// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
#[derive(Debug)]
pub(crate) struct Handle {
    pub(crate) client: aws_smithy_client::Client<
        aws_smithy_client::erase::DynConnector,
        aws_smithy_client::erase::DynMiddleware<aws_smithy_client::erase::DynConnector>,
    >,
    pub(crate) conf: crate::Config,
}

/// Client for AWS Config
///
/// Client for invoking operations on AWS Config. Each operation on AWS Config is a method on this
/// this struct. `.send()` MUST be invoked on the generated operations to dispatch the request to the service.
///
/// # Examples
/// **Constructing a client and invoking an operation**
/// ```rust,no_run
/// # async fn docs() {
///     // create a shared configuration. This can be used & shared between multiple service clients.
///     let shared_config = aws_config::load_from_env().await;
///     let client = aws_sdk_config::Client::new(&shared_config);
///     // invoke an operation
///     /* let rsp = client
///         .<operation_name>().
///         .<param>("some value")
///         .send().await; */
/// # }
/// ```
/// **Constructing a client with custom configuration**
/// ```rust,no_run
/// use aws_config::RetryConfig;
/// # async fn docs() {
///     let shared_config = aws_config::load_from_env().await;
///     let config = aws_sdk_config::config::Builder::from(&shared_config)
///         .retry_config(RetryConfig::disabled())
///         .build();
///     let client = aws_sdk_config::Client::from_conf(config);
/// # }
#[derive(std::fmt::Debug)]
pub struct Client {
    handle: std::sync::Arc<Handle>,
}

impl std::clone::Clone for Client {
    fn clone(&self) -> Self {
        Self {
            handle: self.handle.clone(),
        }
    }
}

#[doc(inline)]
pub use aws_smithy_client::Builder;

impl
    From<
        aws_smithy_client::Client<
            aws_smithy_client::erase::DynConnector,
            aws_smithy_client::erase::DynMiddleware<aws_smithy_client::erase::DynConnector>,
        >,
    > for Client
{
    fn from(
        client: aws_smithy_client::Client<
            aws_smithy_client::erase::DynConnector,
            aws_smithy_client::erase::DynMiddleware<aws_smithy_client::erase::DynConnector>,
        >,
    ) -> Self {
        Self::with_config(client, crate::Config::builder().build())
    }
}

impl Client {
    /// Creates a client with the given service configuration.
    pub fn with_config(
        client: aws_smithy_client::Client<
            aws_smithy_client::erase::DynConnector,
            aws_smithy_client::erase::DynMiddleware<aws_smithy_client::erase::DynConnector>,
        >,
        conf: crate::Config,
    ) -> Self {
        Self {
            handle: std::sync::Arc::new(Handle { client, conf }),
        }
    }

    /// Returns the client's configuration.
    pub fn conf(&self) -> &crate::Config {
        &self.handle.conf
    }
}
impl Client {
    /// Constructs a fluent builder for the [`BatchGetAggregateResourceConfig`](crate::client::fluent_builders::BatchGetAggregateResourceConfig) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`configuration_aggregator_name(impl Into<String>)`](crate::client::fluent_builders::BatchGetAggregateResourceConfig::configuration_aggregator_name) / [`set_configuration_aggregator_name(Option<String>)`](crate::client::fluent_builders::BatchGetAggregateResourceConfig::set_configuration_aggregator_name): <p>The name of the configuration aggregator.</p>
    ///   - [`resource_identifiers(Vec<AggregateResourceIdentifier>)`](crate::client::fluent_builders::BatchGetAggregateResourceConfig::resource_identifiers) / [`set_resource_identifiers(Option<Vec<AggregateResourceIdentifier>>)`](crate::client::fluent_builders::BatchGetAggregateResourceConfig::set_resource_identifiers): <p>A list of aggregate ResourceIdentifiers objects. </p>
    /// - On success, responds with [`BatchGetAggregateResourceConfigOutput`](crate::output::BatchGetAggregateResourceConfigOutput) with field(s):
    ///   - [`base_configuration_items(Option<Vec<BaseConfigurationItem>>)`](crate::output::BatchGetAggregateResourceConfigOutput::base_configuration_items): <p>A list that contains the current configuration of one or more resources.</p>
    ///   - [`unprocessed_resource_identifiers(Option<Vec<AggregateResourceIdentifier>>)`](crate::output::BatchGetAggregateResourceConfigOutput::unprocessed_resource_identifiers): <p>A list of resource identifiers that were not processed with current scope. The list is empty if all the resources are processed.</p>
    /// - On failure, responds with [`SdkError<BatchGetAggregateResourceConfigError>`](crate::error::BatchGetAggregateResourceConfigError)
    pub fn batch_get_aggregate_resource_config(
        &self,
    ) -> fluent_builders::BatchGetAggregateResourceConfig {
        fluent_builders::BatchGetAggregateResourceConfig::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`BatchGetResourceConfig`](crate::client::fluent_builders::BatchGetResourceConfig) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`resource_keys(Vec<ResourceKey>)`](crate::client::fluent_builders::BatchGetResourceConfig::resource_keys) / [`set_resource_keys(Option<Vec<ResourceKey>>)`](crate::client::fluent_builders::BatchGetResourceConfig::set_resource_keys): <p>A list of resource keys to be processed with the current request. Each element in the list consists of the resource type and resource ID.</p>
    /// - On success, responds with [`BatchGetResourceConfigOutput`](crate::output::BatchGetResourceConfigOutput) with field(s):
    ///   - [`base_configuration_items(Option<Vec<BaseConfigurationItem>>)`](crate::output::BatchGetResourceConfigOutput::base_configuration_items): <p>A list that contains the current configuration of one or more resources.</p>
    ///   - [`unprocessed_resource_keys(Option<Vec<ResourceKey>>)`](crate::output::BatchGetResourceConfigOutput::unprocessed_resource_keys): <p>A list of resource keys that were not processed with the current response. The unprocessesResourceKeys value is in the same form as ResourceKeys, so the value can be directly provided to a subsequent BatchGetResourceConfig operation. If there are no unprocessed resource keys, the response contains an empty unprocessedResourceKeys list. </p>
    /// - On failure, responds with [`SdkError<BatchGetResourceConfigError>`](crate::error::BatchGetResourceConfigError)
    pub fn batch_get_resource_config(&self) -> fluent_builders::BatchGetResourceConfig {
        fluent_builders::BatchGetResourceConfig::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DeleteAggregationAuthorization`](crate::client::fluent_builders::DeleteAggregationAuthorization) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`authorized_account_id(impl Into<String>)`](crate::client::fluent_builders::DeleteAggregationAuthorization::authorized_account_id) / [`set_authorized_account_id(Option<String>)`](crate::client::fluent_builders::DeleteAggregationAuthorization::set_authorized_account_id): <p>The 12-digit account ID of the account authorized to aggregate data.</p>
    ///   - [`authorized_aws_region(impl Into<String>)`](crate::client::fluent_builders::DeleteAggregationAuthorization::authorized_aws_region) / [`set_authorized_aws_region(Option<String>)`](crate::client::fluent_builders::DeleteAggregationAuthorization::set_authorized_aws_region): <p>The region authorized to collect aggregated data.</p>
    /// - On success, responds with [`DeleteAggregationAuthorizationOutput`](crate::output::DeleteAggregationAuthorizationOutput)

    /// - On failure, responds with [`SdkError<DeleteAggregationAuthorizationError>`](crate::error::DeleteAggregationAuthorizationError)
    pub fn delete_aggregation_authorization(
        &self,
    ) -> fluent_builders::DeleteAggregationAuthorization {
        fluent_builders::DeleteAggregationAuthorization::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DeleteConfigRule`](crate::client::fluent_builders::DeleteConfigRule) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`config_rule_name(impl Into<String>)`](crate::client::fluent_builders::DeleteConfigRule::config_rule_name) / [`set_config_rule_name(Option<String>)`](crate::client::fluent_builders::DeleteConfigRule::set_config_rule_name): <p>The name of the Config rule that you want to delete.</p>
    /// - On success, responds with [`DeleteConfigRuleOutput`](crate::output::DeleteConfigRuleOutput)

    /// - On failure, responds with [`SdkError<DeleteConfigRuleError>`](crate::error::DeleteConfigRuleError)
    pub fn delete_config_rule(&self) -> fluent_builders::DeleteConfigRule {
        fluent_builders::DeleteConfigRule::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DeleteConfigurationAggregator`](crate::client::fluent_builders::DeleteConfigurationAggregator) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`configuration_aggregator_name(impl Into<String>)`](crate::client::fluent_builders::DeleteConfigurationAggregator::configuration_aggregator_name) / [`set_configuration_aggregator_name(Option<String>)`](crate::client::fluent_builders::DeleteConfigurationAggregator::set_configuration_aggregator_name): <p>The name of the configuration aggregator.</p>
    /// - On success, responds with [`DeleteConfigurationAggregatorOutput`](crate::output::DeleteConfigurationAggregatorOutput)

    /// - On failure, responds with [`SdkError<DeleteConfigurationAggregatorError>`](crate::error::DeleteConfigurationAggregatorError)
    pub fn delete_configuration_aggregator(
        &self,
    ) -> fluent_builders::DeleteConfigurationAggregator {
        fluent_builders::DeleteConfigurationAggregator::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DeleteConfigurationRecorder`](crate::client::fluent_builders::DeleteConfigurationRecorder) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`configuration_recorder_name(impl Into<String>)`](crate::client::fluent_builders::DeleteConfigurationRecorder::configuration_recorder_name) / [`set_configuration_recorder_name(Option<String>)`](crate::client::fluent_builders::DeleteConfigurationRecorder::set_configuration_recorder_name): <p>The name of the configuration recorder to be deleted. You can retrieve the name of your configuration recorder by using the <code>DescribeConfigurationRecorders</code> action.</p>
    /// - On success, responds with [`DeleteConfigurationRecorderOutput`](crate::output::DeleteConfigurationRecorderOutput)

    /// - On failure, responds with [`SdkError<DeleteConfigurationRecorderError>`](crate::error::DeleteConfigurationRecorderError)
    pub fn delete_configuration_recorder(&self) -> fluent_builders::DeleteConfigurationRecorder {
        fluent_builders::DeleteConfigurationRecorder::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DeleteConformancePack`](crate::client::fluent_builders::DeleteConformancePack) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`conformance_pack_name(impl Into<String>)`](crate::client::fluent_builders::DeleteConformancePack::conformance_pack_name) / [`set_conformance_pack_name(Option<String>)`](crate::client::fluent_builders::DeleteConformancePack::set_conformance_pack_name): <p>Name of the conformance pack you want to delete.</p>
    /// - On success, responds with [`DeleteConformancePackOutput`](crate::output::DeleteConformancePackOutput)

    /// - On failure, responds with [`SdkError<DeleteConformancePackError>`](crate::error::DeleteConformancePackError)
    pub fn delete_conformance_pack(&self) -> fluent_builders::DeleteConformancePack {
        fluent_builders::DeleteConformancePack::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DeleteDeliveryChannel`](crate::client::fluent_builders::DeleteDeliveryChannel) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`delivery_channel_name(impl Into<String>)`](crate::client::fluent_builders::DeleteDeliveryChannel::delivery_channel_name) / [`set_delivery_channel_name(Option<String>)`](crate::client::fluent_builders::DeleteDeliveryChannel::set_delivery_channel_name): <p>The name of the delivery channel to delete.</p>
    /// - On success, responds with [`DeleteDeliveryChannelOutput`](crate::output::DeleteDeliveryChannelOutput)

    /// - On failure, responds with [`SdkError<DeleteDeliveryChannelError>`](crate::error::DeleteDeliveryChannelError)
    pub fn delete_delivery_channel(&self) -> fluent_builders::DeleteDeliveryChannel {
        fluent_builders::DeleteDeliveryChannel::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DeleteEvaluationResults`](crate::client::fluent_builders::DeleteEvaluationResults) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`config_rule_name(impl Into<String>)`](crate::client::fluent_builders::DeleteEvaluationResults::config_rule_name) / [`set_config_rule_name(Option<String>)`](crate::client::fluent_builders::DeleteEvaluationResults::set_config_rule_name): <p>The name of the Config rule for which you want to delete the evaluation results.</p>
    /// - On success, responds with [`DeleteEvaluationResultsOutput`](crate::output::DeleteEvaluationResultsOutput)

    /// - On failure, responds with [`SdkError<DeleteEvaluationResultsError>`](crate::error::DeleteEvaluationResultsError)
    pub fn delete_evaluation_results(&self) -> fluent_builders::DeleteEvaluationResults {
        fluent_builders::DeleteEvaluationResults::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DeleteOrganizationConfigRule`](crate::client::fluent_builders::DeleteOrganizationConfigRule) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`organization_config_rule_name(impl Into<String>)`](crate::client::fluent_builders::DeleteOrganizationConfigRule::organization_config_rule_name) / [`set_organization_config_rule_name(Option<String>)`](crate::client::fluent_builders::DeleteOrganizationConfigRule::set_organization_config_rule_name): <p>The name of organization config rule that you want to delete.</p>
    /// - On success, responds with [`DeleteOrganizationConfigRuleOutput`](crate::output::DeleteOrganizationConfigRuleOutput)

    /// - On failure, responds with [`SdkError<DeleteOrganizationConfigRuleError>`](crate::error::DeleteOrganizationConfigRuleError)
    pub fn delete_organization_config_rule(&self) -> fluent_builders::DeleteOrganizationConfigRule {
        fluent_builders::DeleteOrganizationConfigRule::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DeleteOrganizationConformancePack`](crate::client::fluent_builders::DeleteOrganizationConformancePack) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`organization_conformance_pack_name(impl Into<String>)`](crate::client::fluent_builders::DeleteOrganizationConformancePack::organization_conformance_pack_name) / [`set_organization_conformance_pack_name(Option<String>)`](crate::client::fluent_builders::DeleteOrganizationConformancePack::set_organization_conformance_pack_name): <p>The name of organization conformance pack that you want to delete.</p>
    /// - On success, responds with [`DeleteOrganizationConformancePackOutput`](crate::output::DeleteOrganizationConformancePackOutput)

    /// - On failure, responds with [`SdkError<DeleteOrganizationConformancePackError>`](crate::error::DeleteOrganizationConformancePackError)
    pub fn delete_organization_conformance_pack(
        &self,
    ) -> fluent_builders::DeleteOrganizationConformancePack {
        fluent_builders::DeleteOrganizationConformancePack::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DeletePendingAggregationRequest`](crate::client::fluent_builders::DeletePendingAggregationRequest) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`requester_account_id(impl Into<String>)`](crate::client::fluent_builders::DeletePendingAggregationRequest::requester_account_id) / [`set_requester_account_id(Option<String>)`](crate::client::fluent_builders::DeletePendingAggregationRequest::set_requester_account_id): <p>The 12-digit account ID of the account requesting to aggregate data.</p>
    ///   - [`requester_aws_region(impl Into<String>)`](crate::client::fluent_builders::DeletePendingAggregationRequest::requester_aws_region) / [`set_requester_aws_region(Option<String>)`](crate::client::fluent_builders::DeletePendingAggregationRequest::set_requester_aws_region): <p>The region requesting to aggregate data.</p>
    /// - On success, responds with [`DeletePendingAggregationRequestOutput`](crate::output::DeletePendingAggregationRequestOutput)

    /// - On failure, responds with [`SdkError<DeletePendingAggregationRequestError>`](crate::error::DeletePendingAggregationRequestError)
    pub fn delete_pending_aggregation_request(
        &self,
    ) -> fluent_builders::DeletePendingAggregationRequest {
        fluent_builders::DeletePendingAggregationRequest::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DeleteRemediationConfiguration`](crate::client::fluent_builders::DeleteRemediationConfiguration) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`config_rule_name(impl Into<String>)`](crate::client::fluent_builders::DeleteRemediationConfiguration::config_rule_name) / [`set_config_rule_name(Option<String>)`](crate::client::fluent_builders::DeleteRemediationConfiguration::set_config_rule_name): <p>The name of the Config rule for which you want to delete remediation configuration.</p>
    ///   - [`resource_type(impl Into<String>)`](crate::client::fluent_builders::DeleteRemediationConfiguration::resource_type) / [`set_resource_type(Option<String>)`](crate::client::fluent_builders::DeleteRemediationConfiguration::set_resource_type): <p>The type of a resource.</p>
    /// - On success, responds with [`DeleteRemediationConfigurationOutput`](crate::output::DeleteRemediationConfigurationOutput)

    /// - On failure, responds with [`SdkError<DeleteRemediationConfigurationError>`](crate::error::DeleteRemediationConfigurationError)
    pub fn delete_remediation_configuration(
        &self,
    ) -> fluent_builders::DeleteRemediationConfiguration {
        fluent_builders::DeleteRemediationConfiguration::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DeleteRemediationExceptions`](crate::client::fluent_builders::DeleteRemediationExceptions) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`config_rule_name(impl Into<String>)`](crate::client::fluent_builders::DeleteRemediationExceptions::config_rule_name) / [`set_config_rule_name(Option<String>)`](crate::client::fluent_builders::DeleteRemediationExceptions::set_config_rule_name): <p>The name of the Config rule for which you want to delete remediation exception configuration.</p>
    ///   - [`resource_keys(Vec<RemediationExceptionResourceKey>)`](crate::client::fluent_builders::DeleteRemediationExceptions::resource_keys) / [`set_resource_keys(Option<Vec<RemediationExceptionResourceKey>>)`](crate::client::fluent_builders::DeleteRemediationExceptions::set_resource_keys): <p>An exception list of resource exception keys to be processed with the current request. Config adds exception for each resource key. For example, Config adds 3 exceptions for 3 resource keys. </p>
    /// - On success, responds with [`DeleteRemediationExceptionsOutput`](crate::output::DeleteRemediationExceptionsOutput) with field(s):
    ///   - [`failed_batches(Option<Vec<FailedDeleteRemediationExceptionsBatch>>)`](crate::output::DeleteRemediationExceptionsOutput::failed_batches): <p>Returns a list of failed delete remediation exceptions batch objects. Each object in the batch consists of a list of failed items and failure messages.</p>
    /// - On failure, responds with [`SdkError<DeleteRemediationExceptionsError>`](crate::error::DeleteRemediationExceptionsError)
    pub fn delete_remediation_exceptions(&self) -> fluent_builders::DeleteRemediationExceptions {
        fluent_builders::DeleteRemediationExceptions::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DeleteResourceConfig`](crate::client::fluent_builders::DeleteResourceConfig) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`resource_type(impl Into<String>)`](crate::client::fluent_builders::DeleteResourceConfig::resource_type) / [`set_resource_type(Option<String>)`](crate::client::fluent_builders::DeleteResourceConfig::set_resource_type): <p>The type of the resource.</p>
    ///   - [`resource_id(impl Into<String>)`](crate::client::fluent_builders::DeleteResourceConfig::resource_id) / [`set_resource_id(Option<String>)`](crate::client::fluent_builders::DeleteResourceConfig::set_resource_id): <p>Unique identifier of the resource.</p>
    /// - On success, responds with [`DeleteResourceConfigOutput`](crate::output::DeleteResourceConfigOutput)

    /// - On failure, responds with [`SdkError<DeleteResourceConfigError>`](crate::error::DeleteResourceConfigError)
    pub fn delete_resource_config(&self) -> fluent_builders::DeleteResourceConfig {
        fluent_builders::DeleteResourceConfig::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DeleteRetentionConfiguration`](crate::client::fluent_builders::DeleteRetentionConfiguration) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`retention_configuration_name(impl Into<String>)`](crate::client::fluent_builders::DeleteRetentionConfiguration::retention_configuration_name) / [`set_retention_configuration_name(Option<String>)`](crate::client::fluent_builders::DeleteRetentionConfiguration::set_retention_configuration_name): <p>The name of the retention configuration to delete.</p>
    /// - On success, responds with [`DeleteRetentionConfigurationOutput`](crate::output::DeleteRetentionConfigurationOutput)

    /// - On failure, responds with [`SdkError<DeleteRetentionConfigurationError>`](crate::error::DeleteRetentionConfigurationError)
    pub fn delete_retention_configuration(&self) -> fluent_builders::DeleteRetentionConfiguration {
        fluent_builders::DeleteRetentionConfiguration::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DeleteStoredQuery`](crate::client::fluent_builders::DeleteStoredQuery) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`query_name(impl Into<String>)`](crate::client::fluent_builders::DeleteStoredQuery::query_name) / [`set_query_name(Option<String>)`](crate::client::fluent_builders::DeleteStoredQuery::set_query_name): <p>The name of the query that you want to delete.</p>
    /// - On success, responds with [`DeleteStoredQueryOutput`](crate::output::DeleteStoredQueryOutput)

    /// - On failure, responds with [`SdkError<DeleteStoredQueryError>`](crate::error::DeleteStoredQueryError)
    pub fn delete_stored_query(&self) -> fluent_builders::DeleteStoredQuery {
        fluent_builders::DeleteStoredQuery::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DeliverConfigSnapshot`](crate::client::fluent_builders::DeliverConfigSnapshot) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`delivery_channel_name(impl Into<String>)`](crate::client::fluent_builders::DeliverConfigSnapshot::delivery_channel_name) / [`set_delivery_channel_name(Option<String>)`](crate::client::fluent_builders::DeliverConfigSnapshot::set_delivery_channel_name): <p>The name of the delivery channel through which the snapshot is delivered.</p>
    /// - On success, responds with [`DeliverConfigSnapshotOutput`](crate::output::DeliverConfigSnapshotOutput) with field(s):
    ///   - [`config_snapshot_id(Option<String>)`](crate::output::DeliverConfigSnapshotOutput::config_snapshot_id): <p>The ID of the snapshot that is being created.</p>
    /// - On failure, responds with [`SdkError<DeliverConfigSnapshotError>`](crate::error::DeliverConfigSnapshotError)
    pub fn deliver_config_snapshot(&self) -> fluent_builders::DeliverConfigSnapshot {
        fluent_builders::DeliverConfigSnapshot::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DescribeAggregateComplianceByConfigRules`](crate::client::fluent_builders::DescribeAggregateComplianceByConfigRules) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::DescribeAggregateComplianceByConfigRules::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`configuration_aggregator_name(impl Into<String>)`](crate::client::fluent_builders::DescribeAggregateComplianceByConfigRules::configuration_aggregator_name) / [`set_configuration_aggregator_name(Option<String>)`](crate::client::fluent_builders::DescribeAggregateComplianceByConfigRules::set_configuration_aggregator_name): <p>The name of the configuration aggregator.</p>
    ///   - [`filters(ConfigRuleComplianceFilters)`](crate::client::fluent_builders::DescribeAggregateComplianceByConfigRules::filters) / [`set_filters(Option<ConfigRuleComplianceFilters>)`](crate::client::fluent_builders::DescribeAggregateComplianceByConfigRules::set_filters): <p>Filters the results by ConfigRuleComplianceFilters object. </p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::DescribeAggregateComplianceByConfigRules::limit) / [`set_limit(i32)`](crate::client::fluent_builders::DescribeAggregateComplianceByConfigRules::set_limit): <p>The maximum number of evaluation results returned on each page. The default is maximum. If you specify 0, Config uses the default.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::DescribeAggregateComplianceByConfigRules::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::DescribeAggregateComplianceByConfigRules::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On success, responds with [`DescribeAggregateComplianceByConfigRulesOutput`](crate::output::DescribeAggregateComplianceByConfigRulesOutput) with field(s):
    ///   - [`aggregate_compliance_by_config_rules(Option<Vec<AggregateComplianceByConfigRule>>)`](crate::output::DescribeAggregateComplianceByConfigRulesOutput::aggregate_compliance_by_config_rules): <p>Returns a list of AggregateComplianceByConfigRule object.</p>
    ///   - [`next_token(Option<String>)`](crate::output::DescribeAggregateComplianceByConfigRulesOutput::next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<DescribeAggregateComplianceByConfigRulesError>`](crate::error::DescribeAggregateComplianceByConfigRulesError)
    pub fn describe_aggregate_compliance_by_config_rules(
        &self,
    ) -> fluent_builders::DescribeAggregateComplianceByConfigRules {
        fluent_builders::DescribeAggregateComplianceByConfigRules::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DescribeAggregateComplianceByConformancePacks`](crate::client::fluent_builders::DescribeAggregateComplianceByConformancePacks) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::DescribeAggregateComplianceByConformancePacks::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`configuration_aggregator_name(impl Into<String>)`](crate::client::fluent_builders::DescribeAggregateComplianceByConformancePacks::configuration_aggregator_name) / [`set_configuration_aggregator_name(Option<String>)`](crate::client::fluent_builders::DescribeAggregateComplianceByConformancePacks::set_configuration_aggregator_name): <p>The name of the configuration aggregator.</p>
    ///   - [`filters(AggregateConformancePackComplianceFilters)`](crate::client::fluent_builders::DescribeAggregateComplianceByConformancePacks::filters) / [`set_filters(Option<AggregateConformancePackComplianceFilters>)`](crate::client::fluent_builders::DescribeAggregateComplianceByConformancePacks::set_filters): <p>Filters the result by <code>AggregateConformancePackComplianceFilters</code> object.</p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::DescribeAggregateComplianceByConformancePacks::limit) / [`set_limit(i32)`](crate::client::fluent_builders::DescribeAggregateComplianceByConformancePacks::set_limit): <p>The maximum number of conformance packs compliance details returned on each page. The default is maximum. If you specify 0, Config uses the default. </p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::DescribeAggregateComplianceByConformancePacks::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::DescribeAggregateComplianceByConformancePacks::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On success, responds with [`DescribeAggregateComplianceByConformancePacksOutput`](crate::output::DescribeAggregateComplianceByConformancePacksOutput) with field(s):
    ///   - [`aggregate_compliance_by_conformance_packs(Option<Vec<AggregateComplianceByConformancePack>>)`](crate::output::DescribeAggregateComplianceByConformancePacksOutput::aggregate_compliance_by_conformance_packs): <p>Returns the <code>AggregateComplianceByConformancePack</code> object.</p>
    ///   - [`next_token(Option<String>)`](crate::output::DescribeAggregateComplianceByConformancePacksOutput::next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<DescribeAggregateComplianceByConformancePacksError>`](crate::error::DescribeAggregateComplianceByConformancePacksError)
    pub fn describe_aggregate_compliance_by_conformance_packs(
        &self,
    ) -> fluent_builders::DescribeAggregateComplianceByConformancePacks {
        fluent_builders::DescribeAggregateComplianceByConformancePacks::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DescribeAggregationAuthorizations`](crate::client::fluent_builders::DescribeAggregationAuthorizations) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::DescribeAggregationAuthorizations::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`limit(i32)`](crate::client::fluent_builders::DescribeAggregationAuthorizations::limit) / [`set_limit(i32)`](crate::client::fluent_builders::DescribeAggregationAuthorizations::set_limit): <p>The maximum number of AggregationAuthorizations returned on each page. The default is maximum. If you specify 0, Config uses the default.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::DescribeAggregationAuthorizations::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::DescribeAggregationAuthorizations::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On success, responds with [`DescribeAggregationAuthorizationsOutput`](crate::output::DescribeAggregationAuthorizationsOutput) with field(s):
    ///   - [`aggregation_authorizations(Option<Vec<AggregationAuthorization>>)`](crate::output::DescribeAggregationAuthorizationsOutput::aggregation_authorizations): <p>Returns a list of authorizations granted to various aggregator accounts and regions.</p>
    ///   - [`next_token(Option<String>)`](crate::output::DescribeAggregationAuthorizationsOutput::next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<DescribeAggregationAuthorizationsError>`](crate::error::DescribeAggregationAuthorizationsError)
    pub fn describe_aggregation_authorizations(
        &self,
    ) -> fluent_builders::DescribeAggregationAuthorizations {
        fluent_builders::DescribeAggregationAuthorizations::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DescribeComplianceByConfigRule`](crate::client::fluent_builders::DescribeComplianceByConfigRule) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::DescribeComplianceByConfigRule::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`config_rule_names(Vec<String>)`](crate::client::fluent_builders::DescribeComplianceByConfigRule::config_rule_names) / [`set_config_rule_names(Option<Vec<String>>)`](crate::client::fluent_builders::DescribeComplianceByConfigRule::set_config_rule_names): <p>Specify one or more Config rule names to filter the results by rule.</p>
    ///   - [`compliance_types(Vec<ComplianceType>)`](crate::client::fluent_builders::DescribeComplianceByConfigRule::compliance_types) / [`set_compliance_types(Option<Vec<ComplianceType>>)`](crate::client::fluent_builders::DescribeComplianceByConfigRule::set_compliance_types): <p>Filters the results by compliance.</p>  <p>The allowed values are <code>COMPLIANT</code> and <code>NON_COMPLIANT</code>.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::DescribeComplianceByConfigRule::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::DescribeComplianceByConfigRule::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On success, responds with [`DescribeComplianceByConfigRuleOutput`](crate::output::DescribeComplianceByConfigRuleOutput) with field(s):
    ///   - [`compliance_by_config_rules(Option<Vec<ComplianceByConfigRule>>)`](crate::output::DescribeComplianceByConfigRuleOutput::compliance_by_config_rules): <p>Indicates whether each of the specified Config rules is compliant.</p>
    ///   - [`next_token(Option<String>)`](crate::output::DescribeComplianceByConfigRuleOutput::next_token): <p>The string that you use in a subsequent request to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<DescribeComplianceByConfigRuleError>`](crate::error::DescribeComplianceByConfigRuleError)
    pub fn describe_compliance_by_config_rule(
        &self,
    ) -> fluent_builders::DescribeComplianceByConfigRule {
        fluent_builders::DescribeComplianceByConfigRule::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DescribeComplianceByResource`](crate::client::fluent_builders::DescribeComplianceByResource) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::DescribeComplianceByResource::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`resource_type(impl Into<String>)`](crate::client::fluent_builders::DescribeComplianceByResource::resource_type) / [`set_resource_type(Option<String>)`](crate::client::fluent_builders::DescribeComplianceByResource::set_resource_type): <p>The types of Amazon Web Services resources for which you want compliance information (for example, <code>AWS::EC2::Instance</code>). For this action, you can specify that the resource type is an Amazon Web Services account by specifying <code>AWS::::Account</code>.</p>
    ///   - [`resource_id(impl Into<String>)`](crate::client::fluent_builders::DescribeComplianceByResource::resource_id) / [`set_resource_id(Option<String>)`](crate::client::fluent_builders::DescribeComplianceByResource::set_resource_id): <p>The ID of the Amazon Web Services resource for which you want compliance information. You can specify only one resource ID. If you specify a resource ID, you must also specify a type for <code>ResourceType</code>.</p>
    ///   - [`compliance_types(Vec<ComplianceType>)`](crate::client::fluent_builders::DescribeComplianceByResource::compliance_types) / [`set_compliance_types(Option<Vec<ComplianceType>>)`](crate::client::fluent_builders::DescribeComplianceByResource::set_compliance_types): <p>Filters the results by compliance.</p>  <p>The allowed values are <code>COMPLIANT</code>, <code>NON_COMPLIANT</code>, and <code>INSUFFICIENT_DATA</code>.</p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::DescribeComplianceByResource::limit) / [`set_limit(i32)`](crate::client::fluent_builders::DescribeComplianceByResource::set_limit): <p>The maximum number of evaluation results returned on each page. The default is 10. You cannot specify a number greater than 100. If you specify 0, Config uses the default.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::DescribeComplianceByResource::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::DescribeComplianceByResource::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On success, responds with [`DescribeComplianceByResourceOutput`](crate::output::DescribeComplianceByResourceOutput) with field(s):
    ///   - [`compliance_by_resources(Option<Vec<ComplianceByResource>>)`](crate::output::DescribeComplianceByResourceOutput::compliance_by_resources): <p>Indicates whether the specified Amazon Web Services resource complies with all of the Config rules that evaluate it.</p>
    ///   - [`next_token(Option<String>)`](crate::output::DescribeComplianceByResourceOutput::next_token): <p>The string that you use in a subsequent request to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<DescribeComplianceByResourceError>`](crate::error::DescribeComplianceByResourceError)
    pub fn describe_compliance_by_resource(&self) -> fluent_builders::DescribeComplianceByResource {
        fluent_builders::DescribeComplianceByResource::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DescribeConfigRuleEvaluationStatus`](crate::client::fluent_builders::DescribeConfigRuleEvaluationStatus) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::DescribeConfigRuleEvaluationStatus::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`config_rule_names(Vec<String>)`](crate::client::fluent_builders::DescribeConfigRuleEvaluationStatus::config_rule_names) / [`set_config_rule_names(Option<Vec<String>>)`](crate::client::fluent_builders::DescribeConfigRuleEvaluationStatus::set_config_rule_names): <p>The name of the Config managed rules for which you want status information. If you do not specify any names, Config returns status information for all Config managed rules that you use.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::DescribeConfigRuleEvaluationStatus::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::DescribeConfigRuleEvaluationStatus::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::DescribeConfigRuleEvaluationStatus::limit) / [`set_limit(i32)`](crate::client::fluent_builders::DescribeConfigRuleEvaluationStatus::set_limit): <p>The number of rule evaluation results that you want returned.</p>  <p>This parameter is required if the rule limit for your account is more than the default of 150 rules.</p>  <p>For information about requesting a rule limit increase, see <a href="http://docs.aws.amazon.com/general/latest/gr/aws_service_limits.html#limits_config">Config Limits</a> in the <i>Amazon Web Services General Reference Guide</i>.</p>
    /// - On success, responds with [`DescribeConfigRuleEvaluationStatusOutput`](crate::output::DescribeConfigRuleEvaluationStatusOutput) with field(s):
    ///   - [`config_rules_evaluation_status(Option<Vec<ConfigRuleEvaluationStatus>>)`](crate::output::DescribeConfigRuleEvaluationStatusOutput::config_rules_evaluation_status): <p>Status information about your Config managed rules.</p>
    ///   - [`next_token(Option<String>)`](crate::output::DescribeConfigRuleEvaluationStatusOutput::next_token): <p>The string that you use in a subsequent request to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<DescribeConfigRuleEvaluationStatusError>`](crate::error::DescribeConfigRuleEvaluationStatusError)
    pub fn describe_config_rule_evaluation_status(
        &self,
    ) -> fluent_builders::DescribeConfigRuleEvaluationStatus {
        fluent_builders::DescribeConfigRuleEvaluationStatus::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DescribeConfigRules`](crate::client::fluent_builders::DescribeConfigRules) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::DescribeConfigRules::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`config_rule_names(Vec<String>)`](crate::client::fluent_builders::DescribeConfigRules::config_rule_names) / [`set_config_rule_names(Option<Vec<String>>)`](crate::client::fluent_builders::DescribeConfigRules::set_config_rule_names): <p>The names of the Config rules for which you want details. If you do not specify any names, Config returns details for all your rules.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::DescribeConfigRules::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::DescribeConfigRules::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On success, responds with [`DescribeConfigRulesOutput`](crate::output::DescribeConfigRulesOutput) with field(s):
    ///   - [`config_rules(Option<Vec<ConfigRule>>)`](crate::output::DescribeConfigRulesOutput::config_rules): <p>The details about your Config rules.</p>
    ///   - [`next_token(Option<String>)`](crate::output::DescribeConfigRulesOutput::next_token): <p>The string that you use in a subsequent request to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<DescribeConfigRulesError>`](crate::error::DescribeConfigRulesError)
    pub fn describe_config_rules(&self) -> fluent_builders::DescribeConfigRules {
        fluent_builders::DescribeConfigRules::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DescribeConfigurationAggregators`](crate::client::fluent_builders::DescribeConfigurationAggregators) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::DescribeConfigurationAggregators::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`configuration_aggregator_names(Vec<String>)`](crate::client::fluent_builders::DescribeConfigurationAggregators::configuration_aggregator_names) / [`set_configuration_aggregator_names(Option<Vec<String>>)`](crate::client::fluent_builders::DescribeConfigurationAggregators::set_configuration_aggregator_names): <p>The name of the configuration aggregators.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::DescribeConfigurationAggregators::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::DescribeConfigurationAggregators::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::DescribeConfigurationAggregators::limit) / [`set_limit(i32)`](crate::client::fluent_builders::DescribeConfigurationAggregators::set_limit): <p>The maximum number of configuration aggregators returned on each page. The default is maximum. If you specify 0, Config uses the default.</p>
    /// - On success, responds with [`DescribeConfigurationAggregatorsOutput`](crate::output::DescribeConfigurationAggregatorsOutput) with field(s):
    ///   - [`configuration_aggregators(Option<Vec<ConfigurationAggregator>>)`](crate::output::DescribeConfigurationAggregatorsOutput::configuration_aggregators): <p>Returns a ConfigurationAggregators object.</p>
    ///   - [`next_token(Option<String>)`](crate::output::DescribeConfigurationAggregatorsOutput::next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<DescribeConfigurationAggregatorsError>`](crate::error::DescribeConfigurationAggregatorsError)
    pub fn describe_configuration_aggregators(
        &self,
    ) -> fluent_builders::DescribeConfigurationAggregators {
        fluent_builders::DescribeConfigurationAggregators::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DescribeConfigurationAggregatorSourcesStatus`](crate::client::fluent_builders::DescribeConfigurationAggregatorSourcesStatus) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::DescribeConfigurationAggregatorSourcesStatus::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`configuration_aggregator_name(impl Into<String>)`](crate::client::fluent_builders::DescribeConfigurationAggregatorSourcesStatus::configuration_aggregator_name) / [`set_configuration_aggregator_name(Option<String>)`](crate::client::fluent_builders::DescribeConfigurationAggregatorSourcesStatus::set_configuration_aggregator_name): <p>The name of the configuration aggregator.</p>
    ///   - [`update_status(Vec<AggregatedSourceStatusType>)`](crate::client::fluent_builders::DescribeConfigurationAggregatorSourcesStatus::update_status) / [`set_update_status(Option<Vec<AggregatedSourceStatusType>>)`](crate::client::fluent_builders::DescribeConfigurationAggregatorSourcesStatus::set_update_status): <p>Filters the status type.</p>  <ul>   <li> <p>Valid value FAILED indicates errors while moving data.</p> </li>   <li> <p>Valid value SUCCEEDED indicates the data was successfully moved.</p> </li>   <li> <p>Valid value OUTDATED indicates the data is not the most recent.</p> </li>  </ul>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::DescribeConfigurationAggregatorSourcesStatus::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::DescribeConfigurationAggregatorSourcesStatus::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::DescribeConfigurationAggregatorSourcesStatus::limit) / [`set_limit(i32)`](crate::client::fluent_builders::DescribeConfigurationAggregatorSourcesStatus::set_limit): <p>The maximum number of AggregatorSourceStatus returned on each page. The default is maximum. If you specify 0, Config uses the default.</p>
    /// - On success, responds with [`DescribeConfigurationAggregatorSourcesStatusOutput`](crate::output::DescribeConfigurationAggregatorSourcesStatusOutput) with field(s):
    ///   - [`aggregated_source_status_list(Option<Vec<AggregatedSourceStatus>>)`](crate::output::DescribeConfigurationAggregatorSourcesStatusOutput::aggregated_source_status_list): <p>Returns an AggregatedSourceStatus object. </p>
    ///   - [`next_token(Option<String>)`](crate::output::DescribeConfigurationAggregatorSourcesStatusOutput::next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<DescribeConfigurationAggregatorSourcesStatusError>`](crate::error::DescribeConfigurationAggregatorSourcesStatusError)
    pub fn describe_configuration_aggregator_sources_status(
        &self,
    ) -> fluent_builders::DescribeConfigurationAggregatorSourcesStatus {
        fluent_builders::DescribeConfigurationAggregatorSourcesStatus::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DescribeConfigurationRecorders`](crate::client::fluent_builders::DescribeConfigurationRecorders) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`configuration_recorder_names(Vec<String>)`](crate::client::fluent_builders::DescribeConfigurationRecorders::configuration_recorder_names) / [`set_configuration_recorder_names(Option<Vec<String>>)`](crate::client::fluent_builders::DescribeConfigurationRecorders::set_configuration_recorder_names): <p>A list of configuration recorder names.</p>
    /// - On success, responds with [`DescribeConfigurationRecordersOutput`](crate::output::DescribeConfigurationRecordersOutput) with field(s):
    ///   - [`configuration_recorders(Option<Vec<ConfigurationRecorder>>)`](crate::output::DescribeConfigurationRecordersOutput::configuration_recorders): <p>A list that contains the descriptions of the specified configuration recorders.</p>
    /// - On failure, responds with [`SdkError<DescribeConfigurationRecordersError>`](crate::error::DescribeConfigurationRecordersError)
    pub fn describe_configuration_recorders(
        &self,
    ) -> fluent_builders::DescribeConfigurationRecorders {
        fluent_builders::DescribeConfigurationRecorders::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DescribeConfigurationRecorderStatus`](crate::client::fluent_builders::DescribeConfigurationRecorderStatus) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`configuration_recorder_names(Vec<String>)`](crate::client::fluent_builders::DescribeConfigurationRecorderStatus::configuration_recorder_names) / [`set_configuration_recorder_names(Option<Vec<String>>)`](crate::client::fluent_builders::DescribeConfigurationRecorderStatus::set_configuration_recorder_names): <p>The name(s) of the configuration recorder. If the name is not specified, the action returns the current status of all the configuration recorders associated with the account.</p>
    /// - On success, responds with [`DescribeConfigurationRecorderStatusOutput`](crate::output::DescribeConfigurationRecorderStatusOutput) with field(s):
    ///   - [`configuration_recorders_status(Option<Vec<ConfigurationRecorderStatus>>)`](crate::output::DescribeConfigurationRecorderStatusOutput::configuration_recorders_status): <p>A list that contains status of the specified recorders.</p>
    /// - On failure, responds with [`SdkError<DescribeConfigurationRecorderStatusError>`](crate::error::DescribeConfigurationRecorderStatusError)
    pub fn describe_configuration_recorder_status(
        &self,
    ) -> fluent_builders::DescribeConfigurationRecorderStatus {
        fluent_builders::DescribeConfigurationRecorderStatus::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DescribeConformancePackCompliance`](crate::client::fluent_builders::DescribeConformancePackCompliance) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::DescribeConformancePackCompliance::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`conformance_pack_name(impl Into<String>)`](crate::client::fluent_builders::DescribeConformancePackCompliance::conformance_pack_name) / [`set_conformance_pack_name(Option<String>)`](crate::client::fluent_builders::DescribeConformancePackCompliance::set_conformance_pack_name): <p>Name of the conformance pack.</p>
    ///   - [`filters(ConformancePackComplianceFilters)`](crate::client::fluent_builders::DescribeConformancePackCompliance::filters) / [`set_filters(Option<ConformancePackComplianceFilters>)`](crate::client::fluent_builders::DescribeConformancePackCompliance::set_filters): <p>A <code>ConformancePackComplianceFilters</code> object.</p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::DescribeConformancePackCompliance::limit) / [`set_limit(i32)`](crate::client::fluent_builders::DescribeConformancePackCompliance::set_limit): <p>The maximum number of Config rules within a conformance pack are returned on each page.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::DescribeConformancePackCompliance::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::DescribeConformancePackCompliance::set_next_token): <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
    /// - On success, responds with [`DescribeConformancePackComplianceOutput`](crate::output::DescribeConformancePackComplianceOutput) with field(s):
    ///   - [`conformance_pack_name(Option<String>)`](crate::output::DescribeConformancePackComplianceOutput::conformance_pack_name): <p>Name of the conformance pack.</p>
    ///   - [`conformance_pack_rule_compliance_list(Option<Vec<ConformancePackRuleCompliance>>)`](crate::output::DescribeConformancePackComplianceOutput::conformance_pack_rule_compliance_list): <p>Returns a list of <code>ConformancePackRuleCompliance</code> objects.</p>
    ///   - [`next_token(Option<String>)`](crate::output::DescribeConformancePackComplianceOutput::next_token): <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<DescribeConformancePackComplianceError>`](crate::error::DescribeConformancePackComplianceError)
    pub fn describe_conformance_pack_compliance(
        &self,
    ) -> fluent_builders::DescribeConformancePackCompliance {
        fluent_builders::DescribeConformancePackCompliance::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DescribeConformancePacks`](crate::client::fluent_builders::DescribeConformancePacks) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::DescribeConformancePacks::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`conformance_pack_names(Vec<String>)`](crate::client::fluent_builders::DescribeConformancePacks::conformance_pack_names) / [`set_conformance_pack_names(Option<Vec<String>>)`](crate::client::fluent_builders::DescribeConformancePacks::set_conformance_pack_names): <p>Comma-separated list of conformance pack names for which you want details. If you do not specify any names, Config returns details for all your conformance packs. </p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::DescribeConformancePacks::limit) / [`set_limit(i32)`](crate::client::fluent_builders::DescribeConformancePacks::set_limit): <p>The maximum number of conformance packs returned on each page.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::DescribeConformancePacks::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::DescribeConformancePacks::set_next_token): <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
    /// - On success, responds with [`DescribeConformancePacksOutput`](crate::output::DescribeConformancePacksOutput) with field(s):
    ///   - [`conformance_pack_details(Option<Vec<ConformancePackDetail>>)`](crate::output::DescribeConformancePacksOutput::conformance_pack_details): <p>Returns a list of <code>ConformancePackDetail</code> objects.</p>
    ///   - [`next_token(Option<String>)`](crate::output::DescribeConformancePacksOutput::next_token): <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<DescribeConformancePacksError>`](crate::error::DescribeConformancePacksError)
    pub fn describe_conformance_packs(&self) -> fluent_builders::DescribeConformancePacks {
        fluent_builders::DescribeConformancePacks::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DescribeConformancePackStatus`](crate::client::fluent_builders::DescribeConformancePackStatus) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::DescribeConformancePackStatus::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`conformance_pack_names(Vec<String>)`](crate::client::fluent_builders::DescribeConformancePackStatus::conformance_pack_names) / [`set_conformance_pack_names(Option<Vec<String>>)`](crate::client::fluent_builders::DescribeConformancePackStatus::set_conformance_pack_names): <p>Comma-separated list of conformance pack names.</p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::DescribeConformancePackStatus::limit) / [`set_limit(i32)`](crate::client::fluent_builders::DescribeConformancePackStatus::set_limit): <p>The maximum number of conformance packs status returned on each page.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::DescribeConformancePackStatus::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::DescribeConformancePackStatus::set_next_token): <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
    /// - On success, responds with [`DescribeConformancePackStatusOutput`](crate::output::DescribeConformancePackStatusOutput) with field(s):
    ///   - [`conformance_pack_status_details(Option<Vec<ConformancePackStatusDetail>>)`](crate::output::DescribeConformancePackStatusOutput::conformance_pack_status_details): <p>A list of <code>ConformancePackStatusDetail</code> objects.</p>
    ///   - [`next_token(Option<String>)`](crate::output::DescribeConformancePackStatusOutput::next_token): <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<DescribeConformancePackStatusError>`](crate::error::DescribeConformancePackStatusError)
    pub fn describe_conformance_pack_status(
        &self,
    ) -> fluent_builders::DescribeConformancePackStatus {
        fluent_builders::DescribeConformancePackStatus::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DescribeDeliveryChannels`](crate::client::fluent_builders::DescribeDeliveryChannels) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`delivery_channel_names(Vec<String>)`](crate::client::fluent_builders::DescribeDeliveryChannels::delivery_channel_names) / [`set_delivery_channel_names(Option<Vec<String>>)`](crate::client::fluent_builders::DescribeDeliveryChannels::set_delivery_channel_names): <p>A list of delivery channel names.</p>
    /// - On success, responds with [`DescribeDeliveryChannelsOutput`](crate::output::DescribeDeliveryChannelsOutput) with field(s):
    ///   - [`delivery_channels(Option<Vec<DeliveryChannel>>)`](crate::output::DescribeDeliveryChannelsOutput::delivery_channels): <p>A list that contains the descriptions of the specified delivery channel.</p>
    /// - On failure, responds with [`SdkError<DescribeDeliveryChannelsError>`](crate::error::DescribeDeliveryChannelsError)
    pub fn describe_delivery_channels(&self) -> fluent_builders::DescribeDeliveryChannels {
        fluent_builders::DescribeDeliveryChannels::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DescribeDeliveryChannelStatus`](crate::client::fluent_builders::DescribeDeliveryChannelStatus) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`delivery_channel_names(Vec<String>)`](crate::client::fluent_builders::DescribeDeliveryChannelStatus::delivery_channel_names) / [`set_delivery_channel_names(Option<Vec<String>>)`](crate::client::fluent_builders::DescribeDeliveryChannelStatus::set_delivery_channel_names): <p>A list of delivery channel names.</p>
    /// - On success, responds with [`DescribeDeliveryChannelStatusOutput`](crate::output::DescribeDeliveryChannelStatusOutput) with field(s):
    ///   - [`delivery_channels_status(Option<Vec<DeliveryChannelStatus>>)`](crate::output::DescribeDeliveryChannelStatusOutput::delivery_channels_status): <p>A list that contains the status of a specified delivery channel.</p>
    /// - On failure, responds with [`SdkError<DescribeDeliveryChannelStatusError>`](crate::error::DescribeDeliveryChannelStatusError)
    pub fn describe_delivery_channel_status(
        &self,
    ) -> fluent_builders::DescribeDeliveryChannelStatus {
        fluent_builders::DescribeDeliveryChannelStatus::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DescribeOrganizationConfigRules`](crate::client::fluent_builders::DescribeOrganizationConfigRules) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::DescribeOrganizationConfigRules::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`organization_config_rule_names(Vec<String>)`](crate::client::fluent_builders::DescribeOrganizationConfigRules::organization_config_rule_names) / [`set_organization_config_rule_names(Option<Vec<String>>)`](crate::client::fluent_builders::DescribeOrganizationConfigRules::set_organization_config_rule_names): <p>The names of organization config rules for which you want details. If you do not specify any names, Config returns details for all your organization config rules.</p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::DescribeOrganizationConfigRules::limit) / [`set_limit(i32)`](crate::client::fluent_builders::DescribeOrganizationConfigRules::set_limit): <p>The maximum number of organization config rules returned on each page. If you do no specify a number, Config uses the default. The default is 100.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::DescribeOrganizationConfigRules::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::DescribeOrganizationConfigRules::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
    /// - On success, responds with [`DescribeOrganizationConfigRulesOutput`](crate::output::DescribeOrganizationConfigRulesOutput) with field(s):
    ///   - [`organization_config_rules(Option<Vec<OrganizationConfigRule>>)`](crate::output::DescribeOrganizationConfigRulesOutput::organization_config_rules): <p>Returns a list of <code>OrganizationConfigRule</code> objects.</p>
    ///   - [`next_token(Option<String>)`](crate::output::DescribeOrganizationConfigRulesOutput::next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
    /// - On failure, responds with [`SdkError<DescribeOrganizationConfigRulesError>`](crate::error::DescribeOrganizationConfigRulesError)
    pub fn describe_organization_config_rules(
        &self,
    ) -> fluent_builders::DescribeOrganizationConfigRules {
        fluent_builders::DescribeOrganizationConfigRules::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DescribeOrganizationConfigRuleStatuses`](crate::client::fluent_builders::DescribeOrganizationConfigRuleStatuses) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::DescribeOrganizationConfigRuleStatuses::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`organization_config_rule_names(Vec<String>)`](crate::client::fluent_builders::DescribeOrganizationConfigRuleStatuses::organization_config_rule_names) / [`set_organization_config_rule_names(Option<Vec<String>>)`](crate::client::fluent_builders::DescribeOrganizationConfigRuleStatuses::set_organization_config_rule_names): <p>The names of organization config rules for which you want status details. If you do not specify any names, Config returns details for all your organization Config rules.</p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::DescribeOrganizationConfigRuleStatuses::limit) / [`set_limit(i32)`](crate::client::fluent_builders::DescribeOrganizationConfigRuleStatuses::set_limit): <p>The maximum number of <code>OrganizationConfigRuleStatuses</code> returned on each page. If you do no specify a number, Config uses the default. The default is 100.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::DescribeOrganizationConfigRuleStatuses::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::DescribeOrganizationConfigRuleStatuses::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
    /// - On success, responds with [`DescribeOrganizationConfigRuleStatusesOutput`](crate::output::DescribeOrganizationConfigRuleStatusesOutput) with field(s):
    ///   - [`organization_config_rule_statuses(Option<Vec<OrganizationConfigRuleStatus>>)`](crate::output::DescribeOrganizationConfigRuleStatusesOutput::organization_config_rule_statuses): <p>A list of <code>OrganizationConfigRuleStatus</code> objects.</p>
    ///   - [`next_token(Option<String>)`](crate::output::DescribeOrganizationConfigRuleStatusesOutput::next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
    /// - On failure, responds with [`SdkError<DescribeOrganizationConfigRuleStatusesError>`](crate::error::DescribeOrganizationConfigRuleStatusesError)
    pub fn describe_organization_config_rule_statuses(
        &self,
    ) -> fluent_builders::DescribeOrganizationConfigRuleStatuses {
        fluent_builders::DescribeOrganizationConfigRuleStatuses::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DescribeOrganizationConformancePacks`](crate::client::fluent_builders::DescribeOrganizationConformancePacks) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::DescribeOrganizationConformancePacks::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`organization_conformance_pack_names(Vec<String>)`](crate::client::fluent_builders::DescribeOrganizationConformancePacks::organization_conformance_pack_names) / [`set_organization_conformance_pack_names(Option<Vec<String>>)`](crate::client::fluent_builders::DescribeOrganizationConformancePacks::set_organization_conformance_pack_names): <p>The name that you assign to an organization conformance pack.</p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::DescribeOrganizationConformancePacks::limit) / [`set_limit(i32)`](crate::client::fluent_builders::DescribeOrganizationConformancePacks::set_limit): <p>The maximum number of organization config packs returned on each page. If you do no specify a number, Config uses the default. The default is 100.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::DescribeOrganizationConformancePacks::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::DescribeOrganizationConformancePacks::set_next_token): <p>The nextToken string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On success, responds with [`DescribeOrganizationConformancePacksOutput`](crate::output::DescribeOrganizationConformancePacksOutput) with field(s):
    ///   - [`organization_conformance_packs(Option<Vec<OrganizationConformancePack>>)`](crate::output::DescribeOrganizationConformancePacksOutput::organization_conformance_packs): <p>Returns a list of OrganizationConformancePacks objects.</p>
    ///   - [`next_token(Option<String>)`](crate::output::DescribeOrganizationConformancePacksOutput::next_token): <p>The nextToken string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<DescribeOrganizationConformancePacksError>`](crate::error::DescribeOrganizationConformancePacksError)
    pub fn describe_organization_conformance_packs(
        &self,
    ) -> fluent_builders::DescribeOrganizationConformancePacks {
        fluent_builders::DescribeOrganizationConformancePacks::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DescribeOrganizationConformancePackStatuses`](crate::client::fluent_builders::DescribeOrganizationConformancePackStatuses) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::DescribeOrganizationConformancePackStatuses::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`organization_conformance_pack_names(Vec<String>)`](crate::client::fluent_builders::DescribeOrganizationConformancePackStatuses::organization_conformance_pack_names) / [`set_organization_conformance_pack_names(Option<Vec<String>>)`](crate::client::fluent_builders::DescribeOrganizationConformancePackStatuses::set_organization_conformance_pack_names): <p>The names of organization conformance packs for which you want status details. If you do not specify any names, Config returns details for all your organization conformance packs. </p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::DescribeOrganizationConformancePackStatuses::limit) / [`set_limit(i32)`](crate::client::fluent_builders::DescribeOrganizationConformancePackStatuses::set_limit): <p>The maximum number of OrganizationConformancePackStatuses returned on each page. If you do no specify a number, Config uses the default. The default is 100. </p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::DescribeOrganizationConformancePackStatuses::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::DescribeOrganizationConformancePackStatuses::set_next_token): <p>The nextToken string returned on a previous page that you use to get the next page of results in a paginated response. </p>
    /// - On success, responds with [`DescribeOrganizationConformancePackStatusesOutput`](crate::output::DescribeOrganizationConformancePackStatusesOutput) with field(s):
    ///   - [`organization_conformance_pack_statuses(Option<Vec<OrganizationConformancePackStatus>>)`](crate::output::DescribeOrganizationConformancePackStatusesOutput::organization_conformance_pack_statuses): <p>A list of <code>OrganizationConformancePackStatus</code> objects. </p>
    ///   - [`next_token(Option<String>)`](crate::output::DescribeOrganizationConformancePackStatusesOutput::next_token): <p>The nextToken string returned on a previous page that you use to get the next page of results in a paginated response. </p>
    /// - On failure, responds with [`SdkError<DescribeOrganizationConformancePackStatusesError>`](crate::error::DescribeOrganizationConformancePackStatusesError)
    pub fn describe_organization_conformance_pack_statuses(
        &self,
    ) -> fluent_builders::DescribeOrganizationConformancePackStatuses {
        fluent_builders::DescribeOrganizationConformancePackStatuses::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DescribePendingAggregationRequests`](crate::client::fluent_builders::DescribePendingAggregationRequests) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::DescribePendingAggregationRequests::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`limit(i32)`](crate::client::fluent_builders::DescribePendingAggregationRequests::limit) / [`set_limit(i32)`](crate::client::fluent_builders::DescribePendingAggregationRequests::set_limit): <p>The maximum number of evaluation results returned on each page. The default is maximum. If you specify 0, Config uses the default.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::DescribePendingAggregationRequests::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::DescribePendingAggregationRequests::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On success, responds with [`DescribePendingAggregationRequestsOutput`](crate::output::DescribePendingAggregationRequestsOutput) with field(s):
    ///   - [`pending_aggregation_requests(Option<Vec<PendingAggregationRequest>>)`](crate::output::DescribePendingAggregationRequestsOutput::pending_aggregation_requests): <p>Returns a PendingAggregationRequests object.</p>
    ///   - [`next_token(Option<String>)`](crate::output::DescribePendingAggregationRequestsOutput::next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<DescribePendingAggregationRequestsError>`](crate::error::DescribePendingAggregationRequestsError)
    pub fn describe_pending_aggregation_requests(
        &self,
    ) -> fluent_builders::DescribePendingAggregationRequests {
        fluent_builders::DescribePendingAggregationRequests::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DescribeRemediationConfigurations`](crate::client::fluent_builders::DescribeRemediationConfigurations) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`config_rule_names(Vec<String>)`](crate::client::fluent_builders::DescribeRemediationConfigurations::config_rule_names) / [`set_config_rule_names(Option<Vec<String>>)`](crate::client::fluent_builders::DescribeRemediationConfigurations::set_config_rule_names): <p>A list of Config rule names of remediation configurations for which you want details. </p>
    /// - On success, responds with [`DescribeRemediationConfigurationsOutput`](crate::output::DescribeRemediationConfigurationsOutput) with field(s):
    ///   - [`remediation_configurations(Option<Vec<RemediationConfiguration>>)`](crate::output::DescribeRemediationConfigurationsOutput::remediation_configurations): <p>Returns a remediation configuration object.</p>
    /// - On failure, responds with [`SdkError<DescribeRemediationConfigurationsError>`](crate::error::DescribeRemediationConfigurationsError)
    pub fn describe_remediation_configurations(
        &self,
    ) -> fluent_builders::DescribeRemediationConfigurations {
        fluent_builders::DescribeRemediationConfigurations::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DescribeRemediationExceptions`](crate::client::fluent_builders::DescribeRemediationExceptions) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::DescribeRemediationExceptions::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`config_rule_name(impl Into<String>)`](crate::client::fluent_builders::DescribeRemediationExceptions::config_rule_name) / [`set_config_rule_name(Option<String>)`](crate::client::fluent_builders::DescribeRemediationExceptions::set_config_rule_name): <p>The name of the Config rule.</p>
    ///   - [`resource_keys(Vec<RemediationExceptionResourceKey>)`](crate::client::fluent_builders::DescribeRemediationExceptions::resource_keys) / [`set_resource_keys(Option<Vec<RemediationExceptionResourceKey>>)`](crate::client::fluent_builders::DescribeRemediationExceptions::set_resource_keys): <p>An exception list of resource exception keys to be processed with the current request. Config adds exception for each resource key. For example, Config adds 3 exceptions for 3 resource keys. </p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::DescribeRemediationExceptions::limit) / [`set_limit(i32)`](crate::client::fluent_builders::DescribeRemediationExceptions::set_limit): <p>The maximum number of RemediationExceptionResourceKey returned on each page. The default is 25. If you specify 0, Config uses the default.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::DescribeRemediationExceptions::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::DescribeRemediationExceptions::set_next_token): <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
    /// - On success, responds with [`DescribeRemediationExceptionsOutput`](crate::output::DescribeRemediationExceptionsOutput) with field(s):
    ///   - [`remediation_exceptions(Option<Vec<RemediationException>>)`](crate::output::DescribeRemediationExceptionsOutput::remediation_exceptions): <p>Returns a list of remediation exception objects.</p>
    ///   - [`next_token(Option<String>)`](crate::output::DescribeRemediationExceptionsOutput::next_token): <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<DescribeRemediationExceptionsError>`](crate::error::DescribeRemediationExceptionsError)
    pub fn describe_remediation_exceptions(
        &self,
    ) -> fluent_builders::DescribeRemediationExceptions {
        fluent_builders::DescribeRemediationExceptions::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DescribeRemediationExecutionStatus`](crate::client::fluent_builders::DescribeRemediationExecutionStatus) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::DescribeRemediationExecutionStatus::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`config_rule_name(impl Into<String>)`](crate::client::fluent_builders::DescribeRemediationExecutionStatus::config_rule_name) / [`set_config_rule_name(Option<String>)`](crate::client::fluent_builders::DescribeRemediationExecutionStatus::set_config_rule_name): <p>A list of Config rule names.</p>
    ///   - [`resource_keys(Vec<ResourceKey>)`](crate::client::fluent_builders::DescribeRemediationExecutionStatus::resource_keys) / [`set_resource_keys(Option<Vec<ResourceKey>>)`](crate::client::fluent_builders::DescribeRemediationExecutionStatus::set_resource_keys): <p>A list of resource keys to be processed with the current request. Each element in the list consists of the resource type and resource ID. </p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::DescribeRemediationExecutionStatus::limit) / [`set_limit(i32)`](crate::client::fluent_builders::DescribeRemediationExecutionStatus::set_limit): <p>The maximum number of RemediationExecutionStatuses returned on each page. The default is maximum. If you specify 0, Config uses the default. </p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::DescribeRemediationExecutionStatus::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::DescribeRemediationExecutionStatus::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On success, responds with [`DescribeRemediationExecutionStatusOutput`](crate::output::DescribeRemediationExecutionStatusOutput) with field(s):
    ///   - [`remediation_execution_statuses(Option<Vec<RemediationExecutionStatus>>)`](crate::output::DescribeRemediationExecutionStatusOutput::remediation_execution_statuses): <p>Returns a list of remediation execution statuses objects.</p>
    ///   - [`next_token(Option<String>)`](crate::output::DescribeRemediationExecutionStatusOutput::next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<DescribeRemediationExecutionStatusError>`](crate::error::DescribeRemediationExecutionStatusError)
    pub fn describe_remediation_execution_status(
        &self,
    ) -> fluent_builders::DescribeRemediationExecutionStatus {
        fluent_builders::DescribeRemediationExecutionStatus::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`DescribeRetentionConfigurations`](crate::client::fluent_builders::DescribeRetentionConfigurations) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::DescribeRetentionConfigurations::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`retention_configuration_names(Vec<String>)`](crate::client::fluent_builders::DescribeRetentionConfigurations::retention_configuration_names) / [`set_retention_configuration_names(Option<Vec<String>>)`](crate::client::fluent_builders::DescribeRetentionConfigurations::set_retention_configuration_names): <p>A list of names of retention configurations for which you want details. If you do not specify a name, Config returns details for all the retention configurations for that account.</p> <note>   <p>Currently, Config supports only one retention configuration per region in your account.</p>  </note>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::DescribeRetentionConfigurations::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::DescribeRetentionConfigurations::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
    /// - On success, responds with [`DescribeRetentionConfigurationsOutput`](crate::output::DescribeRetentionConfigurationsOutput) with field(s):
    ///   - [`retention_configurations(Option<Vec<RetentionConfiguration>>)`](crate::output::DescribeRetentionConfigurationsOutput::retention_configurations): <p>Returns a retention configuration object.</p>
    ///   - [`next_token(Option<String>)`](crate::output::DescribeRetentionConfigurationsOutput::next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
    /// - On failure, responds with [`SdkError<DescribeRetentionConfigurationsError>`](crate::error::DescribeRetentionConfigurationsError)
    pub fn describe_retention_configurations(
        &self,
    ) -> fluent_builders::DescribeRetentionConfigurations {
        fluent_builders::DescribeRetentionConfigurations::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`GetAggregateComplianceDetailsByConfigRule`](crate::client::fluent_builders::GetAggregateComplianceDetailsByConfigRule) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::GetAggregateComplianceDetailsByConfigRule::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`configuration_aggregator_name(impl Into<String>)`](crate::client::fluent_builders::GetAggregateComplianceDetailsByConfigRule::configuration_aggregator_name) / [`set_configuration_aggregator_name(Option<String>)`](crate::client::fluent_builders::GetAggregateComplianceDetailsByConfigRule::set_configuration_aggregator_name): <p>The name of the configuration aggregator.</p>
    ///   - [`config_rule_name(impl Into<String>)`](crate::client::fluent_builders::GetAggregateComplianceDetailsByConfigRule::config_rule_name) / [`set_config_rule_name(Option<String>)`](crate::client::fluent_builders::GetAggregateComplianceDetailsByConfigRule::set_config_rule_name): <p>The name of the Config rule for which you want compliance information.</p>
    ///   - [`account_id(impl Into<String>)`](crate::client::fluent_builders::GetAggregateComplianceDetailsByConfigRule::account_id) / [`set_account_id(Option<String>)`](crate::client::fluent_builders::GetAggregateComplianceDetailsByConfigRule::set_account_id): <p>The 12-digit account ID of the source account.</p>
    ///   - [`aws_region(impl Into<String>)`](crate::client::fluent_builders::GetAggregateComplianceDetailsByConfigRule::aws_region) / [`set_aws_region(Option<String>)`](crate::client::fluent_builders::GetAggregateComplianceDetailsByConfigRule::set_aws_region): <p>The source region from where the data is aggregated.</p>
    ///   - [`compliance_type(ComplianceType)`](crate::client::fluent_builders::GetAggregateComplianceDetailsByConfigRule::compliance_type) / [`set_compliance_type(Option<ComplianceType>)`](crate::client::fluent_builders::GetAggregateComplianceDetailsByConfigRule::set_compliance_type): <p>The resource compliance status.</p> <note>   <p>For the <code>GetAggregateComplianceDetailsByConfigRuleRequest</code> data type, Config supports only the <code>COMPLIANT</code> and <code>NON_COMPLIANT</code>. Config does not support the <code>NOT_APPLICABLE</code> and <code>INSUFFICIENT_DATA</code> values.</p>  </note>
    ///   - [`limit(i32)`](crate::client::fluent_builders::GetAggregateComplianceDetailsByConfigRule::limit) / [`set_limit(i32)`](crate::client::fluent_builders::GetAggregateComplianceDetailsByConfigRule::set_limit): <p>The maximum number of evaluation results returned on each page. The default is 50. You cannot specify a number greater than 100. If you specify 0, Config uses the default.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::GetAggregateComplianceDetailsByConfigRule::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::GetAggregateComplianceDetailsByConfigRule::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On success, responds with [`GetAggregateComplianceDetailsByConfigRuleOutput`](crate::output::GetAggregateComplianceDetailsByConfigRuleOutput) with field(s):
    ///   - [`aggregate_evaluation_results(Option<Vec<AggregateEvaluationResult>>)`](crate::output::GetAggregateComplianceDetailsByConfigRuleOutput::aggregate_evaluation_results): <p>Returns an AggregateEvaluationResults object.</p>
    ///   - [`next_token(Option<String>)`](crate::output::GetAggregateComplianceDetailsByConfigRuleOutput::next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<GetAggregateComplianceDetailsByConfigRuleError>`](crate::error::GetAggregateComplianceDetailsByConfigRuleError)
    pub fn get_aggregate_compliance_details_by_config_rule(
        &self,
    ) -> fluent_builders::GetAggregateComplianceDetailsByConfigRule {
        fluent_builders::GetAggregateComplianceDetailsByConfigRule::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`GetAggregateConfigRuleComplianceSummary`](crate::client::fluent_builders::GetAggregateConfigRuleComplianceSummary) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::GetAggregateConfigRuleComplianceSummary::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`configuration_aggregator_name(impl Into<String>)`](crate::client::fluent_builders::GetAggregateConfigRuleComplianceSummary::configuration_aggregator_name) / [`set_configuration_aggregator_name(Option<String>)`](crate::client::fluent_builders::GetAggregateConfigRuleComplianceSummary::set_configuration_aggregator_name): <p>The name of the configuration aggregator.</p>
    ///   - [`filters(ConfigRuleComplianceSummaryFilters)`](crate::client::fluent_builders::GetAggregateConfigRuleComplianceSummary::filters) / [`set_filters(Option<ConfigRuleComplianceSummaryFilters>)`](crate::client::fluent_builders::GetAggregateConfigRuleComplianceSummary::set_filters): <p>Filters the results based on the ConfigRuleComplianceSummaryFilters object.</p>
    ///   - [`group_by_key(ConfigRuleComplianceSummaryGroupKey)`](crate::client::fluent_builders::GetAggregateConfigRuleComplianceSummary::group_by_key) / [`set_group_by_key(Option<ConfigRuleComplianceSummaryGroupKey>)`](crate::client::fluent_builders::GetAggregateConfigRuleComplianceSummary::set_group_by_key): <p>Groups the result based on ACCOUNT_ID or AWS_REGION.</p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::GetAggregateConfigRuleComplianceSummary::limit) / [`set_limit(i32)`](crate::client::fluent_builders::GetAggregateConfigRuleComplianceSummary::set_limit): <p>The maximum number of evaluation results returned on each page. The default is 1000. You cannot specify a number greater than 1000. If you specify 0, Config uses the default.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::GetAggregateConfigRuleComplianceSummary::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::GetAggregateConfigRuleComplianceSummary::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On success, responds with [`GetAggregateConfigRuleComplianceSummaryOutput`](crate::output::GetAggregateConfigRuleComplianceSummaryOutput) with field(s):
    ///   - [`group_by_key(Option<String>)`](crate::output::GetAggregateConfigRuleComplianceSummaryOutput::group_by_key): <p>Groups the result based on ACCOUNT_ID or AWS_REGION.</p>
    ///   - [`aggregate_compliance_counts(Option<Vec<AggregateComplianceCount>>)`](crate::output::GetAggregateConfigRuleComplianceSummaryOutput::aggregate_compliance_counts): <p>Returns a list of AggregateComplianceCounts object.</p>
    ///   - [`next_token(Option<String>)`](crate::output::GetAggregateConfigRuleComplianceSummaryOutput::next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<GetAggregateConfigRuleComplianceSummaryError>`](crate::error::GetAggregateConfigRuleComplianceSummaryError)
    pub fn get_aggregate_config_rule_compliance_summary(
        &self,
    ) -> fluent_builders::GetAggregateConfigRuleComplianceSummary {
        fluent_builders::GetAggregateConfigRuleComplianceSummary::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`GetAggregateConformancePackComplianceSummary`](crate::client::fluent_builders::GetAggregateConformancePackComplianceSummary) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::GetAggregateConformancePackComplianceSummary::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`configuration_aggregator_name(impl Into<String>)`](crate::client::fluent_builders::GetAggregateConformancePackComplianceSummary::configuration_aggregator_name) / [`set_configuration_aggregator_name(Option<String>)`](crate::client::fluent_builders::GetAggregateConformancePackComplianceSummary::set_configuration_aggregator_name): <p>The name of the configuration aggregator.</p>
    ///   - [`filters(AggregateConformancePackComplianceSummaryFilters)`](crate::client::fluent_builders::GetAggregateConformancePackComplianceSummary::filters) / [`set_filters(Option<AggregateConformancePackComplianceSummaryFilters>)`](crate::client::fluent_builders::GetAggregateConformancePackComplianceSummary::set_filters): <p>Filters the results based on the <code>AggregateConformancePackComplianceSummaryFilters</code> object.</p>
    ///   - [`group_by_key(AggregateConformancePackComplianceSummaryGroupKey)`](crate::client::fluent_builders::GetAggregateConformancePackComplianceSummary::group_by_key) / [`set_group_by_key(Option<AggregateConformancePackComplianceSummaryGroupKey>)`](crate::client::fluent_builders::GetAggregateConformancePackComplianceSummary::set_group_by_key): <p>Groups the result based on Amazon Web Services account ID or Amazon Web Services Region.</p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::GetAggregateConformancePackComplianceSummary::limit) / [`set_limit(i32)`](crate::client::fluent_builders::GetAggregateConformancePackComplianceSummary::set_limit): <p>The maximum number of results returned on each page. The default is maximum. If you specify 0, Config uses the default.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::GetAggregateConformancePackComplianceSummary::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::GetAggregateConformancePackComplianceSummary::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On success, responds with [`GetAggregateConformancePackComplianceSummaryOutput`](crate::output::GetAggregateConformancePackComplianceSummaryOutput) with field(s):
    ///   - [`aggregate_conformance_pack_compliance_summaries(Option<Vec<AggregateConformancePackComplianceSummary>>)`](crate::output::GetAggregateConformancePackComplianceSummaryOutput::aggregate_conformance_pack_compliance_summaries): <p>Returns a list of <code>AggregateConformancePackComplianceSummary</code> object.</p>
    ///   - [`group_by_key(Option<String>)`](crate::output::GetAggregateConformancePackComplianceSummaryOutput::group_by_key): <p>Groups the result based on Amazon Web Services account ID or Amazon Web Services Region.</p>
    ///   - [`next_token(Option<String>)`](crate::output::GetAggregateConformancePackComplianceSummaryOutput::next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<GetAggregateConformancePackComplianceSummaryError>`](crate::error::GetAggregateConformancePackComplianceSummaryError)
    pub fn get_aggregate_conformance_pack_compliance_summary(
        &self,
    ) -> fluent_builders::GetAggregateConformancePackComplianceSummary {
        fluent_builders::GetAggregateConformancePackComplianceSummary::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`GetAggregateDiscoveredResourceCounts`](crate::client::fluent_builders::GetAggregateDiscoveredResourceCounts) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::GetAggregateDiscoveredResourceCounts::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`configuration_aggregator_name(impl Into<String>)`](crate::client::fluent_builders::GetAggregateDiscoveredResourceCounts::configuration_aggregator_name) / [`set_configuration_aggregator_name(Option<String>)`](crate::client::fluent_builders::GetAggregateDiscoveredResourceCounts::set_configuration_aggregator_name): <p>The name of the configuration aggregator.</p>
    ///   - [`filters(ResourceCountFilters)`](crate::client::fluent_builders::GetAggregateDiscoveredResourceCounts::filters) / [`set_filters(Option<ResourceCountFilters>)`](crate::client::fluent_builders::GetAggregateDiscoveredResourceCounts::set_filters): <p>Filters the results based on the <code>ResourceCountFilters</code> object.</p>
    ///   - [`group_by_key(ResourceCountGroupKey)`](crate::client::fluent_builders::GetAggregateDiscoveredResourceCounts::group_by_key) / [`set_group_by_key(Option<ResourceCountGroupKey>)`](crate::client::fluent_builders::GetAggregateDiscoveredResourceCounts::set_group_by_key): <p>The key to group the resource counts.</p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::GetAggregateDiscoveredResourceCounts::limit) / [`set_limit(i32)`](crate::client::fluent_builders::GetAggregateDiscoveredResourceCounts::set_limit): <p>The maximum number of <code>GroupedResourceCount</code> objects returned on each page. The default is 1000. You cannot specify a number greater than 1000. If you specify 0, Config uses the default.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::GetAggregateDiscoveredResourceCounts::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::GetAggregateDiscoveredResourceCounts::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
    /// - On success, responds with [`GetAggregateDiscoveredResourceCountsOutput`](crate::output::GetAggregateDiscoveredResourceCountsOutput) with field(s):
    ///   - [`total_discovered_resources(i64)`](crate::output::GetAggregateDiscoveredResourceCountsOutput::total_discovered_resources): <p>The total number of resources that are present in an aggregator with the filters that you provide.</p>
    ///   - [`group_by_key(Option<String>)`](crate::output::GetAggregateDiscoveredResourceCountsOutput::group_by_key): <p>The key passed into the request object. If <code>GroupByKey</code> is not provided, the result will be empty.</p>
    ///   - [`grouped_resource_counts(Option<Vec<GroupedResourceCount>>)`](crate::output::GetAggregateDiscoveredResourceCountsOutput::grouped_resource_counts): <p>Returns a list of GroupedResourceCount objects.</p>
    ///   - [`next_token(Option<String>)`](crate::output::GetAggregateDiscoveredResourceCountsOutput::next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<GetAggregateDiscoveredResourceCountsError>`](crate::error::GetAggregateDiscoveredResourceCountsError)
    pub fn get_aggregate_discovered_resource_counts(
        &self,
    ) -> fluent_builders::GetAggregateDiscoveredResourceCounts {
        fluent_builders::GetAggregateDiscoveredResourceCounts::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`GetAggregateResourceConfig`](crate::client::fluent_builders::GetAggregateResourceConfig) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`configuration_aggregator_name(impl Into<String>)`](crate::client::fluent_builders::GetAggregateResourceConfig::configuration_aggregator_name) / [`set_configuration_aggregator_name(Option<String>)`](crate::client::fluent_builders::GetAggregateResourceConfig::set_configuration_aggregator_name): <p>The name of the configuration aggregator.</p>
    ///   - [`resource_identifier(AggregateResourceIdentifier)`](crate::client::fluent_builders::GetAggregateResourceConfig::resource_identifier) / [`set_resource_identifier(Option<AggregateResourceIdentifier>)`](crate::client::fluent_builders::GetAggregateResourceConfig::set_resource_identifier): <p>An object that identifies aggregate resource.</p>
    /// - On success, responds with [`GetAggregateResourceConfigOutput`](crate::output::GetAggregateResourceConfigOutput) with field(s):
    ///   - [`configuration_item(Option<ConfigurationItem>)`](crate::output::GetAggregateResourceConfigOutput::configuration_item): <p>Returns a <code>ConfigurationItem</code> object.</p>
    /// - On failure, responds with [`SdkError<GetAggregateResourceConfigError>`](crate::error::GetAggregateResourceConfigError)
    pub fn get_aggregate_resource_config(&self) -> fluent_builders::GetAggregateResourceConfig {
        fluent_builders::GetAggregateResourceConfig::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`GetComplianceDetailsByConfigRule`](crate::client::fluent_builders::GetComplianceDetailsByConfigRule) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::GetComplianceDetailsByConfigRule::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`config_rule_name(impl Into<String>)`](crate::client::fluent_builders::GetComplianceDetailsByConfigRule::config_rule_name) / [`set_config_rule_name(Option<String>)`](crate::client::fluent_builders::GetComplianceDetailsByConfigRule::set_config_rule_name): <p>The name of the Config rule for which you want compliance information.</p>
    ///   - [`compliance_types(Vec<ComplianceType>)`](crate::client::fluent_builders::GetComplianceDetailsByConfigRule::compliance_types) / [`set_compliance_types(Option<Vec<ComplianceType>>)`](crate::client::fluent_builders::GetComplianceDetailsByConfigRule::set_compliance_types): <p>Filters the results by compliance.</p>  <p>The allowed values are <code>COMPLIANT</code>, <code>NON_COMPLIANT</code>, and <code>NOT_APPLICABLE</code>.</p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::GetComplianceDetailsByConfigRule::limit) / [`set_limit(i32)`](crate::client::fluent_builders::GetComplianceDetailsByConfigRule::set_limit): <p>The maximum number of evaluation results returned on each page. The default is 10. You cannot specify a number greater than 100. If you specify 0, Config uses the default.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::GetComplianceDetailsByConfigRule::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::GetComplianceDetailsByConfigRule::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On success, responds with [`GetComplianceDetailsByConfigRuleOutput`](crate::output::GetComplianceDetailsByConfigRuleOutput) with field(s):
    ///   - [`evaluation_results(Option<Vec<EvaluationResult>>)`](crate::output::GetComplianceDetailsByConfigRuleOutput::evaluation_results): <p>Indicates whether the Amazon Web Services resource complies with the specified Config rule.</p>
    ///   - [`next_token(Option<String>)`](crate::output::GetComplianceDetailsByConfigRuleOutput::next_token): <p>The string that you use in a subsequent request to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<GetComplianceDetailsByConfigRuleError>`](crate::error::GetComplianceDetailsByConfigRuleError)
    pub fn get_compliance_details_by_config_rule(
        &self,
    ) -> fluent_builders::GetComplianceDetailsByConfigRule {
        fluent_builders::GetComplianceDetailsByConfigRule::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`GetComplianceDetailsByResource`](crate::client::fluent_builders::GetComplianceDetailsByResource) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::GetComplianceDetailsByResource::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`resource_type(impl Into<String>)`](crate::client::fluent_builders::GetComplianceDetailsByResource::resource_type) / [`set_resource_type(Option<String>)`](crate::client::fluent_builders::GetComplianceDetailsByResource::set_resource_type): <p>The type of the Amazon Web Services resource for which you want compliance information.</p>
    ///   - [`resource_id(impl Into<String>)`](crate::client::fluent_builders::GetComplianceDetailsByResource::resource_id) / [`set_resource_id(Option<String>)`](crate::client::fluent_builders::GetComplianceDetailsByResource::set_resource_id): <p>The ID of the Amazon Web Services resource for which you want compliance information.</p>
    ///   - [`compliance_types(Vec<ComplianceType>)`](crate::client::fluent_builders::GetComplianceDetailsByResource::compliance_types) / [`set_compliance_types(Option<Vec<ComplianceType>>)`](crate::client::fluent_builders::GetComplianceDetailsByResource::set_compliance_types): <p>Filters the results by compliance.</p>  <p>The allowed values are <code>COMPLIANT</code>, <code>NON_COMPLIANT</code>, and <code>NOT_APPLICABLE</code>.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::GetComplianceDetailsByResource::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::GetComplianceDetailsByResource::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On success, responds with [`GetComplianceDetailsByResourceOutput`](crate::output::GetComplianceDetailsByResourceOutput) with field(s):
    ///   - [`evaluation_results(Option<Vec<EvaluationResult>>)`](crate::output::GetComplianceDetailsByResourceOutput::evaluation_results): <p>Indicates whether the specified Amazon Web Services resource complies each Config rule.</p>
    ///   - [`next_token(Option<String>)`](crate::output::GetComplianceDetailsByResourceOutput::next_token): <p>The string that you use in a subsequent request to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<GetComplianceDetailsByResourceError>`](crate::error::GetComplianceDetailsByResourceError)
    pub fn get_compliance_details_by_resource(
        &self,
    ) -> fluent_builders::GetComplianceDetailsByResource {
        fluent_builders::GetComplianceDetailsByResource::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`GetComplianceSummaryByConfigRule`](crate::client::fluent_builders::GetComplianceSummaryByConfigRule) operation.
    ///
    /// - The fluent builder takes no input, just [`send`](crate::client::fluent_builders::GetComplianceSummaryByConfigRule::send) it.

    /// - On success, responds with [`GetComplianceSummaryByConfigRuleOutput`](crate::output::GetComplianceSummaryByConfigRuleOutput) with field(s):
    ///   - [`compliance_summary(Option<ComplianceSummary>)`](crate::output::GetComplianceSummaryByConfigRuleOutput::compliance_summary): <p>The number of Config rules that are compliant and the number that are noncompliant, up to a maximum of 25 for each.</p>
    /// - On failure, responds with [`SdkError<GetComplianceSummaryByConfigRuleError>`](crate::error::GetComplianceSummaryByConfigRuleError)
    pub fn get_compliance_summary_by_config_rule(
        &self,
    ) -> fluent_builders::GetComplianceSummaryByConfigRule {
        fluent_builders::GetComplianceSummaryByConfigRule::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`GetComplianceSummaryByResourceType`](crate::client::fluent_builders::GetComplianceSummaryByResourceType) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`resource_types(Vec<String>)`](crate::client::fluent_builders::GetComplianceSummaryByResourceType::resource_types) / [`set_resource_types(Option<Vec<String>>)`](crate::client::fluent_builders::GetComplianceSummaryByResourceType::set_resource_types): <p>Specify one or more resource types to get the number of resources that are compliant and the number that are noncompliant for each resource type.</p>  <p>For this request, you can specify an Amazon Web Services resource type such as <code>AWS::EC2::Instance</code>. You can specify that the resource type is an Amazon Web Services account by specifying <code>AWS::::Account</code>.</p>
    /// - On success, responds with [`GetComplianceSummaryByResourceTypeOutput`](crate::output::GetComplianceSummaryByResourceTypeOutput) with field(s):
    ///   - [`compliance_summaries_by_resource_type(Option<Vec<ComplianceSummaryByResourceType>>)`](crate::output::GetComplianceSummaryByResourceTypeOutput::compliance_summaries_by_resource_type): <p>The number of resources that are compliant and the number that are noncompliant. If one or more resource types were provided with the request, the numbers are returned for each resource type. The maximum number returned is 100.</p>
    /// - On failure, responds with [`SdkError<GetComplianceSummaryByResourceTypeError>`](crate::error::GetComplianceSummaryByResourceTypeError)
    pub fn get_compliance_summary_by_resource_type(
        &self,
    ) -> fluent_builders::GetComplianceSummaryByResourceType {
        fluent_builders::GetComplianceSummaryByResourceType::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`GetConformancePackComplianceDetails`](crate::client::fluent_builders::GetConformancePackComplianceDetails) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::GetConformancePackComplianceDetails::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`conformance_pack_name(impl Into<String>)`](crate::client::fluent_builders::GetConformancePackComplianceDetails::conformance_pack_name) / [`set_conformance_pack_name(Option<String>)`](crate::client::fluent_builders::GetConformancePackComplianceDetails::set_conformance_pack_name): <p>Name of the conformance pack.</p>
    ///   - [`filters(ConformancePackEvaluationFilters)`](crate::client::fluent_builders::GetConformancePackComplianceDetails::filters) / [`set_filters(Option<ConformancePackEvaluationFilters>)`](crate::client::fluent_builders::GetConformancePackComplianceDetails::set_filters): <p>A <code>ConformancePackEvaluationFilters</code> object.</p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::GetConformancePackComplianceDetails::limit) / [`set_limit(i32)`](crate::client::fluent_builders::GetConformancePackComplianceDetails::set_limit): <p>The maximum number of evaluation results returned on each page. If you do no specify a number, Config uses the default. The default is 100.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::GetConformancePackComplianceDetails::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::GetConformancePackComplianceDetails::set_next_token): <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
    /// - On success, responds with [`GetConformancePackComplianceDetailsOutput`](crate::output::GetConformancePackComplianceDetailsOutput) with field(s):
    ///   - [`conformance_pack_name(Option<String>)`](crate::output::GetConformancePackComplianceDetailsOutput::conformance_pack_name): <p>Name of the conformance pack.</p>
    ///   - [`conformance_pack_rule_evaluation_results(Option<Vec<ConformancePackEvaluationResult>>)`](crate::output::GetConformancePackComplianceDetailsOutput::conformance_pack_rule_evaluation_results): <p>Returns a list of <code>ConformancePackEvaluationResult</code> objects.</p>
    ///   - [`next_token(Option<String>)`](crate::output::GetConformancePackComplianceDetailsOutput::next_token): <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<GetConformancePackComplianceDetailsError>`](crate::error::GetConformancePackComplianceDetailsError)
    pub fn get_conformance_pack_compliance_details(
        &self,
    ) -> fluent_builders::GetConformancePackComplianceDetails {
        fluent_builders::GetConformancePackComplianceDetails::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`GetConformancePackComplianceSummary`](crate::client::fluent_builders::GetConformancePackComplianceSummary) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::GetConformancePackComplianceSummary::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`conformance_pack_names(Vec<String>)`](crate::client::fluent_builders::GetConformancePackComplianceSummary::conformance_pack_names) / [`set_conformance_pack_names(Option<Vec<String>>)`](crate::client::fluent_builders::GetConformancePackComplianceSummary::set_conformance_pack_names): <p>Names of conformance packs.</p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::GetConformancePackComplianceSummary::limit) / [`set_limit(i32)`](crate::client::fluent_builders::GetConformancePackComplianceSummary::set_limit): <p>The maximum number of conformance packs returned on each page.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::GetConformancePackComplianceSummary::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::GetConformancePackComplianceSummary::set_next_token): <p>The nextToken string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On success, responds with [`GetConformancePackComplianceSummaryOutput`](crate::output::GetConformancePackComplianceSummaryOutput) with field(s):
    ///   - [`conformance_pack_compliance_summary_list(Option<Vec<ConformancePackComplianceSummary>>)`](crate::output::GetConformancePackComplianceSummaryOutput::conformance_pack_compliance_summary_list): <p>A list of <code>ConformancePackComplianceSummary</code> objects. </p>
    ///   - [`next_token(Option<String>)`](crate::output::GetConformancePackComplianceSummaryOutput::next_token): <p>The nextToken string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<GetConformancePackComplianceSummaryError>`](crate::error::GetConformancePackComplianceSummaryError)
    pub fn get_conformance_pack_compliance_summary(
        &self,
    ) -> fluent_builders::GetConformancePackComplianceSummary {
        fluent_builders::GetConformancePackComplianceSummary::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`GetDiscoveredResourceCounts`](crate::client::fluent_builders::GetDiscoveredResourceCounts) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::GetDiscoveredResourceCounts::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`resource_types(Vec<String>)`](crate::client::fluent_builders::GetDiscoveredResourceCounts::resource_types) / [`set_resource_types(Option<Vec<String>>)`](crate::client::fluent_builders::GetDiscoveredResourceCounts::set_resource_types): <p>The comma-separated list that specifies the resource types that you want Config to return (for example, <code>"AWS::EC2::Instance"</code>, <code>"AWS::IAM::User"</code>).</p>  <p>If a value for <code>resourceTypes</code> is not specified, Config returns all resource types that Config is recording in the region for your account.</p> <note>   <p>If the configuration recorder is turned off, Config returns an empty list of <code>ResourceCount</code> objects. If the configuration recorder is not recording a specific resource type (for example, S3 buckets), that resource type is not returned in the list of <code>ResourceCount</code> objects.</p>  </note>
    ///   - [`limit(i32)`](crate::client::fluent_builders::GetDiscoveredResourceCounts::limit) / [`set_limit(i32)`](crate::client::fluent_builders::GetDiscoveredResourceCounts::set_limit): <p>The maximum number of <code>ResourceCount</code> objects returned on each page. The default is 100. You cannot specify a number greater than 100. If you specify 0, Config uses the default.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::GetDiscoveredResourceCounts::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::GetDiscoveredResourceCounts::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On success, responds with [`GetDiscoveredResourceCountsOutput`](crate::output::GetDiscoveredResourceCountsOutput) with field(s):
    ///   - [`total_discovered_resources(i64)`](crate::output::GetDiscoveredResourceCountsOutput::total_discovered_resources): <p>The total number of resources that Config is recording in the region for your account. If you specify resource types in the request, Config returns only the total number of resources for those resource types.</p>  <p class="title"> <b>Example</b> </p>  <ol>   <li> <p>Config is recording three resource types in the US East (Ohio) Region for your account: 25 EC2 instances, 20 IAM users, and 15 S3 buckets, for a total of 60 resources.</p> </li>   <li> <p>You make a call to the <code>GetDiscoveredResourceCounts</code> action and specify the resource type, <code>"AWS::EC2::Instances"</code>, in the request.</p> </li>   <li> <p>Config returns 25 for <code>totalDiscoveredResources</code>.</p> </li>  </ol>
    ///   - [`resource_counts(Option<Vec<ResourceCount>>)`](crate::output::GetDiscoveredResourceCountsOutput::resource_counts): <p>The list of <code>ResourceCount</code> objects. Each object is listed in descending order by the number of resources.</p>
    ///   - [`next_token(Option<String>)`](crate::output::GetDiscoveredResourceCountsOutput::next_token): <p>The string that you use in a subsequent request to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<GetDiscoveredResourceCountsError>`](crate::error::GetDiscoveredResourceCountsError)
    pub fn get_discovered_resource_counts(&self) -> fluent_builders::GetDiscoveredResourceCounts {
        fluent_builders::GetDiscoveredResourceCounts::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`GetOrganizationConfigRuleDetailedStatus`](crate::client::fluent_builders::GetOrganizationConfigRuleDetailedStatus) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::GetOrganizationConfigRuleDetailedStatus::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`organization_config_rule_name(impl Into<String>)`](crate::client::fluent_builders::GetOrganizationConfigRuleDetailedStatus::organization_config_rule_name) / [`set_organization_config_rule_name(Option<String>)`](crate::client::fluent_builders::GetOrganizationConfigRuleDetailedStatus::set_organization_config_rule_name): <p>The name of organization config rule for which you want status details for member accounts.</p>
    ///   - [`filters(StatusDetailFilters)`](crate::client::fluent_builders::GetOrganizationConfigRuleDetailedStatus::filters) / [`set_filters(Option<StatusDetailFilters>)`](crate::client::fluent_builders::GetOrganizationConfigRuleDetailedStatus::set_filters): <p>A <code>StatusDetailFilters</code> object.</p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::GetOrganizationConfigRuleDetailedStatus::limit) / [`set_limit(i32)`](crate::client::fluent_builders::GetOrganizationConfigRuleDetailedStatus::set_limit): <p>The maximum number of <code>OrganizationConfigRuleDetailedStatus</code> returned on each page. If you do not specify a number, Config uses the default. The default is 100.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::GetOrganizationConfigRuleDetailedStatus::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::GetOrganizationConfigRuleDetailedStatus::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
    /// - On success, responds with [`GetOrganizationConfigRuleDetailedStatusOutput`](crate::output::GetOrganizationConfigRuleDetailedStatusOutput) with field(s):
    ///   - [`organization_config_rule_detailed_status(Option<Vec<MemberAccountStatus>>)`](crate::output::GetOrganizationConfigRuleDetailedStatusOutput::organization_config_rule_detailed_status): <p>A list of <code>MemberAccountStatus</code> objects.</p>
    ///   - [`next_token(Option<String>)`](crate::output::GetOrganizationConfigRuleDetailedStatusOutput::next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
    /// - On failure, responds with [`SdkError<GetOrganizationConfigRuleDetailedStatusError>`](crate::error::GetOrganizationConfigRuleDetailedStatusError)
    pub fn get_organization_config_rule_detailed_status(
        &self,
    ) -> fluent_builders::GetOrganizationConfigRuleDetailedStatus {
        fluent_builders::GetOrganizationConfigRuleDetailedStatus::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`GetOrganizationConformancePackDetailedStatus`](crate::client::fluent_builders::GetOrganizationConformancePackDetailedStatus) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::GetOrganizationConformancePackDetailedStatus::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`organization_conformance_pack_name(impl Into<String>)`](crate::client::fluent_builders::GetOrganizationConformancePackDetailedStatus::organization_conformance_pack_name) / [`set_organization_conformance_pack_name(Option<String>)`](crate::client::fluent_builders::GetOrganizationConformancePackDetailedStatus::set_organization_conformance_pack_name): <p>The name of organization conformance pack for which you want status details for member accounts.</p>
    ///   - [`filters(OrganizationResourceDetailedStatusFilters)`](crate::client::fluent_builders::GetOrganizationConformancePackDetailedStatus::filters) / [`set_filters(Option<OrganizationResourceDetailedStatusFilters>)`](crate::client::fluent_builders::GetOrganizationConformancePackDetailedStatus::set_filters): <p>An <code>OrganizationResourceDetailedStatusFilters</code> object.</p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::GetOrganizationConformancePackDetailedStatus::limit) / [`set_limit(i32)`](crate::client::fluent_builders::GetOrganizationConformancePackDetailedStatus::set_limit): <p>The maximum number of <code>OrganizationConformancePackDetailedStatuses</code> returned on each page. If you do not specify a number, Config uses the default. The default is 100. </p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::GetOrganizationConformancePackDetailedStatus::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::GetOrganizationConformancePackDetailedStatus::set_next_token): <p>The nextToken string returned on a previous page that you use to get the next page of results in a paginated response. </p>
    /// - On success, responds with [`GetOrganizationConformancePackDetailedStatusOutput`](crate::output::GetOrganizationConformancePackDetailedStatusOutput) with field(s):
    ///   - [`organization_conformance_pack_detailed_statuses(Option<Vec<OrganizationConformancePackDetailedStatus>>)`](crate::output::GetOrganizationConformancePackDetailedStatusOutput::organization_conformance_pack_detailed_statuses): <p>A list of <code>OrganizationConformancePackDetailedStatus</code> objects. </p>
    ///   - [`next_token(Option<String>)`](crate::output::GetOrganizationConformancePackDetailedStatusOutput::next_token): <p>The nextToken string returned on a previous page that you use to get the next page of results in a paginated response. </p>
    /// - On failure, responds with [`SdkError<GetOrganizationConformancePackDetailedStatusError>`](crate::error::GetOrganizationConformancePackDetailedStatusError)
    pub fn get_organization_conformance_pack_detailed_status(
        &self,
    ) -> fluent_builders::GetOrganizationConformancePackDetailedStatus {
        fluent_builders::GetOrganizationConformancePackDetailedStatus::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`GetResourceConfigHistory`](crate::client::fluent_builders::GetResourceConfigHistory) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::GetResourceConfigHistory::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`resource_type(ResourceType)`](crate::client::fluent_builders::GetResourceConfigHistory::resource_type) / [`set_resource_type(Option<ResourceType>)`](crate::client::fluent_builders::GetResourceConfigHistory::set_resource_type): <p>The resource type.</p>
    ///   - [`resource_id(impl Into<String>)`](crate::client::fluent_builders::GetResourceConfigHistory::resource_id) / [`set_resource_id(Option<String>)`](crate::client::fluent_builders::GetResourceConfigHistory::set_resource_id): <p>The ID of the resource (for example., <code>sg-xxxxxx</code>).</p>
    ///   - [`later_time(DateTime)`](crate::client::fluent_builders::GetResourceConfigHistory::later_time) / [`set_later_time(Option<DateTime>)`](crate::client::fluent_builders::GetResourceConfigHistory::set_later_time): <p>The time stamp that indicates a later time. If not specified, current time is taken.</p>
    ///   - [`earlier_time(DateTime)`](crate::client::fluent_builders::GetResourceConfigHistory::earlier_time) / [`set_earlier_time(Option<DateTime>)`](crate::client::fluent_builders::GetResourceConfigHistory::set_earlier_time): <p>The time stamp that indicates an earlier time. If not specified, the action returns paginated results that contain configuration items that start when the first configuration item was recorded.</p>
    ///   - [`chronological_order(ChronologicalOrder)`](crate::client::fluent_builders::GetResourceConfigHistory::chronological_order) / [`set_chronological_order(Option<ChronologicalOrder>)`](crate::client::fluent_builders::GetResourceConfigHistory::set_chronological_order): <p>The chronological order for configuration items listed. By default, the results are listed in reverse chronological order.</p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::GetResourceConfigHistory::limit) / [`set_limit(i32)`](crate::client::fluent_builders::GetResourceConfigHistory::set_limit): <p>The maximum number of configuration items returned on each page. The default is 10. You cannot specify a number greater than 100. If you specify 0, Config uses the default.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::GetResourceConfigHistory::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::GetResourceConfigHistory::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On success, responds with [`GetResourceConfigHistoryOutput`](crate::output::GetResourceConfigHistoryOutput) with field(s):
    ///   - [`configuration_items(Option<Vec<ConfigurationItem>>)`](crate::output::GetResourceConfigHistoryOutput::configuration_items): <p>A list that contains the configuration history of one or more resources.</p>
    ///   - [`next_token(Option<String>)`](crate::output::GetResourceConfigHistoryOutput::next_token): <p>The string that you use in a subsequent request to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<GetResourceConfigHistoryError>`](crate::error::GetResourceConfigHistoryError)
    pub fn get_resource_config_history(&self) -> fluent_builders::GetResourceConfigHistory {
        fluent_builders::GetResourceConfigHistory::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`GetStoredQuery`](crate::client::fluent_builders::GetStoredQuery) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`query_name(impl Into<String>)`](crate::client::fluent_builders::GetStoredQuery::query_name) / [`set_query_name(Option<String>)`](crate::client::fluent_builders::GetStoredQuery::set_query_name): <p>The name of the query.</p>
    /// - On success, responds with [`GetStoredQueryOutput`](crate::output::GetStoredQueryOutput) with field(s):
    ///   - [`stored_query(Option<StoredQuery>)`](crate::output::GetStoredQueryOutput::stored_query): <p>Returns a <code>StoredQuery</code> object.</p>
    /// - On failure, responds with [`SdkError<GetStoredQueryError>`](crate::error::GetStoredQueryError)
    pub fn get_stored_query(&self) -> fluent_builders::GetStoredQuery {
        fluent_builders::GetStoredQuery::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`ListAggregateDiscoveredResources`](crate::client::fluent_builders::ListAggregateDiscoveredResources) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::ListAggregateDiscoveredResources::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`configuration_aggregator_name(impl Into<String>)`](crate::client::fluent_builders::ListAggregateDiscoveredResources::configuration_aggregator_name) / [`set_configuration_aggregator_name(Option<String>)`](crate::client::fluent_builders::ListAggregateDiscoveredResources::set_configuration_aggregator_name): <p>The name of the configuration aggregator. </p>
    ///   - [`resource_type(ResourceType)`](crate::client::fluent_builders::ListAggregateDiscoveredResources::resource_type) / [`set_resource_type(Option<ResourceType>)`](crate::client::fluent_builders::ListAggregateDiscoveredResources::set_resource_type): <p>The type of resources that you want Config to list in the response.</p>
    ///   - [`filters(ResourceFilters)`](crate::client::fluent_builders::ListAggregateDiscoveredResources::filters) / [`set_filters(Option<ResourceFilters>)`](crate::client::fluent_builders::ListAggregateDiscoveredResources::set_filters): <p>Filters the results based on the <code>ResourceFilters</code> object.</p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::ListAggregateDiscoveredResources::limit) / [`set_limit(i32)`](crate::client::fluent_builders::ListAggregateDiscoveredResources::set_limit): <p>The maximum number of resource identifiers returned on each page. You cannot specify a number greater than 100. If you specify 0, Config uses the default.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::ListAggregateDiscoveredResources::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::ListAggregateDiscoveredResources::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On success, responds with [`ListAggregateDiscoveredResourcesOutput`](crate::output::ListAggregateDiscoveredResourcesOutput) with field(s):
    ///   - [`resource_identifiers(Option<Vec<AggregateResourceIdentifier>>)`](crate::output::ListAggregateDiscoveredResourcesOutput::resource_identifiers): <p>Returns a list of <code>ResourceIdentifiers</code> objects.</p>
    ///   - [`next_token(Option<String>)`](crate::output::ListAggregateDiscoveredResourcesOutput::next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<ListAggregateDiscoveredResourcesError>`](crate::error::ListAggregateDiscoveredResourcesError)
    pub fn list_aggregate_discovered_resources(
        &self,
    ) -> fluent_builders::ListAggregateDiscoveredResources {
        fluent_builders::ListAggregateDiscoveredResources::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`ListDiscoveredResources`](crate::client::fluent_builders::ListDiscoveredResources) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::ListDiscoveredResources::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`resource_type(ResourceType)`](crate::client::fluent_builders::ListDiscoveredResources::resource_type) / [`set_resource_type(Option<ResourceType>)`](crate::client::fluent_builders::ListDiscoveredResources::set_resource_type): <p>The type of resources that you want Config to list in the response.</p>
    ///   - [`resource_ids(Vec<String>)`](crate::client::fluent_builders::ListDiscoveredResources::resource_ids) / [`set_resource_ids(Option<Vec<String>>)`](crate::client::fluent_builders::ListDiscoveredResources::set_resource_ids): <p>The IDs of only those resources that you want Config to list in the response. If you do not specify this parameter, Config lists all resources of the specified type that it has discovered.</p>
    ///   - [`resource_name(impl Into<String>)`](crate::client::fluent_builders::ListDiscoveredResources::resource_name) / [`set_resource_name(Option<String>)`](crate::client::fluent_builders::ListDiscoveredResources::set_resource_name): <p>The custom name of only those resources that you want Config to list in the response. If you do not specify this parameter, Config lists all resources of the specified type that it has discovered.</p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::ListDiscoveredResources::limit) / [`set_limit(i32)`](crate::client::fluent_builders::ListDiscoveredResources::set_limit): <p>The maximum number of resource identifiers returned on each page. The default is 100. You cannot specify a number greater than 100. If you specify 0, Config uses the default.</p>
    ///   - [`include_deleted_resources(bool)`](crate::client::fluent_builders::ListDiscoveredResources::include_deleted_resources) / [`set_include_deleted_resources(bool)`](crate::client::fluent_builders::ListDiscoveredResources::set_include_deleted_resources): <p>Specifies whether Config includes deleted resources in the results. By default, deleted resources are not included.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::ListDiscoveredResources::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::ListDiscoveredResources::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
    /// - On success, responds with [`ListDiscoveredResourcesOutput`](crate::output::ListDiscoveredResourcesOutput) with field(s):
    ///   - [`resource_identifiers(Option<Vec<ResourceIdentifier>>)`](crate::output::ListDiscoveredResourcesOutput::resource_identifiers): <p>The details that identify a resource that is discovered by Config, including the resource type, ID, and (if available) the custom resource name.</p>
    ///   - [`next_token(Option<String>)`](crate::output::ListDiscoveredResourcesOutput::next_token): <p>The string that you use in a subsequent request to get the next page of results in a paginated response.</p>
    /// - On failure, responds with [`SdkError<ListDiscoveredResourcesError>`](crate::error::ListDiscoveredResourcesError)
    pub fn list_discovered_resources(&self) -> fluent_builders::ListDiscoveredResources {
        fluent_builders::ListDiscoveredResources::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`ListStoredQueries`](crate::client::fluent_builders::ListStoredQueries) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::ListStoredQueries::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::ListStoredQueries::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::ListStoredQueries::set_next_token): <p>The nextToken string returned in a previous request that you use to request the next page of results in a paginated response.</p>
    ///   - [`max_results(i32)`](crate::client::fluent_builders::ListStoredQueries::max_results) / [`set_max_results(Option<i32>)`](crate::client::fluent_builders::ListStoredQueries::set_max_results): <p>The maximum number of results to be returned with a single call.</p>
    /// - On success, responds with [`ListStoredQueriesOutput`](crate::output::ListStoredQueriesOutput) with field(s):
    ///   - [`stored_query_metadata(Option<Vec<StoredQueryMetadata>>)`](crate::output::ListStoredQueriesOutput::stored_query_metadata): <p>A list of <code>StoredQueryMetadata</code> objects.</p>
    ///   - [`next_token(Option<String>)`](crate::output::ListStoredQueriesOutput::next_token): <p>If the previous paginated request didn't return all of the remaining results, the response object's <code>NextToken</code> parameter value is set to a token. To retrieve the next set of results, call this action again and assign that token to the request object's <code>NextToken</code> parameter. If there are no remaining results, the previous response object's <code>NextToken</code> parameter is set to <code>null</code>. </p>
    /// - On failure, responds with [`SdkError<ListStoredQueriesError>`](crate::error::ListStoredQueriesError)
    pub fn list_stored_queries(&self) -> fluent_builders::ListStoredQueries {
        fluent_builders::ListStoredQueries::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`ListTagsForResource`](crate::client::fluent_builders::ListTagsForResource) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::ListTagsForResource::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`resource_arn(impl Into<String>)`](crate::client::fluent_builders::ListTagsForResource::resource_arn) / [`set_resource_arn(Option<String>)`](crate::client::fluent_builders::ListTagsForResource::set_resource_arn): <p>The Amazon Resource Name (ARN) that identifies the resource for which to list the tags. Currently, the supported resources are <code>ConfigRule</code>, <code>ConfigurationAggregator</code> and <code>AggregatorAuthorization</code>.</p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::ListTagsForResource::limit) / [`set_limit(i32)`](crate::client::fluent_builders::ListTagsForResource::set_limit): <p>The maximum number of tags returned on each page. The limit maximum is 50. You cannot specify a number greater than 50. If you specify 0, Config uses the default. </p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::ListTagsForResource::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::ListTagsForResource::set_next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
    /// - On success, responds with [`ListTagsForResourceOutput`](crate::output::ListTagsForResourceOutput) with field(s):
    ///   - [`tags(Option<Vec<Tag>>)`](crate::output::ListTagsForResourceOutput::tags): <p>The tags for the resource.</p>
    ///   - [`next_token(Option<String>)`](crate::output::ListTagsForResourceOutput::next_token): <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
    /// - On failure, responds with [`SdkError<ListTagsForResourceError>`](crate::error::ListTagsForResourceError)
    pub fn list_tags_for_resource(&self) -> fluent_builders::ListTagsForResource {
        fluent_builders::ListTagsForResource::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`PutAggregationAuthorization`](crate::client::fluent_builders::PutAggregationAuthorization) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`authorized_account_id(impl Into<String>)`](crate::client::fluent_builders::PutAggregationAuthorization::authorized_account_id) / [`set_authorized_account_id(Option<String>)`](crate::client::fluent_builders::PutAggregationAuthorization::set_authorized_account_id): <p>The 12-digit account ID of the account authorized to aggregate data.</p>
    ///   - [`authorized_aws_region(impl Into<String>)`](crate::client::fluent_builders::PutAggregationAuthorization::authorized_aws_region) / [`set_authorized_aws_region(Option<String>)`](crate::client::fluent_builders::PutAggregationAuthorization::set_authorized_aws_region): <p>The region authorized to collect aggregated data.</p>
    ///   - [`tags(Vec<Tag>)`](crate::client::fluent_builders::PutAggregationAuthorization::tags) / [`set_tags(Option<Vec<Tag>>)`](crate::client::fluent_builders::PutAggregationAuthorization::set_tags): <p>An array of tag object.</p>
    /// - On success, responds with [`PutAggregationAuthorizationOutput`](crate::output::PutAggregationAuthorizationOutput) with field(s):
    ///   - [`aggregation_authorization(Option<AggregationAuthorization>)`](crate::output::PutAggregationAuthorizationOutput::aggregation_authorization): <p>Returns an AggregationAuthorization object. </p>
    /// - On failure, responds with [`SdkError<PutAggregationAuthorizationError>`](crate::error::PutAggregationAuthorizationError)
    pub fn put_aggregation_authorization(&self) -> fluent_builders::PutAggregationAuthorization {
        fluent_builders::PutAggregationAuthorization::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`PutConfigRule`](crate::client::fluent_builders::PutConfigRule) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`config_rule(ConfigRule)`](crate::client::fluent_builders::PutConfigRule::config_rule) / [`set_config_rule(Option<ConfigRule>)`](crate::client::fluent_builders::PutConfigRule::set_config_rule): <p>The rule that you want to add to your account.</p>
    ///   - [`tags(Vec<Tag>)`](crate::client::fluent_builders::PutConfigRule::tags) / [`set_tags(Option<Vec<Tag>>)`](crate::client::fluent_builders::PutConfigRule::set_tags): <p>An array of tag object.</p>
    /// - On success, responds with [`PutConfigRuleOutput`](crate::output::PutConfigRuleOutput)

    /// - On failure, responds with [`SdkError<PutConfigRuleError>`](crate::error::PutConfigRuleError)
    pub fn put_config_rule(&self) -> fluent_builders::PutConfigRule {
        fluent_builders::PutConfigRule::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`PutConfigurationAggregator`](crate::client::fluent_builders::PutConfigurationAggregator) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`configuration_aggregator_name(impl Into<String>)`](crate::client::fluent_builders::PutConfigurationAggregator::configuration_aggregator_name) / [`set_configuration_aggregator_name(Option<String>)`](crate::client::fluent_builders::PutConfigurationAggregator::set_configuration_aggregator_name): <p>The name of the configuration aggregator.</p>
    ///   - [`account_aggregation_sources(Vec<AccountAggregationSource>)`](crate::client::fluent_builders::PutConfigurationAggregator::account_aggregation_sources) / [`set_account_aggregation_sources(Option<Vec<AccountAggregationSource>>)`](crate::client::fluent_builders::PutConfigurationAggregator::set_account_aggregation_sources): <p>A list of AccountAggregationSource object. </p>
    ///   - [`organization_aggregation_source(OrganizationAggregationSource)`](crate::client::fluent_builders::PutConfigurationAggregator::organization_aggregation_source) / [`set_organization_aggregation_source(Option<OrganizationAggregationSource>)`](crate::client::fluent_builders::PutConfigurationAggregator::set_organization_aggregation_source): <p>An OrganizationAggregationSource object.</p>
    ///   - [`tags(Vec<Tag>)`](crate::client::fluent_builders::PutConfigurationAggregator::tags) / [`set_tags(Option<Vec<Tag>>)`](crate::client::fluent_builders::PutConfigurationAggregator::set_tags): <p>An array of tag object.</p>
    /// - On success, responds with [`PutConfigurationAggregatorOutput`](crate::output::PutConfigurationAggregatorOutput) with field(s):
    ///   - [`configuration_aggregator(Option<ConfigurationAggregator>)`](crate::output::PutConfigurationAggregatorOutput::configuration_aggregator): <p>Returns a ConfigurationAggregator object.</p>
    /// - On failure, responds with [`SdkError<PutConfigurationAggregatorError>`](crate::error::PutConfigurationAggregatorError)
    pub fn put_configuration_aggregator(&self) -> fluent_builders::PutConfigurationAggregator {
        fluent_builders::PutConfigurationAggregator::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`PutConfigurationRecorder`](crate::client::fluent_builders::PutConfigurationRecorder) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`configuration_recorder(ConfigurationRecorder)`](crate::client::fluent_builders::PutConfigurationRecorder::configuration_recorder) / [`set_configuration_recorder(Option<ConfigurationRecorder>)`](crate::client::fluent_builders::PutConfigurationRecorder::set_configuration_recorder): <p>The configuration recorder object that records each configuration change made to the resources.</p>
    /// - On success, responds with [`PutConfigurationRecorderOutput`](crate::output::PutConfigurationRecorderOutput)

    /// - On failure, responds with [`SdkError<PutConfigurationRecorderError>`](crate::error::PutConfigurationRecorderError)
    pub fn put_configuration_recorder(&self) -> fluent_builders::PutConfigurationRecorder {
        fluent_builders::PutConfigurationRecorder::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`PutConformancePack`](crate::client::fluent_builders::PutConformancePack) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`conformance_pack_name(impl Into<String>)`](crate::client::fluent_builders::PutConformancePack::conformance_pack_name) / [`set_conformance_pack_name(Option<String>)`](crate::client::fluent_builders::PutConformancePack::set_conformance_pack_name): <p>Name of the conformance pack you want to create.</p>
    ///   - [`template_s3_uri(impl Into<String>)`](crate::client::fluent_builders::PutConformancePack::template_s3_uri) / [`set_template_s3_uri(Option<String>)`](crate::client::fluent_builders::PutConformancePack::set_template_s3_uri): <p>Location of file containing the template body (<code>s3://bucketname/prefix</code>). The uri must point to the conformance pack template (max size: 300 KB) that is located in an Amazon S3 bucket in the same region as the conformance pack. </p> <note>   <p>You must have access to read Amazon S3 bucket.</p>  </note>
    ///   - [`template_body(impl Into<String>)`](crate::client::fluent_builders::PutConformancePack::template_body) / [`set_template_body(Option<String>)`](crate::client::fluent_builders::PutConformancePack::set_template_body): <p>A string containing full conformance pack template body. Structure containing the template body with a minimum length of 1 byte and a maximum length of 51,200 bytes.</p> <note>   <p>You can only use a YAML template with two resource types: config rule (<code>AWS::Config::ConfigRule</code>) and a remediation action (<code>AWS::Config::RemediationConfiguration</code>).</p>  </note>
    ///   - [`delivery_s3_bucket(impl Into<String>)`](crate::client::fluent_builders::PutConformancePack::delivery_s3_bucket) / [`set_delivery_s3_bucket(Option<String>)`](crate::client::fluent_builders::PutConformancePack::set_delivery_s3_bucket): <p>The name of the Amazon S3 bucket where Config stores conformance pack templates.</p> <note>   <p>This field is optional.</p>  </note>
    ///   - [`delivery_s3_key_prefix(impl Into<String>)`](crate::client::fluent_builders::PutConformancePack::delivery_s3_key_prefix) / [`set_delivery_s3_key_prefix(Option<String>)`](crate::client::fluent_builders::PutConformancePack::set_delivery_s3_key_prefix): <p>The prefix for the Amazon S3 bucket. </p> <note>   <p>This field is optional.</p>  </note>
    ///   - [`conformance_pack_input_parameters(Vec<ConformancePackInputParameter>)`](crate::client::fluent_builders::PutConformancePack::conformance_pack_input_parameters) / [`set_conformance_pack_input_parameters(Option<Vec<ConformancePackInputParameter>>)`](crate::client::fluent_builders::PutConformancePack::set_conformance_pack_input_parameters): <p>A list of <code>ConformancePackInputParameter</code> objects.</p>
    /// - On success, responds with [`PutConformancePackOutput`](crate::output::PutConformancePackOutput) with field(s):
    ///   - [`conformance_pack_arn(Option<String>)`](crate::output::PutConformancePackOutput::conformance_pack_arn): <p>ARN of the conformance pack.</p>
    /// - On failure, responds with [`SdkError<PutConformancePackError>`](crate::error::PutConformancePackError)
    pub fn put_conformance_pack(&self) -> fluent_builders::PutConformancePack {
        fluent_builders::PutConformancePack::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`PutDeliveryChannel`](crate::client::fluent_builders::PutDeliveryChannel) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`delivery_channel(DeliveryChannel)`](crate::client::fluent_builders::PutDeliveryChannel::delivery_channel) / [`set_delivery_channel(Option<DeliveryChannel>)`](crate::client::fluent_builders::PutDeliveryChannel::set_delivery_channel): <p>The configuration delivery channel object that delivers the configuration information to an Amazon S3 bucket and to an Amazon SNS topic.</p>
    /// - On success, responds with [`PutDeliveryChannelOutput`](crate::output::PutDeliveryChannelOutput)

    /// - On failure, responds with [`SdkError<PutDeliveryChannelError>`](crate::error::PutDeliveryChannelError)
    pub fn put_delivery_channel(&self) -> fluent_builders::PutDeliveryChannel {
        fluent_builders::PutDeliveryChannel::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`PutEvaluations`](crate::client::fluent_builders::PutEvaluations) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`evaluations(Vec<Evaluation>)`](crate::client::fluent_builders::PutEvaluations::evaluations) / [`set_evaluations(Option<Vec<Evaluation>>)`](crate::client::fluent_builders::PutEvaluations::set_evaluations): <p>The assessments that the Lambda function performs. Each evaluation identifies an Amazon Web Services resource and indicates whether it complies with the Config rule that invokes the Lambda function.</p>
    ///   - [`result_token(impl Into<String>)`](crate::client::fluent_builders::PutEvaluations::result_token) / [`set_result_token(Option<String>)`](crate::client::fluent_builders::PutEvaluations::set_result_token): <p>An encrypted token that associates an evaluation with an Config rule. Identifies the rule and the event that triggered the evaluation.</p>
    ///   - [`test_mode(bool)`](crate::client::fluent_builders::PutEvaluations::test_mode) / [`set_test_mode(bool)`](crate::client::fluent_builders::PutEvaluations::set_test_mode): <p>Use this parameter to specify a test run for <code>PutEvaluations</code>. You can verify whether your Lambda function will deliver evaluation results to Config. No updates occur to your existing evaluations, and evaluation results are not sent to Config.</p> <note>   <p>When <code>TestMode</code> is <code>true</code>, <code>PutEvaluations</code> doesn't require a valid value for the <code>ResultToken</code> parameter, but the value cannot be null.</p>  </note>
    /// - On success, responds with [`PutEvaluationsOutput`](crate::output::PutEvaluationsOutput) with field(s):
    ///   - [`failed_evaluations(Option<Vec<Evaluation>>)`](crate::output::PutEvaluationsOutput::failed_evaluations): <p>Requests that failed because of a client or server error.</p>
    /// - On failure, responds with [`SdkError<PutEvaluationsError>`](crate::error::PutEvaluationsError)
    pub fn put_evaluations(&self) -> fluent_builders::PutEvaluations {
        fluent_builders::PutEvaluations::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`PutExternalEvaluation`](crate::client::fluent_builders::PutExternalEvaluation) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`config_rule_name(impl Into<String>)`](crate::client::fluent_builders::PutExternalEvaluation::config_rule_name) / [`set_config_rule_name(Option<String>)`](crate::client::fluent_builders::PutExternalEvaluation::set_config_rule_name): <p>The name of the Config rule.</p>
    ///   - [`external_evaluation(ExternalEvaluation)`](crate::client::fluent_builders::PutExternalEvaluation::external_evaluation) / [`set_external_evaluation(Option<ExternalEvaluation>)`](crate::client::fluent_builders::PutExternalEvaluation::set_external_evaluation): <p>An <code>ExternalEvaluation</code> object that provides details about compliance.</p>
    /// - On success, responds with [`PutExternalEvaluationOutput`](crate::output::PutExternalEvaluationOutput)

    /// - On failure, responds with [`SdkError<PutExternalEvaluationError>`](crate::error::PutExternalEvaluationError)
    pub fn put_external_evaluation(&self) -> fluent_builders::PutExternalEvaluation {
        fluent_builders::PutExternalEvaluation::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`PutOrganizationConfigRule`](crate::client::fluent_builders::PutOrganizationConfigRule) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`organization_config_rule_name(impl Into<String>)`](crate::client::fluent_builders::PutOrganizationConfigRule::organization_config_rule_name) / [`set_organization_config_rule_name(Option<String>)`](crate::client::fluent_builders::PutOrganizationConfigRule::set_organization_config_rule_name): <p>The name that you assign to an organization config rule.</p>
    ///   - [`organization_managed_rule_metadata(OrganizationManagedRuleMetadata)`](crate::client::fluent_builders::PutOrganizationConfigRule::organization_managed_rule_metadata) / [`set_organization_managed_rule_metadata(Option<OrganizationManagedRuleMetadata>)`](crate::client::fluent_builders::PutOrganizationConfigRule::set_organization_managed_rule_metadata): <p>An <code>OrganizationManagedRuleMetadata</code> object. </p>
    ///   - [`organization_custom_rule_metadata(OrganizationCustomRuleMetadata)`](crate::client::fluent_builders::PutOrganizationConfigRule::organization_custom_rule_metadata) / [`set_organization_custom_rule_metadata(Option<OrganizationCustomRuleMetadata>)`](crate::client::fluent_builders::PutOrganizationConfigRule::set_organization_custom_rule_metadata): <p>An <code>OrganizationCustomRuleMetadata</code> object.</p>
    ///   - [`excluded_accounts(Vec<String>)`](crate::client::fluent_builders::PutOrganizationConfigRule::excluded_accounts) / [`set_excluded_accounts(Option<Vec<String>>)`](crate::client::fluent_builders::PutOrganizationConfigRule::set_excluded_accounts): <p>A comma-separated list of accounts that you want to exclude from an organization config rule.</p>
    /// - On success, responds with [`PutOrganizationConfigRuleOutput`](crate::output::PutOrganizationConfigRuleOutput) with field(s):
    ///   - [`organization_config_rule_arn(Option<String>)`](crate::output::PutOrganizationConfigRuleOutput::organization_config_rule_arn): <p>The Amazon Resource Name (ARN) of an organization config rule.</p>
    /// - On failure, responds with [`SdkError<PutOrganizationConfigRuleError>`](crate::error::PutOrganizationConfigRuleError)
    pub fn put_organization_config_rule(&self) -> fluent_builders::PutOrganizationConfigRule {
        fluent_builders::PutOrganizationConfigRule::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`PutOrganizationConformancePack`](crate::client::fluent_builders::PutOrganizationConformancePack) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`organization_conformance_pack_name(impl Into<String>)`](crate::client::fluent_builders::PutOrganizationConformancePack::organization_conformance_pack_name) / [`set_organization_conformance_pack_name(Option<String>)`](crate::client::fluent_builders::PutOrganizationConformancePack::set_organization_conformance_pack_name): <p>Name of the organization conformance pack you want to create.</p>
    ///   - [`template_s3_uri(impl Into<String>)`](crate::client::fluent_builders::PutOrganizationConformancePack::template_s3_uri) / [`set_template_s3_uri(Option<String>)`](crate::client::fluent_builders::PutOrganizationConformancePack::set_template_s3_uri): <p>Location of file containing the template body. The uri must point to the conformance pack template (max size: 300 KB).</p> <note>   <p>You must have access to read Amazon S3 bucket.</p>  </note>
    ///   - [`template_body(impl Into<String>)`](crate::client::fluent_builders::PutOrganizationConformancePack::template_body) / [`set_template_body(Option<String>)`](crate::client::fluent_builders::PutOrganizationConformancePack::set_template_body): <p>A string containing full conformance pack template body. Structure containing the template body with a minimum length of 1 byte and a maximum length of 51,200 bytes.</p>
    ///   - [`delivery_s3_bucket(impl Into<String>)`](crate::client::fluent_builders::PutOrganizationConformancePack::delivery_s3_bucket) / [`set_delivery_s3_bucket(Option<String>)`](crate::client::fluent_builders::PutOrganizationConformancePack::set_delivery_s3_bucket): <p>The name of the Amazon S3 bucket where Config stores conformance pack templates.</p> <note>   <p>This field is optional. If used, it must be prefixed with <code>awsconfigconforms</code>.</p>  </note>
    ///   - [`delivery_s3_key_prefix(impl Into<String>)`](crate::client::fluent_builders::PutOrganizationConformancePack::delivery_s3_key_prefix) / [`set_delivery_s3_key_prefix(Option<String>)`](crate::client::fluent_builders::PutOrganizationConformancePack::set_delivery_s3_key_prefix): <p>The prefix for the Amazon S3 bucket.</p> <note>   <p>This field is optional.</p>  </note>
    ///   - [`conformance_pack_input_parameters(Vec<ConformancePackInputParameter>)`](crate::client::fluent_builders::PutOrganizationConformancePack::conformance_pack_input_parameters) / [`set_conformance_pack_input_parameters(Option<Vec<ConformancePackInputParameter>>)`](crate::client::fluent_builders::PutOrganizationConformancePack::set_conformance_pack_input_parameters): <p>A list of <code>ConformancePackInputParameter</code> objects.</p>
    ///   - [`excluded_accounts(Vec<String>)`](crate::client::fluent_builders::PutOrganizationConformancePack::excluded_accounts) / [`set_excluded_accounts(Option<Vec<String>>)`](crate::client::fluent_builders::PutOrganizationConformancePack::set_excluded_accounts): <p>A list of Amazon Web Services accounts to be excluded from an organization conformance pack while deploying a conformance pack.</p>
    /// - On success, responds with [`PutOrganizationConformancePackOutput`](crate::output::PutOrganizationConformancePackOutput) with field(s):
    ///   - [`organization_conformance_pack_arn(Option<String>)`](crate::output::PutOrganizationConformancePackOutput::organization_conformance_pack_arn): <p>ARN of the organization conformance pack.</p>
    /// - On failure, responds with [`SdkError<PutOrganizationConformancePackError>`](crate::error::PutOrganizationConformancePackError)
    pub fn put_organization_conformance_pack(
        &self,
    ) -> fluent_builders::PutOrganizationConformancePack {
        fluent_builders::PutOrganizationConformancePack::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`PutRemediationConfigurations`](crate::client::fluent_builders::PutRemediationConfigurations) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`remediation_configurations(Vec<RemediationConfiguration>)`](crate::client::fluent_builders::PutRemediationConfigurations::remediation_configurations) / [`set_remediation_configurations(Option<Vec<RemediationConfiguration>>)`](crate::client::fluent_builders::PutRemediationConfigurations::set_remediation_configurations): <p>A list of remediation configuration objects.</p>
    /// - On success, responds with [`PutRemediationConfigurationsOutput`](crate::output::PutRemediationConfigurationsOutput) with field(s):
    ///   - [`failed_batches(Option<Vec<FailedRemediationBatch>>)`](crate::output::PutRemediationConfigurationsOutput::failed_batches): <p>Returns a list of failed remediation batch objects.</p>
    /// - On failure, responds with [`SdkError<PutRemediationConfigurationsError>`](crate::error::PutRemediationConfigurationsError)
    pub fn put_remediation_configurations(&self) -> fluent_builders::PutRemediationConfigurations {
        fluent_builders::PutRemediationConfigurations::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`PutRemediationExceptions`](crate::client::fluent_builders::PutRemediationExceptions) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`config_rule_name(impl Into<String>)`](crate::client::fluent_builders::PutRemediationExceptions::config_rule_name) / [`set_config_rule_name(Option<String>)`](crate::client::fluent_builders::PutRemediationExceptions::set_config_rule_name): <p>The name of the Config rule for which you want to create remediation exception.</p>
    ///   - [`resource_keys(Vec<RemediationExceptionResourceKey>)`](crate::client::fluent_builders::PutRemediationExceptions::resource_keys) / [`set_resource_keys(Option<Vec<RemediationExceptionResourceKey>>)`](crate::client::fluent_builders::PutRemediationExceptions::set_resource_keys): <p>An exception list of resource exception keys to be processed with the current request. Config adds exception for each resource key. For example, Config adds 3 exceptions for 3 resource keys. </p>
    ///   - [`message(impl Into<String>)`](crate::client::fluent_builders::PutRemediationExceptions::message) / [`set_message(Option<String>)`](crate::client::fluent_builders::PutRemediationExceptions::set_message): <p>The message contains an explanation of the exception.</p>
    ///   - [`expiration_time(DateTime)`](crate::client::fluent_builders::PutRemediationExceptions::expiration_time) / [`set_expiration_time(Option<DateTime>)`](crate::client::fluent_builders::PutRemediationExceptions::set_expiration_time): <p>The exception is automatically deleted after the expiration date.</p>
    /// - On success, responds with [`PutRemediationExceptionsOutput`](crate::output::PutRemediationExceptionsOutput) with field(s):
    ///   - [`failed_batches(Option<Vec<FailedRemediationExceptionBatch>>)`](crate::output::PutRemediationExceptionsOutput::failed_batches): <p>Returns a list of failed remediation exceptions batch objects. Each object in the batch consists of a list of failed items and failure messages.</p>
    /// - On failure, responds with [`SdkError<PutRemediationExceptionsError>`](crate::error::PutRemediationExceptionsError)
    pub fn put_remediation_exceptions(&self) -> fluent_builders::PutRemediationExceptions {
        fluent_builders::PutRemediationExceptions::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`PutResourceConfig`](crate::client::fluent_builders::PutResourceConfig) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`resource_type(impl Into<String>)`](crate::client::fluent_builders::PutResourceConfig::resource_type) / [`set_resource_type(Option<String>)`](crate::client::fluent_builders::PutResourceConfig::set_resource_type): <p>The type of the resource. The custom resource type must be registered with CloudFormation. </p> <note>   <p>You cannot use the organization names “amzn”, “amazon”, “alexa”, “custom” with custom resource types. It is the first part of the ResourceType up to the first ::.</p>  </note>
    ///   - [`schema_version_id(impl Into<String>)`](crate::client::fluent_builders::PutResourceConfig::schema_version_id) / [`set_schema_version_id(Option<String>)`](crate::client::fluent_builders::PutResourceConfig::set_schema_version_id): <p>Version of the schema registered for the ResourceType in CloudFormation.</p>
    ///   - [`resource_id(impl Into<String>)`](crate::client::fluent_builders::PutResourceConfig::resource_id) / [`set_resource_id(Option<String>)`](crate::client::fluent_builders::PutResourceConfig::set_resource_id): <p>Unique identifier of the resource.</p>
    ///   - [`resource_name(impl Into<String>)`](crate::client::fluent_builders::PutResourceConfig::resource_name) / [`set_resource_name(Option<String>)`](crate::client::fluent_builders::PutResourceConfig::set_resource_name): <p>Name of the resource.</p>
    ///   - [`configuration(impl Into<String>)`](crate::client::fluent_builders::PutResourceConfig::configuration) / [`set_configuration(Option<String>)`](crate::client::fluent_builders::PutResourceConfig::set_configuration): <p>The configuration object of the resource in valid JSON format. It must match the schema registered with CloudFormation.</p> <note>   <p>The configuration JSON must not exceed 64 KB.</p>  </note>
    ///   - [`tags(HashMap<String, String>)`](crate::client::fluent_builders::PutResourceConfig::tags) / [`set_tags(Option<HashMap<String, String>>)`](crate::client::fluent_builders::PutResourceConfig::set_tags): <p>Tags associated with the resource.</p>
    /// - On success, responds with [`PutResourceConfigOutput`](crate::output::PutResourceConfigOutput)

    /// - On failure, responds with [`SdkError<PutResourceConfigError>`](crate::error::PutResourceConfigError)
    pub fn put_resource_config(&self) -> fluent_builders::PutResourceConfig {
        fluent_builders::PutResourceConfig::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`PutRetentionConfiguration`](crate::client::fluent_builders::PutRetentionConfiguration) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`retention_period_in_days(i32)`](crate::client::fluent_builders::PutRetentionConfiguration::retention_period_in_days) / [`set_retention_period_in_days(i32)`](crate::client::fluent_builders::PutRetentionConfiguration::set_retention_period_in_days): <p>Number of days Config stores your historical information.</p> <note>   <p>Currently, only applicable to the configuration item history.</p>  </note>
    /// - On success, responds with [`PutRetentionConfigurationOutput`](crate::output::PutRetentionConfigurationOutput) with field(s):
    ///   - [`retention_configuration(Option<RetentionConfiguration>)`](crate::output::PutRetentionConfigurationOutput::retention_configuration): <p>Returns a retention configuration object.</p>
    /// - On failure, responds with [`SdkError<PutRetentionConfigurationError>`](crate::error::PutRetentionConfigurationError)
    pub fn put_retention_configuration(&self) -> fluent_builders::PutRetentionConfiguration {
        fluent_builders::PutRetentionConfiguration::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`PutStoredQuery`](crate::client::fluent_builders::PutStoredQuery) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`stored_query(StoredQuery)`](crate::client::fluent_builders::PutStoredQuery::stored_query) / [`set_stored_query(Option<StoredQuery>)`](crate::client::fluent_builders::PutStoredQuery::set_stored_query): <p>A list of <code>StoredQuery</code> objects. The mandatory fields are <code>QueryName</code> and <code>Expression</code>.</p> <note>   <p>When you are creating a query, you must provide a query name and an expression. When you are updating a query, you must provide a query name but updating the description is optional.</p>  </note>
    ///   - [`tags(Vec<Tag>)`](crate::client::fluent_builders::PutStoredQuery::tags) / [`set_tags(Option<Vec<Tag>>)`](crate::client::fluent_builders::PutStoredQuery::set_tags): <p>A list of <code>Tags</code> object.</p>
    /// - On success, responds with [`PutStoredQueryOutput`](crate::output::PutStoredQueryOutput) with field(s):
    ///   - [`query_arn(Option<String>)`](crate::output::PutStoredQueryOutput::query_arn): <p>Amazon Resource Name (ARN) of the query. For example, arn:partition:service:region:account-id:resource-type/resource-name/resource-id.</p>
    /// - On failure, responds with [`SdkError<PutStoredQueryError>`](crate::error::PutStoredQueryError)
    pub fn put_stored_query(&self) -> fluent_builders::PutStoredQuery {
        fluent_builders::PutStoredQuery::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`SelectAggregateResourceConfig`](crate::client::fluent_builders::SelectAggregateResourceConfig) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::SelectAggregateResourceConfig::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`expression(impl Into<String>)`](crate::client::fluent_builders::SelectAggregateResourceConfig::expression) / [`set_expression(Option<String>)`](crate::client::fluent_builders::SelectAggregateResourceConfig::set_expression): <p>The SQL query SELECT command. </p>
    ///   - [`configuration_aggregator_name(impl Into<String>)`](crate::client::fluent_builders::SelectAggregateResourceConfig::configuration_aggregator_name) / [`set_configuration_aggregator_name(Option<String>)`](crate::client::fluent_builders::SelectAggregateResourceConfig::set_configuration_aggregator_name): <p>The name of the configuration aggregator.</p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::SelectAggregateResourceConfig::limit) / [`set_limit(i32)`](crate::client::fluent_builders::SelectAggregateResourceConfig::set_limit): <p>The maximum number of query results returned on each page. </p>
    ///   - [`max_results(i32)`](crate::client::fluent_builders::SelectAggregateResourceConfig::max_results) / [`set_max_results(i32)`](crate::client::fluent_builders::SelectAggregateResourceConfig::set_max_results): <p>The maximum number of query results returned on each page. Config also allows the Limit request parameter.</p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::SelectAggregateResourceConfig::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::SelectAggregateResourceConfig::set_next_token): <p>The nextToken string returned in a previous request that you use to request the next page of results in a paginated response. </p>
    /// - On success, responds with [`SelectAggregateResourceConfigOutput`](crate::output::SelectAggregateResourceConfigOutput) with field(s):
    ///   - [`results(Option<Vec<String>>)`](crate::output::SelectAggregateResourceConfigOutput::results): <p>Returns the results for the SQL query.</p>
    ///   - [`query_info(Option<QueryInfo>)`](crate::output::SelectAggregateResourceConfigOutput::query_info): <p>Details about the query.</p>
    ///   - [`next_token(Option<String>)`](crate::output::SelectAggregateResourceConfigOutput::next_token): <p>The nextToken string returned in a previous request that you use to request the next page of results in a paginated response. </p>
    /// - On failure, responds with [`SdkError<SelectAggregateResourceConfigError>`](crate::error::SelectAggregateResourceConfigError)
    pub fn select_aggregate_resource_config(
        &self,
    ) -> fluent_builders::SelectAggregateResourceConfig {
        fluent_builders::SelectAggregateResourceConfig::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`SelectResourceConfig`](crate::client::fluent_builders::SelectResourceConfig) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::client::fluent_builders::SelectResourceConfig::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`expression(impl Into<String>)`](crate::client::fluent_builders::SelectResourceConfig::expression) / [`set_expression(Option<String>)`](crate::client::fluent_builders::SelectResourceConfig::set_expression): <p>The SQL query <code>SELECT</code> command.</p>
    ///   - [`limit(i32)`](crate::client::fluent_builders::SelectResourceConfig::limit) / [`set_limit(i32)`](crate::client::fluent_builders::SelectResourceConfig::set_limit): <p>The maximum number of query results returned on each page. </p>
    ///   - [`next_token(impl Into<String>)`](crate::client::fluent_builders::SelectResourceConfig::next_token) / [`set_next_token(Option<String>)`](crate::client::fluent_builders::SelectResourceConfig::set_next_token): <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response. </p>
    /// - On success, responds with [`SelectResourceConfigOutput`](crate::output::SelectResourceConfigOutput) with field(s):
    ///   - [`results(Option<Vec<String>>)`](crate::output::SelectResourceConfigOutput::results): <p>Returns the results for the SQL query.</p>
    ///   - [`query_info(Option<QueryInfo>)`](crate::output::SelectResourceConfigOutput::query_info): <p>Returns the <code>QueryInfo</code> object.</p>
    ///   - [`next_token(Option<String>)`](crate::output::SelectResourceConfigOutput::next_token): <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response. </p>
    /// - On failure, responds with [`SdkError<SelectResourceConfigError>`](crate::error::SelectResourceConfigError)
    pub fn select_resource_config(&self) -> fluent_builders::SelectResourceConfig {
        fluent_builders::SelectResourceConfig::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`StartConfigRulesEvaluation`](crate::client::fluent_builders::StartConfigRulesEvaluation) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`config_rule_names(Vec<String>)`](crate::client::fluent_builders::StartConfigRulesEvaluation::config_rule_names) / [`set_config_rule_names(Option<Vec<String>>)`](crate::client::fluent_builders::StartConfigRulesEvaluation::set_config_rule_names): <p>The list of names of Config rules that you want to run evaluations for.</p>
    /// - On success, responds with [`StartConfigRulesEvaluationOutput`](crate::output::StartConfigRulesEvaluationOutput)

    /// - On failure, responds with [`SdkError<StartConfigRulesEvaluationError>`](crate::error::StartConfigRulesEvaluationError)
    pub fn start_config_rules_evaluation(&self) -> fluent_builders::StartConfigRulesEvaluation {
        fluent_builders::StartConfigRulesEvaluation::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`StartConfigurationRecorder`](crate::client::fluent_builders::StartConfigurationRecorder) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`configuration_recorder_name(impl Into<String>)`](crate::client::fluent_builders::StartConfigurationRecorder::configuration_recorder_name) / [`set_configuration_recorder_name(Option<String>)`](crate::client::fluent_builders::StartConfigurationRecorder::set_configuration_recorder_name): <p>The name of the recorder object that records each configuration change made to the resources.</p>
    /// - On success, responds with [`StartConfigurationRecorderOutput`](crate::output::StartConfigurationRecorderOutput)

    /// - On failure, responds with [`SdkError<StartConfigurationRecorderError>`](crate::error::StartConfigurationRecorderError)
    pub fn start_configuration_recorder(&self) -> fluent_builders::StartConfigurationRecorder {
        fluent_builders::StartConfigurationRecorder::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`StartRemediationExecution`](crate::client::fluent_builders::StartRemediationExecution) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`config_rule_name(impl Into<String>)`](crate::client::fluent_builders::StartRemediationExecution::config_rule_name) / [`set_config_rule_name(Option<String>)`](crate::client::fluent_builders::StartRemediationExecution::set_config_rule_name): <p>The list of names of Config rules that you want to run remediation execution for.</p>
    ///   - [`resource_keys(Vec<ResourceKey>)`](crate::client::fluent_builders::StartRemediationExecution::resource_keys) / [`set_resource_keys(Option<Vec<ResourceKey>>)`](crate::client::fluent_builders::StartRemediationExecution::set_resource_keys): <p>A list of resource keys to be processed with the current request. Each element in the list consists of the resource type and resource ID. </p>
    /// - On success, responds with [`StartRemediationExecutionOutput`](crate::output::StartRemediationExecutionOutput) with field(s):
    ///   - [`failure_message(Option<String>)`](crate::output::StartRemediationExecutionOutput::failure_message): <p>Returns a failure message. For example, the resource is already compliant.</p>
    ///   - [`failed_items(Option<Vec<ResourceKey>>)`](crate::output::StartRemediationExecutionOutput::failed_items): <p>For resources that have failed to start execution, the API returns a resource key object.</p>
    /// - On failure, responds with [`SdkError<StartRemediationExecutionError>`](crate::error::StartRemediationExecutionError)
    pub fn start_remediation_execution(&self) -> fluent_builders::StartRemediationExecution {
        fluent_builders::StartRemediationExecution::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`StopConfigurationRecorder`](crate::client::fluent_builders::StopConfigurationRecorder) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`configuration_recorder_name(impl Into<String>)`](crate::client::fluent_builders::StopConfigurationRecorder::configuration_recorder_name) / [`set_configuration_recorder_name(Option<String>)`](crate::client::fluent_builders::StopConfigurationRecorder::set_configuration_recorder_name): <p>The name of the recorder object that records each configuration change made to the resources.</p>
    /// - On success, responds with [`StopConfigurationRecorderOutput`](crate::output::StopConfigurationRecorderOutput)

    /// - On failure, responds with [`SdkError<StopConfigurationRecorderError>`](crate::error::StopConfigurationRecorderError)
    pub fn stop_configuration_recorder(&self) -> fluent_builders::StopConfigurationRecorder {
        fluent_builders::StopConfigurationRecorder::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`TagResource`](crate::client::fluent_builders::TagResource) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`resource_arn(impl Into<String>)`](crate::client::fluent_builders::TagResource::resource_arn) / [`set_resource_arn(Option<String>)`](crate::client::fluent_builders::TagResource::set_resource_arn): <p>The Amazon Resource Name (ARN) that identifies the resource for which to list the tags. Currently, the supported resources are <code>ConfigRule</code>, <code>ConfigurationAggregator</code> and <code>AggregatorAuthorization</code>.</p>
    ///   - [`tags(Vec<Tag>)`](crate::client::fluent_builders::TagResource::tags) / [`set_tags(Option<Vec<Tag>>)`](crate::client::fluent_builders::TagResource::set_tags): <p>An array of tag object.</p>
    /// - On success, responds with [`TagResourceOutput`](crate::output::TagResourceOutput)

    /// - On failure, responds with [`SdkError<TagResourceError>`](crate::error::TagResourceError)
    pub fn tag_resource(&self) -> fluent_builders::TagResource {
        fluent_builders::TagResource::new(self.handle.clone())
    }
    /// Constructs a fluent builder for the [`UntagResource`](crate::client::fluent_builders::UntagResource) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`resource_arn(impl Into<String>)`](crate::client::fluent_builders::UntagResource::resource_arn) / [`set_resource_arn(Option<String>)`](crate::client::fluent_builders::UntagResource::set_resource_arn): <p>The Amazon Resource Name (ARN) that identifies the resource for which to list the tags. Currently, the supported resources are <code>ConfigRule</code>, <code>ConfigurationAggregator</code> and <code>AggregatorAuthorization</code>.</p>
    ///   - [`tag_keys(Vec<String>)`](crate::client::fluent_builders::UntagResource::tag_keys) / [`set_tag_keys(Option<Vec<String>>)`](crate::client::fluent_builders::UntagResource::set_tag_keys): <p>The keys of the tags to be removed.</p>
    /// - On success, responds with [`UntagResourceOutput`](crate::output::UntagResourceOutput)

    /// - On failure, responds with [`SdkError<UntagResourceError>`](crate::error::UntagResourceError)
    pub fn untag_resource(&self) -> fluent_builders::UntagResource {
        fluent_builders::UntagResource::new(self.handle.clone())
    }
}
pub mod fluent_builders {
    //!
    //! Utilities to ergonomically construct a request to the service.
    //!
    //! Fluent builders are created through the [`Client`](crate::client::Client) by calling
    //! one if its operation methods. After parameters are set using the builder methods,
    //! the `send` method can be called to initiate the request.
    //!
    /// Fluent builder constructing a request to `BatchGetAggregateResourceConfig`.
    ///
    /// <p>Returns the current configuration items for resources that are present in your Config aggregator. The operation also returns a list of resources that are not processed in the current request. If there are no unprocessed resources, the operation returns an empty <code>unprocessedResourceIdentifiers</code> list. </p> <note>
    /// <ul>
    /// <li> <p>The API does not return results for deleted resources.</p> </li>
    /// <li> <p> The API does not return tags and relationships.</p> </li>
    /// </ul>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct BatchGetAggregateResourceConfig {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::batch_get_aggregate_resource_config_input::Builder,
    }
    impl BatchGetAggregateResourceConfig {
        /// Creates a new `BatchGetAggregateResourceConfig`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::BatchGetAggregateResourceConfigOutput,
            aws_smithy_http::result::SdkError<crate::error::BatchGetAggregateResourceConfigError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn configuration_aggregator_name(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(input.into());
            self
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
        /// Appends an item to `ResourceIdentifiers`.
        ///
        /// To override the contents of this collection use [`set_resource_identifiers`](Self::set_resource_identifiers).
        ///
        /// <p>A list of aggregate ResourceIdentifiers objects. </p>
        pub fn resource_identifiers(
            mut self,
            input: crate::model::AggregateResourceIdentifier,
        ) -> Self {
            self.inner = self.inner.resource_identifiers(input);
            self
        }
        /// <p>A list of aggregate ResourceIdentifiers objects. </p>
        pub fn set_resource_identifiers(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::AggregateResourceIdentifier>>,
        ) -> Self {
            self.inner = self.inner.set_resource_identifiers(input);
            self
        }
    }
    /// Fluent builder constructing a request to `BatchGetResourceConfig`.
    ///
    /// <p>Returns the <code>BaseConfigurationItem</code> for one or more requested resources. The operation also returns a list of resources that are not processed in the current request. If there are no unprocessed resources, the operation returns an empty unprocessedResourceKeys list. </p> <note>
    /// <ul>
    /// <li> <p>The API does not return results for deleted resources.</p> </li>
    /// <li> <p> The API does not return any tags for the requested resources. This information is filtered out of the supplementaryConfiguration section of the API response.</p> </li>
    /// </ul>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct BatchGetResourceConfig {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::batch_get_resource_config_input::Builder,
    }
    impl BatchGetResourceConfig {
        /// Creates a new `BatchGetResourceConfig`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::BatchGetResourceConfigOutput,
            aws_smithy_http::result::SdkError<crate::error::BatchGetResourceConfigError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `resourceKeys`.
        ///
        /// To override the contents of this collection use [`set_resource_keys`](Self::set_resource_keys).
        ///
        /// <p>A list of resource keys to be processed with the current request. Each element in the list consists of the resource type and resource ID.</p>
        pub fn resource_keys(mut self, input: crate::model::ResourceKey) -> Self {
            self.inner = self.inner.resource_keys(input);
            self
        }
        /// <p>A list of resource keys to be processed with the current request. Each element in the list consists of the resource type and resource ID.</p>
        pub fn set_resource_keys(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ResourceKey>>,
        ) -> Self {
            self.inner = self.inner.set_resource_keys(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DeleteAggregationAuthorization`.
    ///
    /// <p>Deletes the authorization granted to the specified configuration aggregator account in a specified region.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DeleteAggregationAuthorization {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::delete_aggregation_authorization_input::Builder,
    }
    impl DeleteAggregationAuthorization {
        /// Creates a new `DeleteAggregationAuthorization`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteAggregationAuthorizationOutput,
            aws_smithy_http::result::SdkError<crate::error::DeleteAggregationAuthorizationError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The 12-digit account ID of the account authorized to aggregate data.</p>
        pub fn authorized_account_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.authorized_account_id(input.into());
            self
        }
        /// <p>The 12-digit account ID of the account authorized to aggregate data.</p>
        pub fn set_authorized_account_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_authorized_account_id(input);
            self
        }
        /// <p>The region authorized to collect aggregated data.</p>
        pub fn authorized_aws_region(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.authorized_aws_region(input.into());
            self
        }
        /// <p>The region authorized to collect aggregated data.</p>
        pub fn set_authorized_aws_region(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_authorized_aws_region(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DeleteConfigRule`.
    ///
    /// <p>Deletes the specified Config rule and all of its evaluation results.</p>
    /// <p>Config sets the state of a rule to <code>DELETING</code> until the deletion is complete. You cannot update a rule while it is in this state. If you make a <code>PutConfigRule</code> or <code>DeleteConfigRule</code> request for the rule, you will receive a <code>ResourceInUseException</code>.</p>
    /// <p>You can check the state of a rule by using the <code>DescribeConfigRules</code> request.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DeleteConfigRule {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::delete_config_rule_input::Builder,
    }
    impl DeleteConfigRule {
        /// Creates a new `DeleteConfigRule`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteConfigRuleOutput,
            aws_smithy_http::result::SdkError<crate::error::DeleteConfigRuleError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the Config rule that you want to delete.</p>
        pub fn config_rule_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_name(input.into());
            self
        }
        /// <p>The name of the Config rule that you want to delete.</p>
        pub fn set_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_name(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DeleteConfigurationAggregator`.
    ///
    /// <p>Deletes the specified configuration aggregator and the aggregated data associated with the aggregator.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DeleteConfigurationAggregator {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::delete_configuration_aggregator_input::Builder,
    }
    impl DeleteConfigurationAggregator {
        /// Creates a new `DeleteConfigurationAggregator`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteConfigurationAggregatorOutput,
            aws_smithy_http::result::SdkError<crate::error::DeleteConfigurationAggregatorError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn configuration_aggregator_name(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(input.into());
            self
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DeleteConfigurationRecorder`.
    ///
    /// <p>Deletes the configuration recorder.</p>
    /// <p>After the configuration recorder is deleted, Config will not record resource configuration changes until you create a new configuration recorder.</p>
    /// <p>This action does not delete the configuration information that was previously recorded. You will be able to access the previously recorded information by using the <code>GetResourceConfigHistory</code> action, but you will not be able to access this information in the Config console until you create a new configuration recorder.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DeleteConfigurationRecorder {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::delete_configuration_recorder_input::Builder,
    }
    impl DeleteConfigurationRecorder {
        /// Creates a new `DeleteConfigurationRecorder`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteConfigurationRecorderOutput,
            aws_smithy_http::result::SdkError<crate::error::DeleteConfigurationRecorderError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the configuration recorder to be deleted. You can retrieve the name of your configuration recorder by using the <code>DescribeConfigurationRecorders</code> action.</p>
        pub fn configuration_recorder_name(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_recorder_name(input.into());
            self
        }
        /// <p>The name of the configuration recorder to be deleted. You can retrieve the name of your configuration recorder by using the <code>DescribeConfigurationRecorders</code> action.</p>
        pub fn set_configuration_recorder_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_recorder_name(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DeleteConformancePack`.
    ///
    /// <p>Deletes the specified conformance pack and all the Config rules, remediation actions, and all evaluation results within that conformance pack.</p>
    /// <p>Config sets the conformance pack to <code>DELETE_IN_PROGRESS</code> until the deletion is complete. You cannot update a conformance pack while it is in this state.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DeleteConformancePack {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::delete_conformance_pack_input::Builder,
    }
    impl DeleteConformancePack {
        /// Creates a new `DeleteConformancePack`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteConformancePackOutput,
            aws_smithy_http::result::SdkError<crate::error::DeleteConformancePackError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>Name of the conformance pack you want to delete.</p>
        pub fn conformance_pack_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.conformance_pack_name(input.into());
            self
        }
        /// <p>Name of the conformance pack you want to delete.</p>
        pub fn set_conformance_pack_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_conformance_pack_name(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DeleteDeliveryChannel`.
    ///
    /// <p>Deletes the delivery channel.</p>
    /// <p>Before you can delete the delivery channel, you must stop the configuration recorder by using the <code>StopConfigurationRecorder</code> action.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DeleteDeliveryChannel {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::delete_delivery_channel_input::Builder,
    }
    impl DeleteDeliveryChannel {
        /// Creates a new `DeleteDeliveryChannel`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteDeliveryChannelOutput,
            aws_smithy_http::result::SdkError<crate::error::DeleteDeliveryChannelError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the delivery channel to delete.</p>
        pub fn delivery_channel_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.delivery_channel_name(input.into());
            self
        }
        /// <p>The name of the delivery channel to delete.</p>
        pub fn set_delivery_channel_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_delivery_channel_name(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DeleteEvaluationResults`.
    ///
    /// <p>Deletes the evaluation results for the specified Config rule. You can specify one Config rule per request. After you delete the evaluation results, you can call the <code>StartConfigRulesEvaluation</code> API to start evaluating your Amazon Web Services resources against the rule.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DeleteEvaluationResults {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::delete_evaluation_results_input::Builder,
    }
    impl DeleteEvaluationResults {
        /// Creates a new `DeleteEvaluationResults`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteEvaluationResultsOutput,
            aws_smithy_http::result::SdkError<crate::error::DeleteEvaluationResultsError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the Config rule for which you want to delete the evaluation results.</p>
        pub fn config_rule_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_name(input.into());
            self
        }
        /// <p>The name of the Config rule for which you want to delete the evaluation results.</p>
        pub fn set_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_name(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DeleteOrganizationConfigRule`.
    ///
    /// <p>Deletes the specified organization config rule and all of its evaluation results from all member accounts in that organization. </p>
    /// <p>Only a master account and a delegated administrator account can delete an organization config rule. When calling this API with a delegated administrator, you must ensure Organizations <code>ListDelegatedAdministrator</code> permissions are added.</p>
    /// <p>Config sets the state of a rule to DELETE_IN_PROGRESS until the deletion is complete. You cannot update a rule while it is in this state.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DeleteOrganizationConfigRule {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::delete_organization_config_rule_input::Builder,
    }
    impl DeleteOrganizationConfigRule {
        /// Creates a new `DeleteOrganizationConfigRule`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteOrganizationConfigRuleOutput,
            aws_smithy_http::result::SdkError<crate::error::DeleteOrganizationConfigRuleError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The name of organization config rule that you want to delete.</p>
        pub fn organization_config_rule_name(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.organization_config_rule_name(input.into());
            self
        }
        /// <p>The name of organization config rule that you want to delete.</p>
        pub fn set_organization_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_organization_config_rule_name(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DeleteOrganizationConformancePack`.
    ///
    /// <p>Deletes the specified organization conformance pack and all of the config rules and remediation actions from all member accounts in that organization. </p>
    /// <p> Only a master account or a delegated administrator account can delete an organization conformance pack. When calling this API with a delegated administrator, you must ensure Organizations <code>ListDelegatedAdministrator</code> permissions are added.</p>
    /// <p>Config sets the state of a conformance pack to DELETE_IN_PROGRESS until the deletion is complete. You cannot update a conformance pack while it is in this state. </p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DeleteOrganizationConformancePack {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::delete_organization_conformance_pack_input::Builder,
    }
    impl DeleteOrganizationConformancePack {
        /// Creates a new `DeleteOrganizationConformancePack`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteOrganizationConformancePackOutput,
            aws_smithy_http::result::SdkError<crate::error::DeleteOrganizationConformancePackError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The name of organization conformance pack that you want to delete.</p>
        pub fn organization_conformance_pack_name(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.organization_conformance_pack_name(input.into());
            self
        }
        /// <p>The name of organization conformance pack that you want to delete.</p>
        pub fn set_organization_conformance_pack_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_organization_conformance_pack_name(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DeletePendingAggregationRequest`.
    ///
    /// <p>Deletes pending authorization requests for a specified aggregator account in a specified region.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DeletePendingAggregationRequest {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::delete_pending_aggregation_request_input::Builder,
    }
    impl DeletePendingAggregationRequest {
        /// Creates a new `DeletePendingAggregationRequest`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeletePendingAggregationRequestOutput,
            aws_smithy_http::result::SdkError<crate::error::DeletePendingAggregationRequestError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The 12-digit account ID of the account requesting to aggregate data.</p>
        pub fn requester_account_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.requester_account_id(input.into());
            self
        }
        /// <p>The 12-digit account ID of the account requesting to aggregate data.</p>
        pub fn set_requester_account_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_requester_account_id(input);
            self
        }
        /// <p>The region requesting to aggregate data.</p>
        pub fn requester_aws_region(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.requester_aws_region(input.into());
            self
        }
        /// <p>The region requesting to aggregate data.</p>
        pub fn set_requester_aws_region(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_requester_aws_region(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DeleteRemediationConfiguration`.
    ///
    /// <p>Deletes the remediation configuration.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DeleteRemediationConfiguration {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::delete_remediation_configuration_input::Builder,
    }
    impl DeleteRemediationConfiguration {
        /// Creates a new `DeleteRemediationConfiguration`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteRemediationConfigurationOutput,
            aws_smithy_http::result::SdkError<crate::error::DeleteRemediationConfigurationError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the Config rule for which you want to delete remediation configuration.</p>
        pub fn config_rule_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_name(input.into());
            self
        }
        /// <p>The name of the Config rule for which you want to delete remediation configuration.</p>
        pub fn set_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_name(input);
            self
        }
        /// <p>The type of a resource.</p>
        pub fn resource_type(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_type(input.into());
            self
        }
        /// <p>The type of a resource.</p>
        pub fn set_resource_type(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_resource_type(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DeleteRemediationExceptions`.
    ///
    /// <p>Deletes one or more remediation exceptions mentioned in the resource keys.</p> <note>
    /// <p>Config generates a remediation exception when a problem occurs executing a remediation action to a specific resource. Remediation exceptions blocks auto-remediation until the exception is cleared.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DeleteRemediationExceptions {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::delete_remediation_exceptions_input::Builder,
    }
    impl DeleteRemediationExceptions {
        /// Creates a new `DeleteRemediationExceptions`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteRemediationExceptionsOutput,
            aws_smithy_http::result::SdkError<crate::error::DeleteRemediationExceptionsError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the Config rule for which you want to delete remediation exception configuration.</p>
        pub fn config_rule_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_name(input.into());
            self
        }
        /// <p>The name of the Config rule for which you want to delete remediation exception configuration.</p>
        pub fn set_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_name(input);
            self
        }
        /// Appends an item to `ResourceKeys`.
        ///
        /// To override the contents of this collection use [`set_resource_keys`](Self::set_resource_keys).
        ///
        /// <p>An exception list of resource exception keys to be processed with the current request. Config adds exception for each resource key. For example, Config adds 3 exceptions for 3 resource keys. </p>
        pub fn resource_keys(
            mut self,
            input: crate::model::RemediationExceptionResourceKey,
        ) -> Self {
            self.inner = self.inner.resource_keys(input);
            self
        }
        /// <p>An exception list of resource exception keys to be processed with the current request. Config adds exception for each resource key. For example, Config adds 3 exceptions for 3 resource keys. </p>
        pub fn set_resource_keys(
            mut self,
            input: std::option::Option<
                std::vec::Vec<crate::model::RemediationExceptionResourceKey>,
            >,
        ) -> Self {
            self.inner = self.inner.set_resource_keys(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DeleteResourceConfig`.
    ///
    /// <p>Records the configuration state for a custom resource that has been deleted. This API records a new ConfigurationItem with a ResourceDeleted status. You can retrieve the ConfigurationItems recorded for this resource in your Config History. </p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DeleteResourceConfig {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::delete_resource_config_input::Builder,
    }
    impl DeleteResourceConfig {
        /// Creates a new `DeleteResourceConfig`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteResourceConfigOutput,
            aws_smithy_http::result::SdkError<crate::error::DeleteResourceConfigError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The type of the resource.</p>
        pub fn resource_type(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_type(input.into());
            self
        }
        /// <p>The type of the resource.</p>
        pub fn set_resource_type(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_resource_type(input);
            self
        }
        /// <p>Unique identifier of the resource.</p>
        pub fn resource_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_id(input.into());
            self
        }
        /// <p>Unique identifier of the resource.</p>
        pub fn set_resource_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_resource_id(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DeleteRetentionConfiguration`.
    ///
    /// <p>Deletes the retention configuration.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DeleteRetentionConfiguration {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::delete_retention_configuration_input::Builder,
    }
    impl DeleteRetentionConfiguration {
        /// Creates a new `DeleteRetentionConfiguration`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteRetentionConfigurationOutput,
            aws_smithy_http::result::SdkError<crate::error::DeleteRetentionConfigurationError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the retention configuration to delete.</p>
        pub fn retention_configuration_name(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.retention_configuration_name(input.into());
            self
        }
        /// <p>The name of the retention configuration to delete.</p>
        pub fn set_retention_configuration_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_retention_configuration_name(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DeleteStoredQuery`.
    ///
    /// <p>Deletes the stored query for a single Amazon Web Services account and a single Amazon Web Services Region.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DeleteStoredQuery {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::delete_stored_query_input::Builder,
    }
    impl DeleteStoredQuery {
        /// Creates a new `DeleteStoredQuery`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteStoredQueryOutput,
            aws_smithy_http::result::SdkError<crate::error::DeleteStoredQueryError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the query that you want to delete.</p>
        pub fn query_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.query_name(input.into());
            self
        }
        /// <p>The name of the query that you want to delete.</p>
        pub fn set_query_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_query_name(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DeliverConfigSnapshot`.
    ///
    /// <p>Schedules delivery of a configuration snapshot to the Amazon S3 bucket in the specified delivery channel. After the delivery has started, Config sends the following notifications using an Amazon SNS topic that you have specified.</p>
    /// <ul>
    /// <li> <p>Notification of the start of the delivery.</p> </li>
    /// <li> <p>Notification of the completion of the delivery, if the delivery was successfully completed.</p> </li>
    /// <li> <p>Notification of delivery failure, if the delivery failed.</p> </li>
    /// </ul>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DeliverConfigSnapshot {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::deliver_config_snapshot_input::Builder,
    }
    impl DeliverConfigSnapshot {
        /// Creates a new `DeliverConfigSnapshot`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeliverConfigSnapshotOutput,
            aws_smithy_http::result::SdkError<crate::error::DeliverConfigSnapshotError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the delivery channel through which the snapshot is delivered.</p>
        pub fn delivery_channel_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.delivery_channel_name(input.into());
            self
        }
        /// <p>The name of the delivery channel through which the snapshot is delivered.</p>
        pub fn set_delivery_channel_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_delivery_channel_name(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DescribeAggregateComplianceByConfigRules`.
    ///
    /// <p>Returns a list of compliant and noncompliant rules with the number of resources for compliant and noncompliant rules. Does not display rules that do not have compliance results. </p> <note>
    /// <p>The results can return an empty result page, but if you have a <code>nextToken</code>, the results are displayed on the next page.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DescribeAggregateComplianceByConfigRules {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::describe_aggregate_compliance_by_config_rules_input::Builder,
    }
    impl DescribeAggregateComplianceByConfigRules {
        /// Creates a new `DescribeAggregateComplianceByConfigRules`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeAggregateComplianceByConfigRulesOutput,
            aws_smithy_http::result::SdkError<
                crate::error::DescribeAggregateComplianceByConfigRulesError,
            >,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::DescribeAggregateComplianceByConfigRulesPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(
            self,
        ) -> crate::paginator::DescribeAggregateComplianceByConfigRulesPaginator {
            crate::paginator::DescribeAggregateComplianceByConfigRulesPaginator::new(
                self.handle,
                self.inner,
            )
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn configuration_aggregator_name(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(input.into());
            self
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
        /// <p>Filters the results by ConfigRuleComplianceFilters object. </p>
        pub fn filters(mut self, input: crate::model::ConfigRuleComplianceFilters) -> Self {
            self.inner = self.inner.filters(input);
            self
        }
        /// <p>Filters the results by ConfigRuleComplianceFilters object. </p>
        pub fn set_filters(
            mut self,
            input: std::option::Option<crate::model::ConfigRuleComplianceFilters>,
        ) -> Self {
            self.inner = self.inner.set_filters(input);
            self
        }
        /// <p>The maximum number of evaluation results returned on each page. The default is maximum. If you specify 0, Config uses the default.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of evaluation results returned on each page. The default is maximum. If you specify 0, Config uses the default.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DescribeAggregateComplianceByConformancePacks`.
    ///
    /// <p>Returns a list of the conformance packs and their associated compliance status with the count of compliant and noncompliant Config rules within each conformance pack. Also returns the total rule count which includes compliant rules, noncompliant rules, and rules that cannot be evaluated due to insufficient data.</p> <note>
    /// <p>The results can return an empty result page, but if you have a <code>nextToken</code>, the results are displayed on the next page.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DescribeAggregateComplianceByConformancePacks {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::describe_aggregate_compliance_by_conformance_packs_input::Builder,
    }
    impl DescribeAggregateComplianceByConformancePacks {
        /// Creates a new `DescribeAggregateComplianceByConformancePacks`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeAggregateComplianceByConformancePacksOutput,
            aws_smithy_http::result::SdkError<
                crate::error::DescribeAggregateComplianceByConformancePacksError,
            >,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::DescribeAggregateComplianceByConformancePacksPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(
            self,
        ) -> crate::paginator::DescribeAggregateComplianceByConformancePacksPaginator {
            crate::paginator::DescribeAggregateComplianceByConformancePacksPaginator::new(
                self.handle,
                self.inner,
            )
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn configuration_aggregator_name(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(input.into());
            self
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
        /// <p>Filters the result by <code>AggregateConformancePackComplianceFilters</code> object.</p>
        pub fn filters(
            mut self,
            input: crate::model::AggregateConformancePackComplianceFilters,
        ) -> Self {
            self.inner = self.inner.filters(input);
            self
        }
        /// <p>Filters the result by <code>AggregateConformancePackComplianceFilters</code> object.</p>
        pub fn set_filters(
            mut self,
            input: std::option::Option<crate::model::AggregateConformancePackComplianceFilters>,
        ) -> Self {
            self.inner = self.inner.set_filters(input);
            self
        }
        /// <p>The maximum number of conformance packs compliance details returned on each page. The default is maximum. If you specify 0, Config uses the default. </p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of conformance packs compliance details returned on each page. The default is maximum. If you specify 0, Config uses the default. </p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DescribeAggregationAuthorizations`.
    ///
    /// <p>Returns a list of authorizations granted to various aggregator accounts and regions.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DescribeAggregationAuthorizations {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::describe_aggregation_authorizations_input::Builder,
    }
    impl DescribeAggregationAuthorizations {
        /// Creates a new `DescribeAggregationAuthorizations`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeAggregationAuthorizationsOutput,
            aws_smithy_http::result::SdkError<crate::error::DescribeAggregationAuthorizationsError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::DescribeAggregationAuthorizationsPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(
            self,
        ) -> crate::paginator::DescribeAggregationAuthorizationsPaginator {
            crate::paginator::DescribeAggregationAuthorizationsPaginator::new(
                self.handle,
                self.inner,
            )
        }
        /// <p>The maximum number of AggregationAuthorizations returned on each page. The default is maximum. If you specify 0, Config uses the default.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of AggregationAuthorizations returned on each page. The default is maximum. If you specify 0, Config uses the default.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DescribeComplianceByConfigRule`.
    ///
    /// <p>Indicates whether the specified Config rules are compliant. If a rule is noncompliant, this action returns the number of Amazon Web Services resources that do not comply with the rule.</p>
    /// <p>A rule is compliant if all of the evaluated resources comply with it. It is noncompliant if any of these resources do not comply.</p>
    /// <p>If Config has no current evaluation results for the rule, it returns <code>INSUFFICIENT_DATA</code>. This result might indicate one of the following conditions:</p>
    /// <ul>
    /// <li> <p>Config has never invoked an evaluation for the rule. To check whether it has, use the <code>DescribeConfigRuleEvaluationStatus</code> action to get the <code>LastSuccessfulInvocationTime</code> and <code>LastFailedInvocationTime</code>.</p> </li>
    /// <li> <p>The rule's Lambda function is failing to send evaluation results to Config. Verify that the role you assigned to your configuration recorder includes the <code>config:PutEvaluations</code> permission. If the rule is a custom rule, verify that the Lambda execution role includes the <code>config:PutEvaluations</code> permission.</p> </li>
    /// <li> <p>The rule's Lambda function has returned <code>NOT_APPLICABLE</code> for all evaluation results. This can occur if the resources were deleted or removed from the rule's scope.</p> </li>
    /// </ul>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DescribeComplianceByConfigRule {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::describe_compliance_by_config_rule_input::Builder,
    }
    impl DescribeComplianceByConfigRule {
        /// Creates a new `DescribeComplianceByConfigRule`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeComplianceByConfigRuleOutput,
            aws_smithy_http::result::SdkError<crate::error::DescribeComplianceByConfigRuleError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::DescribeComplianceByConfigRulePaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(self) -> crate::paginator::DescribeComplianceByConfigRulePaginator {
            crate::paginator::DescribeComplianceByConfigRulePaginator::new(self.handle, self.inner)
        }
        /// Appends an item to `ConfigRuleNames`.
        ///
        /// To override the contents of this collection use [`set_config_rule_names`](Self::set_config_rule_names).
        ///
        /// <p>Specify one or more Config rule names to filter the results by rule.</p>
        pub fn config_rule_names(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_names(input.into());
            self
        }
        /// <p>Specify one or more Config rule names to filter the results by rule.</p>
        pub fn set_config_rule_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_names(input);
            self
        }
        /// Appends an item to `ComplianceTypes`.
        ///
        /// To override the contents of this collection use [`set_compliance_types`](Self::set_compliance_types).
        ///
        /// <p>Filters the results by compliance.</p>
        /// <p>The allowed values are <code>COMPLIANT</code> and <code>NON_COMPLIANT</code>.</p>
        pub fn compliance_types(mut self, input: crate::model::ComplianceType) -> Self {
            self.inner = self.inner.compliance_types(input);
            self
        }
        /// <p>Filters the results by compliance.</p>
        /// <p>The allowed values are <code>COMPLIANT</code> and <code>NON_COMPLIANT</code>.</p>
        pub fn set_compliance_types(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ComplianceType>>,
        ) -> Self {
            self.inner = self.inner.set_compliance_types(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DescribeComplianceByResource`.
    ///
    /// <p>Indicates whether the specified Amazon Web Services resources are compliant. If a resource is noncompliant, this action returns the number of Config rules that the resource does not comply with.</p>
    /// <p>A resource is compliant if it complies with all the Config rules that evaluate it. It is noncompliant if it does not comply with one or more of these rules.</p>
    /// <p>If Config has no current evaluation results for the resource, it returns <code>INSUFFICIENT_DATA</code>. This result might indicate one of the following conditions about the rules that evaluate the resource:</p>
    /// <ul>
    /// <li> <p>Config has never invoked an evaluation for the rule. To check whether it has, use the <code>DescribeConfigRuleEvaluationStatus</code> action to get the <code>LastSuccessfulInvocationTime</code> and <code>LastFailedInvocationTime</code>.</p> </li>
    /// <li> <p>The rule's Lambda function is failing to send evaluation results to Config. Verify that the role that you assigned to your configuration recorder includes the <code>config:PutEvaluations</code> permission. If the rule is a custom rule, verify that the Lambda execution role includes the <code>config:PutEvaluations</code> permission.</p> </li>
    /// <li> <p>The rule's Lambda function has returned <code>NOT_APPLICABLE</code> for all evaluation results. This can occur if the resources were deleted or removed from the rule's scope.</p> </li>
    /// </ul>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DescribeComplianceByResource {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::describe_compliance_by_resource_input::Builder,
    }
    impl DescribeComplianceByResource {
        /// Creates a new `DescribeComplianceByResource`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeComplianceByResourceOutput,
            aws_smithy_http::result::SdkError<crate::error::DescribeComplianceByResourceError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::DescribeComplianceByResourcePaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(self) -> crate::paginator::DescribeComplianceByResourcePaginator {
            crate::paginator::DescribeComplianceByResourcePaginator::new(self.handle, self.inner)
        }
        /// <p>The types of Amazon Web Services resources for which you want compliance information (for example, <code>AWS::EC2::Instance</code>). For this action, you can specify that the resource type is an Amazon Web Services account by specifying <code>AWS::::Account</code>.</p>
        pub fn resource_type(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_type(input.into());
            self
        }
        /// <p>The types of Amazon Web Services resources for which you want compliance information (for example, <code>AWS::EC2::Instance</code>). For this action, you can specify that the resource type is an Amazon Web Services account by specifying <code>AWS::::Account</code>.</p>
        pub fn set_resource_type(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_resource_type(input);
            self
        }
        /// <p>The ID of the Amazon Web Services resource for which you want compliance information. You can specify only one resource ID. If you specify a resource ID, you must also specify a type for <code>ResourceType</code>.</p>
        pub fn resource_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_id(input.into());
            self
        }
        /// <p>The ID of the Amazon Web Services resource for which you want compliance information. You can specify only one resource ID. If you specify a resource ID, you must also specify a type for <code>ResourceType</code>.</p>
        pub fn set_resource_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_resource_id(input);
            self
        }
        /// Appends an item to `ComplianceTypes`.
        ///
        /// To override the contents of this collection use [`set_compliance_types`](Self::set_compliance_types).
        ///
        /// <p>Filters the results by compliance.</p>
        /// <p>The allowed values are <code>COMPLIANT</code>, <code>NON_COMPLIANT</code>, and <code>INSUFFICIENT_DATA</code>.</p>
        pub fn compliance_types(mut self, input: crate::model::ComplianceType) -> Self {
            self.inner = self.inner.compliance_types(input);
            self
        }
        /// <p>Filters the results by compliance.</p>
        /// <p>The allowed values are <code>COMPLIANT</code>, <code>NON_COMPLIANT</code>, and <code>INSUFFICIENT_DATA</code>.</p>
        pub fn set_compliance_types(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ComplianceType>>,
        ) -> Self {
            self.inner = self.inner.set_compliance_types(input);
            self
        }
        /// <p>The maximum number of evaluation results returned on each page. The default is 10. You cannot specify a number greater than 100. If you specify 0, Config uses the default.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of evaluation results returned on each page. The default is 10. You cannot specify a number greater than 100. If you specify 0, Config uses the default.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DescribeConfigRuleEvaluationStatus`.
    ///
    /// <p>Returns status information for each of your Config managed rules. The status includes information such as the last time Config invoked the rule, the last time Config failed to invoke the rule, and the related error for the last failure.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DescribeConfigRuleEvaluationStatus {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::describe_config_rule_evaluation_status_input::Builder,
    }
    impl DescribeConfigRuleEvaluationStatus {
        /// Creates a new `DescribeConfigRuleEvaluationStatus`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeConfigRuleEvaluationStatusOutput,
            aws_smithy_http::result::SdkError<
                crate::error::DescribeConfigRuleEvaluationStatusError,
            >,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::DescribeConfigRuleEvaluationStatusPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(
            self,
        ) -> crate::paginator::DescribeConfigRuleEvaluationStatusPaginator {
            crate::paginator::DescribeConfigRuleEvaluationStatusPaginator::new(
                self.handle,
                self.inner,
            )
        }
        /// Appends an item to `ConfigRuleNames`.
        ///
        /// To override the contents of this collection use [`set_config_rule_names`](Self::set_config_rule_names).
        ///
        /// <p>The name of the Config managed rules for which you want status information. If you do not specify any names, Config returns status information for all Config managed rules that you use.</p>
        pub fn config_rule_names(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_names(input.into());
            self
        }
        /// <p>The name of the Config managed rules for which you want status information. If you do not specify any names, Config returns status information for all Config managed rules that you use.</p>
        pub fn set_config_rule_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_names(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
        /// <p>The number of rule evaluation results that you want returned.</p>
        /// <p>This parameter is required if the rule limit for your account is more than the default of 150 rules.</p>
        /// <p>For information about requesting a rule limit increase, see <a href="http://docs.aws.amazon.com/general/latest/gr/aws_service_limits.html#limits_config">Config Limits</a> in the <i>Amazon Web Services General Reference Guide</i>.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The number of rule evaluation results that you want returned.</p>
        /// <p>This parameter is required if the rule limit for your account is more than the default of 150 rules.</p>
        /// <p>For information about requesting a rule limit increase, see <a href="http://docs.aws.amazon.com/general/latest/gr/aws_service_limits.html#limits_config">Config Limits</a> in the <i>Amazon Web Services General Reference Guide</i>.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DescribeConfigRules`.
    ///
    /// <p>Returns details about your Config rules.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DescribeConfigRules {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::describe_config_rules_input::Builder,
    }
    impl DescribeConfigRules {
        /// Creates a new `DescribeConfigRules`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeConfigRulesOutput,
            aws_smithy_http::result::SdkError<crate::error::DescribeConfigRulesError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::DescribeConfigRulesPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(self) -> crate::paginator::DescribeConfigRulesPaginator {
            crate::paginator::DescribeConfigRulesPaginator::new(self.handle, self.inner)
        }
        /// Appends an item to `ConfigRuleNames`.
        ///
        /// To override the contents of this collection use [`set_config_rule_names`](Self::set_config_rule_names).
        ///
        /// <p>The names of the Config rules for which you want details. If you do not specify any names, Config returns details for all your rules.</p>
        pub fn config_rule_names(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_names(input.into());
            self
        }
        /// <p>The names of the Config rules for which you want details. If you do not specify any names, Config returns details for all your rules.</p>
        pub fn set_config_rule_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_names(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DescribeConfigurationAggregators`.
    ///
    /// <p>Returns the details of one or more configuration aggregators. If the configuration aggregator is not specified, this action returns the details for all the configuration aggregators associated with the account. </p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DescribeConfigurationAggregators {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::describe_configuration_aggregators_input::Builder,
    }
    impl DescribeConfigurationAggregators {
        /// Creates a new `DescribeConfigurationAggregators`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeConfigurationAggregatorsOutput,
            aws_smithy_http::result::SdkError<crate::error::DescribeConfigurationAggregatorsError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::DescribeConfigurationAggregatorsPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(self) -> crate::paginator::DescribeConfigurationAggregatorsPaginator {
            crate::paginator::DescribeConfigurationAggregatorsPaginator::new(
                self.handle,
                self.inner,
            )
        }
        /// Appends an item to `ConfigurationAggregatorNames`.
        ///
        /// To override the contents of this collection use [`set_configuration_aggregator_names`](Self::set_configuration_aggregator_names).
        ///
        /// <p>The name of the configuration aggregators.</p>
        pub fn configuration_aggregator_names(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_names(input.into());
            self
        }
        /// <p>The name of the configuration aggregators.</p>
        pub fn set_configuration_aggregator_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_names(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
        /// <p>The maximum number of configuration aggregators returned on each page. The default is maximum. If you specify 0, Config uses the default.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of configuration aggregators returned on each page. The default is maximum. If you specify 0, Config uses the default.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DescribeConfigurationAggregatorSourcesStatus`.
    ///
    /// <p>Returns status information for sources within an aggregator. The status includes information about the last time Config verified authorization between the source account and an aggregator account. In case of a failure, the status contains the related error code or message. </p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DescribeConfigurationAggregatorSourcesStatus {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::describe_configuration_aggregator_sources_status_input::Builder,
    }
    impl DescribeConfigurationAggregatorSourcesStatus {
        /// Creates a new `DescribeConfigurationAggregatorSourcesStatus`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeConfigurationAggregatorSourcesStatusOutput,
            aws_smithy_http::result::SdkError<
                crate::error::DescribeConfigurationAggregatorSourcesStatusError,
            >,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::DescribeConfigurationAggregatorSourcesStatusPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(
            self,
        ) -> crate::paginator::DescribeConfigurationAggregatorSourcesStatusPaginator {
            crate::paginator::DescribeConfigurationAggregatorSourcesStatusPaginator::new(
                self.handle,
                self.inner,
            )
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn configuration_aggregator_name(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(input.into());
            self
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
        /// Appends an item to `UpdateStatus`.
        ///
        /// To override the contents of this collection use [`set_update_status`](Self::set_update_status).
        ///
        /// <p>Filters the status type.</p>
        /// <ul>
        /// <li> <p>Valid value FAILED indicates errors while moving data.</p> </li>
        /// <li> <p>Valid value SUCCEEDED indicates the data was successfully moved.</p> </li>
        /// <li> <p>Valid value OUTDATED indicates the data is not the most recent.</p> </li>
        /// </ul>
        pub fn update_status(mut self, input: crate::model::AggregatedSourceStatusType) -> Self {
            self.inner = self.inner.update_status(input);
            self
        }
        /// <p>Filters the status type.</p>
        /// <ul>
        /// <li> <p>Valid value FAILED indicates errors while moving data.</p> </li>
        /// <li> <p>Valid value SUCCEEDED indicates the data was successfully moved.</p> </li>
        /// <li> <p>Valid value OUTDATED indicates the data is not the most recent.</p> </li>
        /// </ul>
        pub fn set_update_status(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::AggregatedSourceStatusType>>,
        ) -> Self {
            self.inner = self.inner.set_update_status(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
        /// <p>The maximum number of AggregatorSourceStatus returned on each page. The default is maximum. If you specify 0, Config uses the default.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of AggregatorSourceStatus returned on each page. The default is maximum. If you specify 0, Config uses the default.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DescribeConfigurationRecorders`.
    ///
    /// <p>Returns the details for the specified configuration recorders. If the configuration recorder is not specified, this action returns the details for all configuration recorders associated with the account.</p> <note>
    /// <p>Currently, you can specify only one configuration recorder per region in your account.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DescribeConfigurationRecorders {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::describe_configuration_recorders_input::Builder,
    }
    impl DescribeConfigurationRecorders {
        /// Creates a new `DescribeConfigurationRecorders`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeConfigurationRecordersOutput,
            aws_smithy_http::result::SdkError<crate::error::DescribeConfigurationRecordersError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `ConfigurationRecorderNames`.
        ///
        /// To override the contents of this collection use [`set_configuration_recorder_names`](Self::set_configuration_recorder_names).
        ///
        /// <p>A list of configuration recorder names.</p>
        pub fn configuration_recorder_names(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_recorder_names(input.into());
            self
        }
        /// <p>A list of configuration recorder names.</p>
        pub fn set_configuration_recorder_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_configuration_recorder_names(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DescribeConfigurationRecorderStatus`.
    ///
    /// <p>Returns the current status of the specified configuration recorder. If a configuration recorder is not specified, this action returns the status of all configuration recorders associated with the account.</p> <note>
    /// <p>Currently, you can specify only one configuration recorder per region in your account.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DescribeConfigurationRecorderStatus {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::describe_configuration_recorder_status_input::Builder,
    }
    impl DescribeConfigurationRecorderStatus {
        /// Creates a new `DescribeConfigurationRecorderStatus`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeConfigurationRecorderStatusOutput,
            aws_smithy_http::result::SdkError<
                crate::error::DescribeConfigurationRecorderStatusError,
            >,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `ConfigurationRecorderNames`.
        ///
        /// To override the contents of this collection use [`set_configuration_recorder_names`](Self::set_configuration_recorder_names).
        ///
        /// <p>The name(s) of the configuration recorder. If the name is not specified, the action returns the current status of all the configuration recorders associated with the account.</p>
        pub fn configuration_recorder_names(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_recorder_names(input.into());
            self
        }
        /// <p>The name(s) of the configuration recorder. If the name is not specified, the action returns the current status of all the configuration recorders associated with the account.</p>
        pub fn set_configuration_recorder_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_configuration_recorder_names(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DescribeConformancePackCompliance`.
    ///
    /// <p>Returns compliance details for each rule in that conformance pack.</p> <note>
    /// <p>You must provide exact rule names.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DescribeConformancePackCompliance {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::describe_conformance_pack_compliance_input::Builder,
    }
    impl DescribeConformancePackCompliance {
        /// Creates a new `DescribeConformancePackCompliance`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeConformancePackComplianceOutput,
            aws_smithy_http::result::SdkError<crate::error::DescribeConformancePackComplianceError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::DescribeConformancePackCompliancePaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(
            self,
        ) -> crate::paginator::DescribeConformancePackCompliancePaginator {
            crate::paginator::DescribeConformancePackCompliancePaginator::new(
                self.handle,
                self.inner,
            )
        }
        /// <p>Name of the conformance pack.</p>
        pub fn conformance_pack_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.conformance_pack_name(input.into());
            self
        }
        /// <p>Name of the conformance pack.</p>
        pub fn set_conformance_pack_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_conformance_pack_name(input);
            self
        }
        /// <p>A <code>ConformancePackComplianceFilters</code> object.</p>
        pub fn filters(mut self, input: crate::model::ConformancePackComplianceFilters) -> Self {
            self.inner = self.inner.filters(input);
            self
        }
        /// <p>A <code>ConformancePackComplianceFilters</code> object.</p>
        pub fn set_filters(
            mut self,
            input: std::option::Option<crate::model::ConformancePackComplianceFilters>,
        ) -> Self {
            self.inner = self.inner.set_filters(input);
            self
        }
        /// <p>The maximum number of Config rules within a conformance pack are returned on each page.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of Config rules within a conformance pack are returned on each page.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DescribeConformancePacks`.
    ///
    /// <p>Returns a list of one or more conformance packs.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DescribeConformancePacks {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::describe_conformance_packs_input::Builder,
    }
    impl DescribeConformancePacks {
        /// Creates a new `DescribeConformancePacks`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeConformancePacksOutput,
            aws_smithy_http::result::SdkError<crate::error::DescribeConformancePacksError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::DescribeConformancePacksPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(self) -> crate::paginator::DescribeConformancePacksPaginator {
            crate::paginator::DescribeConformancePacksPaginator::new(self.handle, self.inner)
        }
        /// Appends an item to `ConformancePackNames`.
        ///
        /// To override the contents of this collection use [`set_conformance_pack_names`](Self::set_conformance_pack_names).
        ///
        /// <p>Comma-separated list of conformance pack names for which you want details. If you do not specify any names, Config returns details for all your conformance packs. </p>
        pub fn conformance_pack_names(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.conformance_pack_names(input.into());
            self
        }
        /// <p>Comma-separated list of conformance pack names for which you want details. If you do not specify any names, Config returns details for all your conformance packs. </p>
        pub fn set_conformance_pack_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_conformance_pack_names(input);
            self
        }
        /// <p>The maximum number of conformance packs returned on each page.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of conformance packs returned on each page.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DescribeConformancePackStatus`.
    ///
    /// <p>Provides one or more conformance packs deployment status.</p> <note>
    /// <p>If there are no conformance packs then you will see an empty result.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DescribeConformancePackStatus {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::describe_conformance_pack_status_input::Builder,
    }
    impl DescribeConformancePackStatus {
        /// Creates a new `DescribeConformancePackStatus`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeConformancePackStatusOutput,
            aws_smithy_http::result::SdkError<crate::error::DescribeConformancePackStatusError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::DescribeConformancePackStatusPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(self) -> crate::paginator::DescribeConformancePackStatusPaginator {
            crate::paginator::DescribeConformancePackStatusPaginator::new(self.handle, self.inner)
        }
        /// Appends an item to `ConformancePackNames`.
        ///
        /// To override the contents of this collection use [`set_conformance_pack_names`](Self::set_conformance_pack_names).
        ///
        /// <p>Comma-separated list of conformance pack names.</p>
        pub fn conformance_pack_names(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.conformance_pack_names(input.into());
            self
        }
        /// <p>Comma-separated list of conformance pack names.</p>
        pub fn set_conformance_pack_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_conformance_pack_names(input);
            self
        }
        /// <p>The maximum number of conformance packs status returned on each page.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of conformance packs status returned on each page.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DescribeDeliveryChannels`.
    ///
    /// <p>Returns details about the specified delivery channel. If a delivery channel is not specified, this action returns the details of all delivery channels associated with the account.</p> <note>
    /// <p>Currently, you can specify only one delivery channel per region in your account.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DescribeDeliveryChannels {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::describe_delivery_channels_input::Builder,
    }
    impl DescribeDeliveryChannels {
        /// Creates a new `DescribeDeliveryChannels`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeDeliveryChannelsOutput,
            aws_smithy_http::result::SdkError<crate::error::DescribeDeliveryChannelsError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `DeliveryChannelNames`.
        ///
        /// To override the contents of this collection use [`set_delivery_channel_names`](Self::set_delivery_channel_names).
        ///
        /// <p>A list of delivery channel names.</p>
        pub fn delivery_channel_names(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.delivery_channel_names(input.into());
            self
        }
        /// <p>A list of delivery channel names.</p>
        pub fn set_delivery_channel_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_delivery_channel_names(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DescribeDeliveryChannelStatus`.
    ///
    /// <p>Returns the current status of the specified delivery channel. If a delivery channel is not specified, this action returns the current status of all delivery channels associated with the account.</p> <note>
    /// <p>Currently, you can specify only one delivery channel per region in your account.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DescribeDeliveryChannelStatus {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::describe_delivery_channel_status_input::Builder,
    }
    impl DescribeDeliveryChannelStatus {
        /// Creates a new `DescribeDeliveryChannelStatus`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeDeliveryChannelStatusOutput,
            aws_smithy_http::result::SdkError<crate::error::DescribeDeliveryChannelStatusError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `DeliveryChannelNames`.
        ///
        /// To override the contents of this collection use [`set_delivery_channel_names`](Self::set_delivery_channel_names).
        ///
        /// <p>A list of delivery channel names.</p>
        pub fn delivery_channel_names(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.delivery_channel_names(input.into());
            self
        }
        /// <p>A list of delivery channel names.</p>
        pub fn set_delivery_channel_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_delivery_channel_names(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DescribeOrganizationConfigRules`.
    ///
    /// <p>Returns a list of organization config rules. </p> <note>
    /// <p>When you specify the limit and the next token, you receive a paginated response. Limit and next token are not applicable if you specify organization config rule names. It is only applicable, when you request all the organization config rules.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DescribeOrganizationConfigRules {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::describe_organization_config_rules_input::Builder,
    }
    impl DescribeOrganizationConfigRules {
        /// Creates a new `DescribeOrganizationConfigRules`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeOrganizationConfigRulesOutput,
            aws_smithy_http::result::SdkError<crate::error::DescribeOrganizationConfigRulesError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::DescribeOrganizationConfigRulesPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(self) -> crate::paginator::DescribeOrganizationConfigRulesPaginator {
            crate::paginator::DescribeOrganizationConfigRulesPaginator::new(self.handle, self.inner)
        }
        /// Appends an item to `OrganizationConfigRuleNames`.
        ///
        /// To override the contents of this collection use [`set_organization_config_rule_names`](Self::set_organization_config_rule_names).
        ///
        /// <p>The names of organization config rules for which you want details. If you do not specify any names, Config returns details for all your organization config rules.</p>
        pub fn organization_config_rule_names(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.organization_config_rule_names(input.into());
            self
        }
        /// <p>The names of organization config rules for which you want details. If you do not specify any names, Config returns details for all your organization config rules.</p>
        pub fn set_organization_config_rule_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_organization_config_rule_names(input);
            self
        }
        /// <p>The maximum number of organization config rules returned on each page. If you do no specify a number, Config uses the default. The default is 100.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of organization config rules returned on each page. If you do no specify a number, Config uses the default. The default is 100.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DescribeOrganizationConfigRuleStatuses`.
    ///
    /// <p>Provides organization config rule deployment status for an organization.</p> <note>
    /// <p>The status is not considered successful until organization config rule is successfully deployed in all the member accounts with an exception of excluded accounts.</p>
    /// <p>When you specify the limit and the next token, you receive a paginated response. Limit and next token are not applicable if you specify organization config rule names. It is only applicable, when you request all the organization config rules.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DescribeOrganizationConfigRuleStatuses {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::describe_organization_config_rule_statuses_input::Builder,
    }
    impl DescribeOrganizationConfigRuleStatuses {
        /// Creates a new `DescribeOrganizationConfigRuleStatuses`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeOrganizationConfigRuleStatusesOutput,
            aws_smithy_http::result::SdkError<
                crate::error::DescribeOrganizationConfigRuleStatusesError,
            >,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::DescribeOrganizationConfigRuleStatusesPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(
            self,
        ) -> crate::paginator::DescribeOrganizationConfigRuleStatusesPaginator {
            crate::paginator::DescribeOrganizationConfigRuleStatusesPaginator::new(
                self.handle,
                self.inner,
            )
        }
        /// Appends an item to `OrganizationConfigRuleNames`.
        ///
        /// To override the contents of this collection use [`set_organization_config_rule_names`](Self::set_organization_config_rule_names).
        ///
        /// <p>The names of organization config rules for which you want status details. If you do not specify any names, Config returns details for all your organization Config rules.</p>
        pub fn organization_config_rule_names(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.organization_config_rule_names(input.into());
            self
        }
        /// <p>The names of organization config rules for which you want status details. If you do not specify any names, Config returns details for all your organization Config rules.</p>
        pub fn set_organization_config_rule_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_organization_config_rule_names(input);
            self
        }
        /// <p>The maximum number of <code>OrganizationConfigRuleStatuses</code> returned on each page. If you do no specify a number, Config uses the default. The default is 100.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of <code>OrganizationConfigRuleStatuses</code> returned on each page. If you do no specify a number, Config uses the default. The default is 100.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DescribeOrganizationConformancePacks`.
    ///
    /// <p>Returns a list of organization conformance packs. </p> <note>
    /// <p>When you specify the limit and the next token, you receive a paginated response. </p>
    /// <p>Limit and next token are not applicable if you specify organization conformance packs names. They are only applicable, when you request all the organization conformance packs. </p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DescribeOrganizationConformancePacks {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::describe_organization_conformance_packs_input::Builder,
    }
    impl DescribeOrganizationConformancePacks {
        /// Creates a new `DescribeOrganizationConformancePacks`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeOrganizationConformancePacksOutput,
            aws_smithy_http::result::SdkError<
                crate::error::DescribeOrganizationConformancePacksError,
            >,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::DescribeOrganizationConformancePacksPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(
            self,
        ) -> crate::paginator::DescribeOrganizationConformancePacksPaginator {
            crate::paginator::DescribeOrganizationConformancePacksPaginator::new(
                self.handle,
                self.inner,
            )
        }
        /// Appends an item to `OrganizationConformancePackNames`.
        ///
        /// To override the contents of this collection use [`set_organization_conformance_pack_names`](Self::set_organization_conformance_pack_names).
        ///
        /// <p>The name that you assign to an organization conformance pack.</p>
        pub fn organization_conformance_pack_names(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.organization_conformance_pack_names(input.into());
            self
        }
        /// <p>The name that you assign to an organization conformance pack.</p>
        pub fn set_organization_conformance_pack_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_organization_conformance_pack_names(input);
            self
        }
        /// <p>The maximum number of organization config packs returned on each page. If you do no specify a number, Config uses the default. The default is 100.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of organization config packs returned on each page. If you do no specify a number, Config uses the default. The default is 100.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The nextToken string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The nextToken string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DescribeOrganizationConformancePackStatuses`.
    ///
    /// <p>Provides organization conformance pack deployment status for an organization. </p> <note>
    /// <p>The status is not considered successful until organization conformance pack is successfully deployed in all the member accounts with an exception of excluded accounts.</p>
    /// <p>When you specify the limit and the next token, you receive a paginated response. Limit and next token are not applicable if you specify organization conformance pack names. They are only applicable, when you request all the organization conformance packs.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DescribeOrganizationConformancePackStatuses {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::describe_organization_conformance_pack_statuses_input::Builder,
    }
    impl DescribeOrganizationConformancePackStatuses {
        /// Creates a new `DescribeOrganizationConformancePackStatuses`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeOrganizationConformancePackStatusesOutput,
            aws_smithy_http::result::SdkError<
                crate::error::DescribeOrganizationConformancePackStatusesError,
            >,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::DescribeOrganizationConformancePackStatusesPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(
            self,
        ) -> crate::paginator::DescribeOrganizationConformancePackStatusesPaginator {
            crate::paginator::DescribeOrganizationConformancePackStatusesPaginator::new(
                self.handle,
                self.inner,
            )
        }
        /// Appends an item to `OrganizationConformancePackNames`.
        ///
        /// To override the contents of this collection use [`set_organization_conformance_pack_names`](Self::set_organization_conformance_pack_names).
        ///
        /// <p>The names of organization conformance packs for which you want status details. If you do not specify any names, Config returns details for all your organization conformance packs. </p>
        pub fn organization_conformance_pack_names(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.organization_conformance_pack_names(input.into());
            self
        }
        /// <p>The names of organization conformance packs for which you want status details. If you do not specify any names, Config returns details for all your organization conformance packs. </p>
        pub fn set_organization_conformance_pack_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_organization_conformance_pack_names(input);
            self
        }
        /// <p>The maximum number of OrganizationConformancePackStatuses returned on each page. If you do no specify a number, Config uses the default. The default is 100. </p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of OrganizationConformancePackStatuses returned on each page. If you do no specify a number, Config uses the default. The default is 100. </p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The nextToken string returned on a previous page that you use to get the next page of results in a paginated response. </p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The nextToken string returned on a previous page that you use to get the next page of results in a paginated response. </p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DescribePendingAggregationRequests`.
    ///
    /// <p>Returns a list of all pending aggregation requests.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DescribePendingAggregationRequests {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::describe_pending_aggregation_requests_input::Builder,
    }
    impl DescribePendingAggregationRequests {
        /// Creates a new `DescribePendingAggregationRequests`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribePendingAggregationRequestsOutput,
            aws_smithy_http::result::SdkError<
                crate::error::DescribePendingAggregationRequestsError,
            >,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::DescribePendingAggregationRequestsPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(
            self,
        ) -> crate::paginator::DescribePendingAggregationRequestsPaginator {
            crate::paginator::DescribePendingAggregationRequestsPaginator::new(
                self.handle,
                self.inner,
            )
        }
        /// <p>The maximum number of evaluation results returned on each page. The default is maximum. If you specify 0, Config uses the default.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of evaluation results returned on each page. The default is maximum. If you specify 0, Config uses the default.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DescribeRemediationConfigurations`.
    ///
    /// <p>Returns the details of one or more remediation configurations.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DescribeRemediationConfigurations {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::describe_remediation_configurations_input::Builder,
    }
    impl DescribeRemediationConfigurations {
        /// Creates a new `DescribeRemediationConfigurations`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeRemediationConfigurationsOutput,
            aws_smithy_http::result::SdkError<crate::error::DescribeRemediationConfigurationsError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `ConfigRuleNames`.
        ///
        /// To override the contents of this collection use [`set_config_rule_names`](Self::set_config_rule_names).
        ///
        /// <p>A list of Config rule names of remediation configurations for which you want details. </p>
        pub fn config_rule_names(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_names(input.into());
            self
        }
        /// <p>A list of Config rule names of remediation configurations for which you want details. </p>
        pub fn set_config_rule_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_names(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DescribeRemediationExceptions`.
    ///
    /// <p>Returns the details of one or more remediation exceptions. A detailed view of a remediation exception for a set of resources that includes an explanation of an exception and the time when the exception will be deleted. When you specify the limit and the next token, you receive a paginated response. </p> <note>
    /// <p>Config generates a remediation exception when a problem occurs executing a remediation action to a specific resource. Remediation exceptions blocks auto-remediation until the exception is cleared.</p>
    /// <p>When you specify the limit and the next token, you receive a paginated response. </p>
    /// <p>Limit and next token are not applicable if you request resources in batch. It is only applicable, when you request all resources.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DescribeRemediationExceptions {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::describe_remediation_exceptions_input::Builder,
    }
    impl DescribeRemediationExceptions {
        /// Creates a new `DescribeRemediationExceptions`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeRemediationExceptionsOutput,
            aws_smithy_http::result::SdkError<crate::error::DescribeRemediationExceptionsError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::DescribeRemediationExceptionsPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(self) -> crate::paginator::DescribeRemediationExceptionsPaginator {
            crate::paginator::DescribeRemediationExceptionsPaginator::new(self.handle, self.inner)
        }
        /// <p>The name of the Config rule.</p>
        pub fn config_rule_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_name(input.into());
            self
        }
        /// <p>The name of the Config rule.</p>
        pub fn set_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_name(input);
            self
        }
        /// Appends an item to `ResourceKeys`.
        ///
        /// To override the contents of this collection use [`set_resource_keys`](Self::set_resource_keys).
        ///
        /// <p>An exception list of resource exception keys to be processed with the current request. Config adds exception for each resource key. For example, Config adds 3 exceptions for 3 resource keys. </p>
        pub fn resource_keys(
            mut self,
            input: crate::model::RemediationExceptionResourceKey,
        ) -> Self {
            self.inner = self.inner.resource_keys(input);
            self
        }
        /// <p>An exception list of resource exception keys to be processed with the current request. Config adds exception for each resource key. For example, Config adds 3 exceptions for 3 resource keys. </p>
        pub fn set_resource_keys(
            mut self,
            input: std::option::Option<
                std::vec::Vec<crate::model::RemediationExceptionResourceKey>,
            >,
        ) -> Self {
            self.inner = self.inner.set_resource_keys(input);
            self
        }
        /// <p>The maximum number of RemediationExceptionResourceKey returned on each page. The default is 25. If you specify 0, Config uses the default.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of RemediationExceptionResourceKey returned on each page. The default is 25. If you specify 0, Config uses the default.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DescribeRemediationExecutionStatus`.
    ///
    /// <p>Provides a detailed view of a Remediation Execution for a set of resources including state, timestamps for when steps for the remediation execution occur, and any error messages for steps that have failed. When you specify the limit and the next token, you receive a paginated response.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DescribeRemediationExecutionStatus {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::describe_remediation_execution_status_input::Builder,
    }
    impl DescribeRemediationExecutionStatus {
        /// Creates a new `DescribeRemediationExecutionStatus`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeRemediationExecutionStatusOutput,
            aws_smithy_http::result::SdkError<
                crate::error::DescribeRemediationExecutionStatusError,
            >,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::DescribeRemediationExecutionStatusPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(
            self,
        ) -> crate::paginator::DescribeRemediationExecutionStatusPaginator {
            crate::paginator::DescribeRemediationExecutionStatusPaginator::new(
                self.handle,
                self.inner,
            )
        }
        /// <p>A list of Config rule names.</p>
        pub fn config_rule_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_name(input.into());
            self
        }
        /// <p>A list of Config rule names.</p>
        pub fn set_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_name(input);
            self
        }
        /// Appends an item to `ResourceKeys`.
        ///
        /// To override the contents of this collection use [`set_resource_keys`](Self::set_resource_keys).
        ///
        /// <p>A list of resource keys to be processed with the current request. Each element in the list consists of the resource type and resource ID. </p>
        pub fn resource_keys(mut self, input: crate::model::ResourceKey) -> Self {
            self.inner = self.inner.resource_keys(input);
            self
        }
        /// <p>A list of resource keys to be processed with the current request. Each element in the list consists of the resource type and resource ID. </p>
        pub fn set_resource_keys(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ResourceKey>>,
        ) -> Self {
            self.inner = self.inner.set_resource_keys(input);
            self
        }
        /// <p>The maximum number of RemediationExecutionStatuses returned on each page. The default is maximum. If you specify 0, Config uses the default. </p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of RemediationExecutionStatuses returned on each page. The default is maximum. If you specify 0, Config uses the default. </p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `DescribeRetentionConfigurations`.
    ///
    /// <p>Returns the details of one or more retention configurations. If the retention configuration name is not specified, this action returns the details for all the retention configurations for that account.</p> <note>
    /// <p>Currently, Config supports only one retention configuration per region in your account.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct DescribeRetentionConfigurations {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::describe_retention_configurations_input::Builder,
    }
    impl DescribeRetentionConfigurations {
        /// Creates a new `DescribeRetentionConfigurations`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeRetentionConfigurationsOutput,
            aws_smithy_http::result::SdkError<crate::error::DescribeRetentionConfigurationsError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::DescribeRetentionConfigurationsPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(self) -> crate::paginator::DescribeRetentionConfigurationsPaginator {
            crate::paginator::DescribeRetentionConfigurationsPaginator::new(self.handle, self.inner)
        }
        /// Appends an item to `RetentionConfigurationNames`.
        ///
        /// To override the contents of this collection use [`set_retention_configuration_names`](Self::set_retention_configuration_names).
        ///
        /// <p>A list of names of retention configurations for which you want details. If you do not specify a name, Config returns details for all the retention configurations for that account.</p> <note>
        /// <p>Currently, Config supports only one retention configuration per region in your account.</p>
        /// </note>
        pub fn retention_configuration_names(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.retention_configuration_names(input.into());
            self
        }
        /// <p>A list of names of retention configurations for which you want details. If you do not specify a name, Config returns details for all the retention configurations for that account.</p> <note>
        /// <p>Currently, Config supports only one retention configuration per region in your account.</p>
        /// </note>
        pub fn set_retention_configuration_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_retention_configuration_names(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `GetAggregateComplianceDetailsByConfigRule`.
    ///
    /// <p>Returns the evaluation results for the specified Config rule for a specific resource in a rule. The results indicate which Amazon Web Services resources were evaluated by the rule, when each resource was last evaluated, and whether each resource complies with the rule. </p> <note>
    /// <p>The results can return an empty result page. But if you have a <code>nextToken</code>, the results are displayed on the next page.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct GetAggregateComplianceDetailsByConfigRule {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::get_aggregate_compliance_details_by_config_rule_input::Builder,
    }
    impl GetAggregateComplianceDetailsByConfigRule {
        /// Creates a new `GetAggregateComplianceDetailsByConfigRule`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetAggregateComplianceDetailsByConfigRuleOutput,
            aws_smithy_http::result::SdkError<
                crate::error::GetAggregateComplianceDetailsByConfigRuleError,
            >,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::GetAggregateComplianceDetailsByConfigRulePaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(
            self,
        ) -> crate::paginator::GetAggregateComplianceDetailsByConfigRulePaginator {
            crate::paginator::GetAggregateComplianceDetailsByConfigRulePaginator::new(
                self.handle,
                self.inner,
            )
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn configuration_aggregator_name(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(input.into());
            self
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
        /// <p>The name of the Config rule for which you want compliance information.</p>
        pub fn config_rule_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_name(input.into());
            self
        }
        /// <p>The name of the Config rule for which you want compliance information.</p>
        pub fn set_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_name(input);
            self
        }
        /// <p>The 12-digit account ID of the source account.</p>
        pub fn account_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.account_id(input.into());
            self
        }
        /// <p>The 12-digit account ID of the source account.</p>
        pub fn set_account_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_account_id(input);
            self
        }
        /// <p>The source region from where the data is aggregated.</p>
        pub fn aws_region(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.aws_region(input.into());
            self
        }
        /// <p>The source region from where the data is aggregated.</p>
        pub fn set_aws_region(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_aws_region(input);
            self
        }
        /// <p>The resource compliance status.</p> <note>
        /// <p>For the <code>GetAggregateComplianceDetailsByConfigRuleRequest</code> data type, Config supports only the <code>COMPLIANT</code> and <code>NON_COMPLIANT</code>. Config does not support the <code>NOT_APPLICABLE</code> and <code>INSUFFICIENT_DATA</code> values.</p>
        /// </note>
        pub fn compliance_type(mut self, input: crate::model::ComplianceType) -> Self {
            self.inner = self.inner.compliance_type(input);
            self
        }
        /// <p>The resource compliance status.</p> <note>
        /// <p>For the <code>GetAggregateComplianceDetailsByConfigRuleRequest</code> data type, Config supports only the <code>COMPLIANT</code> and <code>NON_COMPLIANT</code>. Config does not support the <code>NOT_APPLICABLE</code> and <code>INSUFFICIENT_DATA</code> values.</p>
        /// </note>
        pub fn set_compliance_type(
            mut self,
            input: std::option::Option<crate::model::ComplianceType>,
        ) -> Self {
            self.inner = self.inner.set_compliance_type(input);
            self
        }
        /// <p>The maximum number of evaluation results returned on each page. The default is 50. You cannot specify a number greater than 100. If you specify 0, Config uses the default.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of evaluation results returned on each page. The default is 50. You cannot specify a number greater than 100. If you specify 0, Config uses the default.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `GetAggregateConfigRuleComplianceSummary`.
    ///
    /// <p>Returns the number of compliant and noncompliant rules for one or more accounts and regions in an aggregator.</p> <note>
    /// <p>The results can return an empty result page, but if you have a nextToken, the results are displayed on the next page.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct GetAggregateConfigRuleComplianceSummary {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::get_aggregate_config_rule_compliance_summary_input::Builder,
    }
    impl GetAggregateConfigRuleComplianceSummary {
        /// Creates a new `GetAggregateConfigRuleComplianceSummary`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetAggregateConfigRuleComplianceSummaryOutput,
            aws_smithy_http::result::SdkError<
                crate::error::GetAggregateConfigRuleComplianceSummaryError,
            >,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::GetAggregateConfigRuleComplianceSummaryPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(
            self,
        ) -> crate::paginator::GetAggregateConfigRuleComplianceSummaryPaginator {
            crate::paginator::GetAggregateConfigRuleComplianceSummaryPaginator::new(
                self.handle,
                self.inner,
            )
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn configuration_aggregator_name(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(input.into());
            self
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
        /// <p>Filters the results based on the ConfigRuleComplianceSummaryFilters object.</p>
        pub fn filters(mut self, input: crate::model::ConfigRuleComplianceSummaryFilters) -> Self {
            self.inner = self.inner.filters(input);
            self
        }
        /// <p>Filters the results based on the ConfigRuleComplianceSummaryFilters object.</p>
        pub fn set_filters(
            mut self,
            input: std::option::Option<crate::model::ConfigRuleComplianceSummaryFilters>,
        ) -> Self {
            self.inner = self.inner.set_filters(input);
            self
        }
        /// <p>Groups the result based on ACCOUNT_ID or AWS_REGION.</p>
        pub fn group_by_key(
            mut self,
            input: crate::model::ConfigRuleComplianceSummaryGroupKey,
        ) -> Self {
            self.inner = self.inner.group_by_key(input);
            self
        }
        /// <p>Groups the result based on ACCOUNT_ID or AWS_REGION.</p>
        pub fn set_group_by_key(
            mut self,
            input: std::option::Option<crate::model::ConfigRuleComplianceSummaryGroupKey>,
        ) -> Self {
            self.inner = self.inner.set_group_by_key(input);
            self
        }
        /// <p>The maximum number of evaluation results returned on each page. The default is 1000. You cannot specify a number greater than 1000. If you specify 0, Config uses the default.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of evaluation results returned on each page. The default is 1000. You cannot specify a number greater than 1000. If you specify 0, Config uses the default.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `GetAggregateConformancePackComplianceSummary`.
    ///
    /// <p>Returns the count of compliant and noncompliant conformance packs across all Amazon Web Services accounts and Amazon Web Services Regions in an aggregator. You can filter based on Amazon Web Services account ID or Amazon Web Services Region.</p> <note>
    /// <p>The results can return an empty result page, but if you have a nextToken, the results are displayed on the next page.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct GetAggregateConformancePackComplianceSummary {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::get_aggregate_conformance_pack_compliance_summary_input::Builder,
    }
    impl GetAggregateConformancePackComplianceSummary {
        /// Creates a new `GetAggregateConformancePackComplianceSummary`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetAggregateConformancePackComplianceSummaryOutput,
            aws_smithy_http::result::SdkError<
                crate::error::GetAggregateConformancePackComplianceSummaryError,
            >,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::GetAggregateConformancePackComplianceSummaryPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(
            self,
        ) -> crate::paginator::GetAggregateConformancePackComplianceSummaryPaginator {
            crate::paginator::GetAggregateConformancePackComplianceSummaryPaginator::new(
                self.handle,
                self.inner,
            )
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn configuration_aggregator_name(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(input.into());
            self
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
        /// <p>Filters the results based on the <code>AggregateConformancePackComplianceSummaryFilters</code> object.</p>
        pub fn filters(
            mut self,
            input: crate::model::AggregateConformancePackComplianceSummaryFilters,
        ) -> Self {
            self.inner = self.inner.filters(input);
            self
        }
        /// <p>Filters the results based on the <code>AggregateConformancePackComplianceSummaryFilters</code> object.</p>
        pub fn set_filters(
            mut self,
            input: std::option::Option<
                crate::model::AggregateConformancePackComplianceSummaryFilters,
            >,
        ) -> Self {
            self.inner = self.inner.set_filters(input);
            self
        }
        /// <p>Groups the result based on Amazon Web Services account ID or Amazon Web Services Region.</p>
        pub fn group_by_key(
            mut self,
            input: crate::model::AggregateConformancePackComplianceSummaryGroupKey,
        ) -> Self {
            self.inner = self.inner.group_by_key(input);
            self
        }
        /// <p>Groups the result based on Amazon Web Services account ID or Amazon Web Services Region.</p>
        pub fn set_group_by_key(
            mut self,
            input: std::option::Option<
                crate::model::AggregateConformancePackComplianceSummaryGroupKey,
            >,
        ) -> Self {
            self.inner = self.inner.set_group_by_key(input);
            self
        }
        /// <p>The maximum number of results returned on each page. The default is maximum. If you specify 0, Config uses the default.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of results returned on each page. The default is maximum. If you specify 0, Config uses the default.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `GetAggregateDiscoveredResourceCounts`.
    ///
    /// <p>Returns the resource counts across accounts and regions that are present in your Config aggregator. You can request the resource counts by providing filters and GroupByKey.</p>
    /// <p>For example, if the input contains accountID 12345678910 and region us-east-1 in filters, the API returns the count of resources in account ID 12345678910 and region us-east-1. If the input contains ACCOUNT_ID as a GroupByKey, the API returns resource counts for all source accounts that are present in your aggregator.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct GetAggregateDiscoveredResourceCounts {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::get_aggregate_discovered_resource_counts_input::Builder,
    }
    impl GetAggregateDiscoveredResourceCounts {
        /// Creates a new `GetAggregateDiscoveredResourceCounts`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetAggregateDiscoveredResourceCountsOutput,
            aws_smithy_http::result::SdkError<
                crate::error::GetAggregateDiscoveredResourceCountsError,
            >,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::GetAggregateDiscoveredResourceCountsPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(
            self,
        ) -> crate::paginator::GetAggregateDiscoveredResourceCountsPaginator {
            crate::paginator::GetAggregateDiscoveredResourceCountsPaginator::new(
                self.handle,
                self.inner,
            )
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn configuration_aggregator_name(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(input.into());
            self
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
        /// <p>Filters the results based on the <code>ResourceCountFilters</code> object.</p>
        pub fn filters(mut self, input: crate::model::ResourceCountFilters) -> Self {
            self.inner = self.inner.filters(input);
            self
        }
        /// <p>Filters the results based on the <code>ResourceCountFilters</code> object.</p>
        pub fn set_filters(
            mut self,
            input: std::option::Option<crate::model::ResourceCountFilters>,
        ) -> Self {
            self.inner = self.inner.set_filters(input);
            self
        }
        /// <p>The key to group the resource counts.</p>
        pub fn group_by_key(mut self, input: crate::model::ResourceCountGroupKey) -> Self {
            self.inner = self.inner.group_by_key(input);
            self
        }
        /// <p>The key to group the resource counts.</p>
        pub fn set_group_by_key(
            mut self,
            input: std::option::Option<crate::model::ResourceCountGroupKey>,
        ) -> Self {
            self.inner = self.inner.set_group_by_key(input);
            self
        }
        /// <p>The maximum number of <code>GroupedResourceCount</code> objects returned on each page. The default is 1000. You cannot specify a number greater than 1000. If you specify 0, Config uses the default.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of <code>GroupedResourceCount</code> objects returned on each page. The default is 1000. You cannot specify a number greater than 1000. If you specify 0, Config uses the default.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `GetAggregateResourceConfig`.
    ///
    /// <p>Returns configuration item that is aggregated for your specific resource in a specific source account and region.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct GetAggregateResourceConfig {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::get_aggregate_resource_config_input::Builder,
    }
    impl GetAggregateResourceConfig {
        /// Creates a new `GetAggregateResourceConfig`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetAggregateResourceConfigOutput,
            aws_smithy_http::result::SdkError<crate::error::GetAggregateResourceConfigError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn configuration_aggregator_name(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(input.into());
            self
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
        /// <p>An object that identifies aggregate resource.</p>
        pub fn resource_identifier(
            mut self,
            input: crate::model::AggregateResourceIdentifier,
        ) -> Self {
            self.inner = self.inner.resource_identifier(input);
            self
        }
        /// <p>An object that identifies aggregate resource.</p>
        pub fn set_resource_identifier(
            mut self,
            input: std::option::Option<crate::model::AggregateResourceIdentifier>,
        ) -> Self {
            self.inner = self.inner.set_resource_identifier(input);
            self
        }
    }
    /// Fluent builder constructing a request to `GetComplianceDetailsByConfigRule`.
    ///
    /// <p>Returns the evaluation results for the specified Config rule. The results indicate which Amazon Web Services resources were evaluated by the rule, when each resource was last evaluated, and whether each resource complies with the rule.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct GetComplianceDetailsByConfigRule {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::get_compliance_details_by_config_rule_input::Builder,
    }
    impl GetComplianceDetailsByConfigRule {
        /// Creates a new `GetComplianceDetailsByConfigRule`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetComplianceDetailsByConfigRuleOutput,
            aws_smithy_http::result::SdkError<crate::error::GetComplianceDetailsByConfigRuleError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::GetComplianceDetailsByConfigRulePaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(self) -> crate::paginator::GetComplianceDetailsByConfigRulePaginator {
            crate::paginator::GetComplianceDetailsByConfigRulePaginator::new(
                self.handle,
                self.inner,
            )
        }
        /// <p>The name of the Config rule for which you want compliance information.</p>
        pub fn config_rule_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_name(input.into());
            self
        }
        /// <p>The name of the Config rule for which you want compliance information.</p>
        pub fn set_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_name(input);
            self
        }
        /// Appends an item to `ComplianceTypes`.
        ///
        /// To override the contents of this collection use [`set_compliance_types`](Self::set_compliance_types).
        ///
        /// <p>Filters the results by compliance.</p>
        /// <p>The allowed values are <code>COMPLIANT</code>, <code>NON_COMPLIANT</code>, and <code>NOT_APPLICABLE</code>.</p>
        pub fn compliance_types(mut self, input: crate::model::ComplianceType) -> Self {
            self.inner = self.inner.compliance_types(input);
            self
        }
        /// <p>Filters the results by compliance.</p>
        /// <p>The allowed values are <code>COMPLIANT</code>, <code>NON_COMPLIANT</code>, and <code>NOT_APPLICABLE</code>.</p>
        pub fn set_compliance_types(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ComplianceType>>,
        ) -> Self {
            self.inner = self.inner.set_compliance_types(input);
            self
        }
        /// <p>The maximum number of evaluation results returned on each page. The default is 10. You cannot specify a number greater than 100. If you specify 0, Config uses the default.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of evaluation results returned on each page. The default is 10. You cannot specify a number greater than 100. If you specify 0, Config uses the default.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `GetComplianceDetailsByResource`.
    ///
    /// <p>Returns the evaluation results for the specified Amazon Web Services resource. The results indicate which Config rules were used to evaluate the resource, when each rule was last used, and whether the resource complies with each rule.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct GetComplianceDetailsByResource {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::get_compliance_details_by_resource_input::Builder,
    }
    impl GetComplianceDetailsByResource {
        /// Creates a new `GetComplianceDetailsByResource`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetComplianceDetailsByResourceOutput,
            aws_smithy_http::result::SdkError<crate::error::GetComplianceDetailsByResourceError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::GetComplianceDetailsByResourcePaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(self) -> crate::paginator::GetComplianceDetailsByResourcePaginator {
            crate::paginator::GetComplianceDetailsByResourcePaginator::new(self.handle, self.inner)
        }
        /// <p>The type of the Amazon Web Services resource for which you want compliance information.</p>
        pub fn resource_type(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_type(input.into());
            self
        }
        /// <p>The type of the Amazon Web Services resource for which you want compliance information.</p>
        pub fn set_resource_type(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_resource_type(input);
            self
        }
        /// <p>The ID of the Amazon Web Services resource for which you want compliance information.</p>
        pub fn resource_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_id(input.into());
            self
        }
        /// <p>The ID of the Amazon Web Services resource for which you want compliance information.</p>
        pub fn set_resource_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_resource_id(input);
            self
        }
        /// Appends an item to `ComplianceTypes`.
        ///
        /// To override the contents of this collection use [`set_compliance_types`](Self::set_compliance_types).
        ///
        /// <p>Filters the results by compliance.</p>
        /// <p>The allowed values are <code>COMPLIANT</code>, <code>NON_COMPLIANT</code>, and <code>NOT_APPLICABLE</code>.</p>
        pub fn compliance_types(mut self, input: crate::model::ComplianceType) -> Self {
            self.inner = self.inner.compliance_types(input);
            self
        }
        /// <p>Filters the results by compliance.</p>
        /// <p>The allowed values are <code>COMPLIANT</code>, <code>NON_COMPLIANT</code>, and <code>NOT_APPLICABLE</code>.</p>
        pub fn set_compliance_types(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ComplianceType>>,
        ) -> Self {
            self.inner = self.inner.set_compliance_types(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `GetComplianceSummaryByConfigRule`.
    ///
    /// <p>Returns the number of Config rules that are compliant and noncompliant, up to a maximum of 25 for each.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct GetComplianceSummaryByConfigRule {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::get_compliance_summary_by_config_rule_input::Builder,
    }
    impl GetComplianceSummaryByConfigRule {
        /// Creates a new `GetComplianceSummaryByConfigRule`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetComplianceSummaryByConfigRuleOutput,
            aws_smithy_http::result::SdkError<crate::error::GetComplianceSummaryByConfigRuleError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
    }
    /// Fluent builder constructing a request to `GetComplianceSummaryByResourceType`.
    ///
    /// <p>Returns the number of resources that are compliant and the number that are noncompliant. You can specify one or more resource types to get these numbers for each resource type. The maximum number returned is 100.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct GetComplianceSummaryByResourceType {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::get_compliance_summary_by_resource_type_input::Builder,
    }
    impl GetComplianceSummaryByResourceType {
        /// Creates a new `GetComplianceSummaryByResourceType`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetComplianceSummaryByResourceTypeOutput,
            aws_smithy_http::result::SdkError<
                crate::error::GetComplianceSummaryByResourceTypeError,
            >,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `ResourceTypes`.
        ///
        /// To override the contents of this collection use [`set_resource_types`](Self::set_resource_types).
        ///
        /// <p>Specify one or more resource types to get the number of resources that are compliant and the number that are noncompliant for each resource type.</p>
        /// <p>For this request, you can specify an Amazon Web Services resource type such as <code>AWS::EC2::Instance</code>. You can specify that the resource type is an Amazon Web Services account by specifying <code>AWS::::Account</code>.</p>
        pub fn resource_types(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_types(input.into());
            self
        }
        /// <p>Specify one or more resource types to get the number of resources that are compliant and the number that are noncompliant for each resource type.</p>
        /// <p>For this request, you can specify an Amazon Web Services resource type such as <code>AWS::EC2::Instance</code>. You can specify that the resource type is an Amazon Web Services account by specifying <code>AWS::::Account</code>.</p>
        pub fn set_resource_types(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_resource_types(input);
            self
        }
    }
    /// Fluent builder constructing a request to `GetConformancePackComplianceDetails`.
    ///
    /// <p>Returns compliance details of a conformance pack for all Amazon Web Services resources that are monitered by conformance pack.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct GetConformancePackComplianceDetails {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::get_conformance_pack_compliance_details_input::Builder,
    }
    impl GetConformancePackComplianceDetails {
        /// Creates a new `GetConformancePackComplianceDetails`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetConformancePackComplianceDetailsOutput,
            aws_smithy_http::result::SdkError<
                crate::error::GetConformancePackComplianceDetailsError,
            >,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::GetConformancePackComplianceDetailsPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(
            self,
        ) -> crate::paginator::GetConformancePackComplianceDetailsPaginator {
            crate::paginator::GetConformancePackComplianceDetailsPaginator::new(
                self.handle,
                self.inner,
            )
        }
        /// <p>Name of the conformance pack.</p>
        pub fn conformance_pack_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.conformance_pack_name(input.into());
            self
        }
        /// <p>Name of the conformance pack.</p>
        pub fn set_conformance_pack_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_conformance_pack_name(input);
            self
        }
        /// <p>A <code>ConformancePackEvaluationFilters</code> object.</p>
        pub fn filters(mut self, input: crate::model::ConformancePackEvaluationFilters) -> Self {
            self.inner = self.inner.filters(input);
            self
        }
        /// <p>A <code>ConformancePackEvaluationFilters</code> object.</p>
        pub fn set_filters(
            mut self,
            input: std::option::Option<crate::model::ConformancePackEvaluationFilters>,
        ) -> Self {
            self.inner = self.inner.set_filters(input);
            self
        }
        /// <p>The maximum number of evaluation results returned on each page. If you do no specify a number, Config uses the default. The default is 100.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of evaluation results returned on each page. If you do no specify a number, Config uses the default. The default is 100.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `GetConformancePackComplianceSummary`.
    ///
    /// <p>Returns compliance details for the conformance pack based on the cumulative compliance results of all the rules in that conformance pack.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct GetConformancePackComplianceSummary {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::get_conformance_pack_compliance_summary_input::Builder,
    }
    impl GetConformancePackComplianceSummary {
        /// Creates a new `GetConformancePackComplianceSummary`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetConformancePackComplianceSummaryOutput,
            aws_smithy_http::result::SdkError<
                crate::error::GetConformancePackComplianceSummaryError,
            >,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::GetConformancePackComplianceSummaryPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(
            self,
        ) -> crate::paginator::GetConformancePackComplianceSummaryPaginator {
            crate::paginator::GetConformancePackComplianceSummaryPaginator::new(
                self.handle,
                self.inner,
            )
        }
        /// Appends an item to `ConformancePackNames`.
        ///
        /// To override the contents of this collection use [`set_conformance_pack_names`](Self::set_conformance_pack_names).
        ///
        /// <p>Names of conformance packs.</p>
        pub fn conformance_pack_names(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.conformance_pack_names(input.into());
            self
        }
        /// <p>Names of conformance packs.</p>
        pub fn set_conformance_pack_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_conformance_pack_names(input);
            self
        }
        /// <p>The maximum number of conformance packs returned on each page.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of conformance packs returned on each page.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The nextToken string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The nextToken string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `GetDiscoveredResourceCounts`.
    ///
    /// <p>Returns the resource types, the number of each resource type, and the total number of resources that Config is recording in this region for your Amazon Web Services account. </p>
    /// <p class="title"> <b>Example</b> </p>
    /// <ol>
    /// <li> <p>Config is recording three resource types in the US East (Ohio) Region for your account: 25 EC2 instances, 20 IAM users, and 15 S3 buckets.</p> </li>
    /// <li> <p>You make a call to the <code>GetDiscoveredResourceCounts</code> action and specify that you want all resource types. </p> </li>
    /// <li> <p>Config returns the following:</p>
    /// <ul>
    /// <li> <p>The resource types (EC2 instances, IAM users, and S3 buckets).</p> </li>
    /// <li> <p>The number of each resource type (25, 20, and 15).</p> </li>
    /// <li> <p>The total number of all resources (60).</p> </li>
    /// </ul> </li>
    /// </ol>
    /// <p>The response is paginated. By default, Config lists 100 <code>ResourceCount</code> objects on each page. You can customize this number with the <code>limit</code> parameter. The response includes a <code>nextToken</code> string. To get the next page of results, run the request again and specify the string for the <code>nextToken</code> parameter.</p> <note>
    /// <p>If you make a call to the <code>GetDiscoveredResourceCounts</code> action, you might not immediately receive resource counts in the following situations:</p>
    /// <ul>
    /// <li> <p>You are a new Config customer.</p> </li>
    /// <li> <p>You just enabled resource recording.</p> </li>
    /// </ul>
    /// <p>It might take a few minutes for Config to record and count your resources. Wait a few minutes and then retry the <code>GetDiscoveredResourceCounts</code> action. </p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct GetDiscoveredResourceCounts {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::get_discovered_resource_counts_input::Builder,
    }
    impl GetDiscoveredResourceCounts {
        /// Creates a new `GetDiscoveredResourceCounts`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetDiscoveredResourceCountsOutput,
            aws_smithy_http::result::SdkError<crate::error::GetDiscoveredResourceCountsError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::GetDiscoveredResourceCountsPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(self) -> crate::paginator::GetDiscoveredResourceCountsPaginator {
            crate::paginator::GetDiscoveredResourceCountsPaginator::new(self.handle, self.inner)
        }
        /// Appends an item to `resourceTypes`.
        ///
        /// To override the contents of this collection use [`set_resource_types`](Self::set_resource_types).
        ///
        /// <p>The comma-separated list that specifies the resource types that you want Config to return (for example, <code>"AWS::EC2::Instance"</code>, <code>"AWS::IAM::User"</code>).</p>
        /// <p>If a value for <code>resourceTypes</code> is not specified, Config returns all resource types that Config is recording in the region for your account.</p> <note>
        /// <p>If the configuration recorder is turned off, Config returns an empty list of <code>ResourceCount</code> objects. If the configuration recorder is not recording a specific resource type (for example, S3 buckets), that resource type is not returned in the list of <code>ResourceCount</code> objects.</p>
        /// </note>
        pub fn resource_types(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_types(input.into());
            self
        }
        /// <p>The comma-separated list that specifies the resource types that you want Config to return (for example, <code>"AWS::EC2::Instance"</code>, <code>"AWS::IAM::User"</code>).</p>
        /// <p>If a value for <code>resourceTypes</code> is not specified, Config returns all resource types that Config is recording in the region for your account.</p> <note>
        /// <p>If the configuration recorder is turned off, Config returns an empty list of <code>ResourceCount</code> objects. If the configuration recorder is not recording a specific resource type (for example, S3 buckets), that resource type is not returned in the list of <code>ResourceCount</code> objects.</p>
        /// </note>
        pub fn set_resource_types(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_resource_types(input);
            self
        }
        /// <p>The maximum number of <code>ResourceCount</code> objects returned on each page. The default is 100. You cannot specify a number greater than 100. If you specify 0, Config uses the default.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of <code>ResourceCount</code> objects returned on each page. The default is 100. You cannot specify a number greater than 100. If you specify 0, Config uses the default.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `GetOrganizationConfigRuleDetailedStatus`.
    ///
    /// <p>Returns detailed status for each member account within an organization for a given organization config rule.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct GetOrganizationConfigRuleDetailedStatus {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::get_organization_config_rule_detailed_status_input::Builder,
    }
    impl GetOrganizationConfigRuleDetailedStatus {
        /// Creates a new `GetOrganizationConfigRuleDetailedStatus`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetOrganizationConfigRuleDetailedStatusOutput,
            aws_smithy_http::result::SdkError<
                crate::error::GetOrganizationConfigRuleDetailedStatusError,
            >,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::GetOrganizationConfigRuleDetailedStatusPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(
            self,
        ) -> crate::paginator::GetOrganizationConfigRuleDetailedStatusPaginator {
            crate::paginator::GetOrganizationConfigRuleDetailedStatusPaginator::new(
                self.handle,
                self.inner,
            )
        }
        /// <p>The name of organization config rule for which you want status details for member accounts.</p>
        pub fn organization_config_rule_name(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.organization_config_rule_name(input.into());
            self
        }
        /// <p>The name of organization config rule for which you want status details for member accounts.</p>
        pub fn set_organization_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_organization_config_rule_name(input);
            self
        }
        /// <p>A <code>StatusDetailFilters</code> object.</p>
        pub fn filters(mut self, input: crate::model::StatusDetailFilters) -> Self {
            self.inner = self.inner.filters(input);
            self
        }
        /// <p>A <code>StatusDetailFilters</code> object.</p>
        pub fn set_filters(
            mut self,
            input: std::option::Option<crate::model::StatusDetailFilters>,
        ) -> Self {
            self.inner = self.inner.set_filters(input);
            self
        }
        /// <p>The maximum number of <code>OrganizationConfigRuleDetailedStatus</code> returned on each page. If you do not specify a number, Config uses the default. The default is 100.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of <code>OrganizationConfigRuleDetailedStatus</code> returned on each page. If you do not specify a number, Config uses the default. The default is 100.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `GetOrganizationConformancePackDetailedStatus`.
    ///
    /// <p>Returns detailed status for each member account within an organization for a given organization conformance pack.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct GetOrganizationConformancePackDetailedStatus {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::get_organization_conformance_pack_detailed_status_input::Builder,
    }
    impl GetOrganizationConformancePackDetailedStatus {
        /// Creates a new `GetOrganizationConformancePackDetailedStatus`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetOrganizationConformancePackDetailedStatusOutput,
            aws_smithy_http::result::SdkError<
                crate::error::GetOrganizationConformancePackDetailedStatusError,
            >,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::GetOrganizationConformancePackDetailedStatusPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(
            self,
        ) -> crate::paginator::GetOrganizationConformancePackDetailedStatusPaginator {
            crate::paginator::GetOrganizationConformancePackDetailedStatusPaginator::new(
                self.handle,
                self.inner,
            )
        }
        /// <p>The name of organization conformance pack for which you want status details for member accounts.</p>
        pub fn organization_conformance_pack_name(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.organization_conformance_pack_name(input.into());
            self
        }
        /// <p>The name of organization conformance pack for which you want status details for member accounts.</p>
        pub fn set_organization_conformance_pack_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_organization_conformance_pack_name(input);
            self
        }
        /// <p>An <code>OrganizationResourceDetailedStatusFilters</code> object.</p>
        pub fn filters(
            mut self,
            input: crate::model::OrganizationResourceDetailedStatusFilters,
        ) -> Self {
            self.inner = self.inner.filters(input);
            self
        }
        /// <p>An <code>OrganizationResourceDetailedStatusFilters</code> object.</p>
        pub fn set_filters(
            mut self,
            input: std::option::Option<crate::model::OrganizationResourceDetailedStatusFilters>,
        ) -> Self {
            self.inner = self.inner.set_filters(input);
            self
        }
        /// <p>The maximum number of <code>OrganizationConformancePackDetailedStatuses</code> returned on each page. If you do not specify a number, Config uses the default. The default is 100. </p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of <code>OrganizationConformancePackDetailedStatuses</code> returned on each page. If you do not specify a number, Config uses the default. The default is 100. </p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The nextToken string returned on a previous page that you use to get the next page of results in a paginated response. </p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The nextToken string returned on a previous page that you use to get the next page of results in a paginated response. </p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `GetResourceConfigHistory`.
    ///
    /// <p>Returns a list of <code>ConfigurationItems</code> for the specified resource. The list contains details about each state of the resource during the specified time interval. If you specified a retention period to retain your <code>ConfigurationItems</code> between a minimum of 30 days and a maximum of 7 years (2557 days), Config returns the <code>ConfigurationItems</code> for the specified retention period. </p>
    /// <p>The response is paginated. By default, Config returns a limit of 10 configuration items per page. You can customize this number with the <code>limit</code> parameter. The response includes a <code>nextToken</code> string. To get the next page of results, run the request again and specify the string for the <code>nextToken</code> parameter.</p> <note>
    /// <p>Each call to the API is limited to span a duration of seven days. It is likely that the number of records returned is smaller than the specified <code>limit</code>. In such cases, you can make another call, using the <code>nextToken</code>.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct GetResourceConfigHistory {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::get_resource_config_history_input::Builder,
    }
    impl GetResourceConfigHistory {
        /// Creates a new `GetResourceConfigHistory`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetResourceConfigHistoryOutput,
            aws_smithy_http::result::SdkError<crate::error::GetResourceConfigHistoryError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::GetResourceConfigHistoryPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(self) -> crate::paginator::GetResourceConfigHistoryPaginator {
            crate::paginator::GetResourceConfigHistoryPaginator::new(self.handle, self.inner)
        }
        /// <p>The resource type.</p>
        pub fn resource_type(mut self, input: crate::model::ResourceType) -> Self {
            self.inner = self.inner.resource_type(input);
            self
        }
        /// <p>The resource type.</p>
        pub fn set_resource_type(
            mut self,
            input: std::option::Option<crate::model::ResourceType>,
        ) -> Self {
            self.inner = self.inner.set_resource_type(input);
            self
        }
        /// <p>The ID of the resource (for example., <code>sg-xxxxxx</code>).</p>
        pub fn resource_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_id(input.into());
            self
        }
        /// <p>The ID of the resource (for example., <code>sg-xxxxxx</code>).</p>
        pub fn set_resource_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_resource_id(input);
            self
        }
        /// <p>The time stamp that indicates a later time. If not specified, current time is taken.</p>
        pub fn later_time(mut self, input: aws_smithy_types::DateTime) -> Self {
            self.inner = self.inner.later_time(input);
            self
        }
        /// <p>The time stamp that indicates a later time. If not specified, current time is taken.</p>
        pub fn set_later_time(
            mut self,
            input: std::option::Option<aws_smithy_types::DateTime>,
        ) -> Self {
            self.inner = self.inner.set_later_time(input);
            self
        }
        /// <p>The time stamp that indicates an earlier time. If not specified, the action returns paginated results that contain configuration items that start when the first configuration item was recorded.</p>
        pub fn earlier_time(mut self, input: aws_smithy_types::DateTime) -> Self {
            self.inner = self.inner.earlier_time(input);
            self
        }
        /// <p>The time stamp that indicates an earlier time. If not specified, the action returns paginated results that contain configuration items that start when the first configuration item was recorded.</p>
        pub fn set_earlier_time(
            mut self,
            input: std::option::Option<aws_smithy_types::DateTime>,
        ) -> Self {
            self.inner = self.inner.set_earlier_time(input);
            self
        }
        /// <p>The chronological order for configuration items listed. By default, the results are listed in reverse chronological order.</p>
        pub fn chronological_order(mut self, input: crate::model::ChronologicalOrder) -> Self {
            self.inner = self.inner.chronological_order(input);
            self
        }
        /// <p>The chronological order for configuration items listed. By default, the results are listed in reverse chronological order.</p>
        pub fn set_chronological_order(
            mut self,
            input: std::option::Option<crate::model::ChronologicalOrder>,
        ) -> Self {
            self.inner = self.inner.set_chronological_order(input);
            self
        }
        /// <p>The maximum number of configuration items returned on each page. The default is 10. You cannot specify a number greater than 100. If you specify 0, Config uses the default.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of configuration items returned on each page. The default is 10. You cannot specify a number greater than 100. If you specify 0, Config uses the default.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `GetStoredQuery`.
    ///
    /// <p>Returns the details of a specific stored query.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct GetStoredQuery {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::get_stored_query_input::Builder,
    }
    impl GetStoredQuery {
        /// Creates a new `GetStoredQuery`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetStoredQueryOutput,
            aws_smithy_http::result::SdkError<crate::error::GetStoredQueryError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the query.</p>
        pub fn query_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.query_name(input.into());
            self
        }
        /// <p>The name of the query.</p>
        pub fn set_query_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_query_name(input);
            self
        }
    }
    /// Fluent builder constructing a request to `ListAggregateDiscoveredResources`.
    ///
    /// <p>Accepts a resource type and returns a list of resource identifiers that are aggregated for a specific resource type across accounts and regions. A resource identifier includes the resource type, ID, (if available) the custom resource name, source account, and source region. You can narrow the results to include only resources that have specific resource IDs, or a resource name, or source account ID, or source region.</p>
    /// <p>For example, if the input consists of accountID 12345678910 and the region is us-east-1 for resource type <code>AWS::EC2::Instance</code> then the API returns all the EC2 instance identifiers of accountID 12345678910 and region us-east-1.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct ListAggregateDiscoveredResources {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::list_aggregate_discovered_resources_input::Builder,
    }
    impl ListAggregateDiscoveredResources {
        /// Creates a new `ListAggregateDiscoveredResources`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::ListAggregateDiscoveredResourcesOutput,
            aws_smithy_http::result::SdkError<crate::error::ListAggregateDiscoveredResourcesError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::ListAggregateDiscoveredResourcesPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(self) -> crate::paginator::ListAggregateDiscoveredResourcesPaginator {
            crate::paginator::ListAggregateDiscoveredResourcesPaginator::new(
                self.handle,
                self.inner,
            )
        }
        /// <p>The name of the configuration aggregator. </p>
        pub fn configuration_aggregator_name(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(input.into());
            self
        }
        /// <p>The name of the configuration aggregator. </p>
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
        /// <p>The type of resources that you want Config to list in the response.</p>
        pub fn resource_type(mut self, input: crate::model::ResourceType) -> Self {
            self.inner = self.inner.resource_type(input);
            self
        }
        /// <p>The type of resources that you want Config to list in the response.</p>
        pub fn set_resource_type(
            mut self,
            input: std::option::Option<crate::model::ResourceType>,
        ) -> Self {
            self.inner = self.inner.set_resource_type(input);
            self
        }
        /// <p>Filters the results based on the <code>ResourceFilters</code> object.</p>
        pub fn filters(mut self, input: crate::model::ResourceFilters) -> Self {
            self.inner = self.inner.filters(input);
            self
        }
        /// <p>Filters the results based on the <code>ResourceFilters</code> object.</p>
        pub fn set_filters(
            mut self,
            input: std::option::Option<crate::model::ResourceFilters>,
        ) -> Self {
            self.inner = self.inner.set_filters(input);
            self
        }
        /// <p>The maximum number of resource identifiers returned on each page. You cannot specify a number greater than 100. If you specify 0, Config uses the default.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of resource identifiers returned on each page. You cannot specify a number greater than 100. If you specify 0, Config uses the default.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `ListDiscoveredResources`.
    ///
    /// <p>Accepts a resource type and returns a list of resource identifiers for the resources of that type. A resource identifier includes the resource type, ID, and (if available) the custom resource name. The results consist of resources that Config has discovered, including those that Config is not currently recording. You can narrow the results to include only resources that have specific resource IDs or a resource name.</p> <note>
    /// <p>You can specify either resource IDs or a resource name, but not both, in the same request.</p>
    /// </note>
    /// <p>The response is paginated. By default, Config lists 100 resource identifiers on each page. You can customize this number with the <code>limit</code> parameter. The response includes a <code>nextToken</code> string. To get the next page of results, run the request again and specify the string for the <code>nextToken</code> parameter.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct ListDiscoveredResources {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::list_discovered_resources_input::Builder,
    }
    impl ListDiscoveredResources {
        /// Creates a new `ListDiscoveredResources`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::ListDiscoveredResourcesOutput,
            aws_smithy_http::result::SdkError<crate::error::ListDiscoveredResourcesError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::ListDiscoveredResourcesPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(self) -> crate::paginator::ListDiscoveredResourcesPaginator {
            crate::paginator::ListDiscoveredResourcesPaginator::new(self.handle, self.inner)
        }
        /// <p>The type of resources that you want Config to list in the response.</p>
        pub fn resource_type(mut self, input: crate::model::ResourceType) -> Self {
            self.inner = self.inner.resource_type(input);
            self
        }
        /// <p>The type of resources that you want Config to list in the response.</p>
        pub fn set_resource_type(
            mut self,
            input: std::option::Option<crate::model::ResourceType>,
        ) -> Self {
            self.inner = self.inner.set_resource_type(input);
            self
        }
        /// Appends an item to `resourceIds`.
        ///
        /// To override the contents of this collection use [`set_resource_ids`](Self::set_resource_ids).
        ///
        /// <p>The IDs of only those resources that you want Config to list in the response. If you do not specify this parameter, Config lists all resources of the specified type that it has discovered.</p>
        pub fn resource_ids(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_ids(input.into());
            self
        }
        /// <p>The IDs of only those resources that you want Config to list in the response. If you do not specify this parameter, Config lists all resources of the specified type that it has discovered.</p>
        pub fn set_resource_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_resource_ids(input);
            self
        }
        /// <p>The custom name of only those resources that you want Config to list in the response. If you do not specify this parameter, Config lists all resources of the specified type that it has discovered.</p>
        pub fn resource_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_name(input.into());
            self
        }
        /// <p>The custom name of only those resources that you want Config to list in the response. If you do not specify this parameter, Config lists all resources of the specified type that it has discovered.</p>
        pub fn set_resource_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_resource_name(input);
            self
        }
        /// <p>The maximum number of resource identifiers returned on each page. The default is 100. You cannot specify a number greater than 100. If you specify 0, Config uses the default.</p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of resource identifiers returned on each page. The default is 100. You cannot specify a number greater than 100. If you specify 0, Config uses the default.</p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>Specifies whether Config includes deleted resources in the results. By default, deleted resources are not included.</p>
        pub fn include_deleted_resources(mut self, input: bool) -> Self {
            self.inner = self.inner.include_deleted_resources(input);
            self
        }
        /// <p>Specifies whether Config includes deleted resources in the results. By default, deleted resources are not included.</p>
        pub fn set_include_deleted_resources(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_include_deleted_resources(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `ListStoredQueries`.
    ///
    /// <p>Lists the stored queries for a single Amazon Web Services account and a single Amazon Web Services Region. The default is 100. </p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct ListStoredQueries {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::list_stored_queries_input::Builder,
    }
    impl ListStoredQueries {
        /// Creates a new `ListStoredQueries`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::ListStoredQueriesOutput,
            aws_smithy_http::result::SdkError<crate::error::ListStoredQueriesError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::ListStoredQueriesPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(self) -> crate::paginator::ListStoredQueriesPaginator {
            crate::paginator::ListStoredQueriesPaginator::new(self.handle, self.inner)
        }
        /// <p>The nextToken string returned in a previous request that you use to request the next page of results in a paginated response.</p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The nextToken string returned in a previous request that you use to request the next page of results in a paginated response.</p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
        /// <p>The maximum number of results to be returned with a single call.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.inner = self.inner.max_results(input);
            self
        }
        /// <p>The maximum number of results to be returned with a single call.</p>
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_results(input);
            self
        }
    }
    /// Fluent builder constructing a request to `ListTagsForResource`.
    ///
    /// <p>List the tags for Config resource.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct ListTagsForResource {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::list_tags_for_resource_input::Builder,
    }
    impl ListTagsForResource {
        /// Creates a new `ListTagsForResource`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::ListTagsForResourceOutput,
            aws_smithy_http::result::SdkError<crate::error::ListTagsForResourceError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::ListTagsForResourcePaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(self) -> crate::paginator::ListTagsForResourcePaginator {
            crate::paginator::ListTagsForResourcePaginator::new(self.handle, self.inner)
        }
        /// <p>The Amazon Resource Name (ARN) that identifies the resource for which to list the tags. Currently, the supported resources are <code>ConfigRule</code>, <code>ConfigurationAggregator</code> and <code>AggregatorAuthorization</code>.</p>
        pub fn resource_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_arn(input.into());
            self
        }
        /// <p>The Amazon Resource Name (ARN) that identifies the resource for which to list the tags. Currently, the supported resources are <code>ConfigRule</code>, <code>ConfigurationAggregator</code> and <code>AggregatorAuthorization</code>.</p>
        pub fn set_resource_arn(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_resource_arn(input);
            self
        }
        /// <p>The maximum number of tags returned on each page. The limit maximum is 50. You cannot specify a number greater than 50. If you specify 0, Config uses the default. </p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of tags returned on each page. The limit maximum is 50. You cannot specify a number greater than 50. If you specify 0, Config uses the default. </p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `PutAggregationAuthorization`.
    ///
    /// <p>Authorizes the aggregator account and region to collect data from the source account and region. </p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct PutAggregationAuthorization {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::put_aggregation_authorization_input::Builder,
    }
    impl PutAggregationAuthorization {
        /// Creates a new `PutAggregationAuthorization`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutAggregationAuthorizationOutput,
            aws_smithy_http::result::SdkError<crate::error::PutAggregationAuthorizationError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The 12-digit account ID of the account authorized to aggregate data.</p>
        pub fn authorized_account_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.authorized_account_id(input.into());
            self
        }
        /// <p>The 12-digit account ID of the account authorized to aggregate data.</p>
        pub fn set_authorized_account_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_authorized_account_id(input);
            self
        }
        /// <p>The region authorized to collect aggregated data.</p>
        pub fn authorized_aws_region(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.authorized_aws_region(input.into());
            self
        }
        /// <p>The region authorized to collect aggregated data.</p>
        pub fn set_authorized_aws_region(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_authorized_aws_region(input);
            self
        }
        /// Appends an item to `Tags`.
        ///
        /// To override the contents of this collection use [`set_tags`](Self::set_tags).
        ///
        /// <p>An array of tag object.</p>
        pub fn tags(mut self, input: crate::model::Tag) -> Self {
            self.inner = self.inner.tags(input);
            self
        }
        /// <p>An array of tag object.</p>
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
    }
    /// Fluent builder constructing a request to `PutConfigRule`.
    ///
    /// <p>Adds or updates an Config rule for evaluating whether your Amazon Web Services resources comply with your desired configurations.</p>
    /// <p>You can use this action for custom Config rules and Config managed rules. A custom Config rule is a rule that you develop and maintain. An Config managed rule is a customizable, predefined rule that Config provides.</p>
    /// <p>If you are adding a new custom Config rule, you must first create the Lambda function that the rule invokes to evaluate your resources. When you use the <code>PutConfigRule</code> action to add the rule to Config, you must specify the Amazon Resource Name (ARN) that Lambda assigns to the function. Specify the ARN for the <code>SourceIdentifier</code> key. This key is part of the <code>Source</code> object, which is part of the <code>ConfigRule</code> object. </p>
    /// <p>If you are adding an Config managed rule, specify the rule's identifier for the <code>SourceIdentifier</code> key. To reference Config managed rule identifiers, see <a href="https://docs.aws.amazon.com/config/latest/developerguide/evaluate-config_use-managed-rules.html">About Config managed rules</a>.</p>
    /// <p>For any new rule that you add, specify the <code>ConfigRuleName</code> in the <code>ConfigRule</code> object. Do not specify the <code>ConfigRuleArn</code> or the <code>ConfigRuleId</code>. These values are generated by Config for new rules.</p>
    /// <p>If you are updating a rule that you added previously, you can specify the rule by <code>ConfigRuleName</code>, <code>ConfigRuleId</code>, or <code>ConfigRuleArn</code> in the <code>ConfigRule</code> data type that you use in this request.</p>
    /// <p>The maximum number of rules that Config supports is 150.</p>
    /// <p>For information about requesting a rule limit increase, see <a href="http://docs.aws.amazon.com/general/latest/gr/aws_service_limits.html#limits_config">Config Limits</a> in the <i>Amazon Web Services General Reference Guide</i>.</p>
    /// <p>For more information about developing and using Config rules, see <a href="https://docs.aws.amazon.com/config/latest/developerguide/evaluate-config.html">Evaluating Amazon Web Services resource Configurations with Config</a> in the <i>Config Developer Guide</i>.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct PutConfigRule {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::put_config_rule_input::Builder,
    }
    impl PutConfigRule {
        /// Creates a new `PutConfigRule`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutConfigRuleOutput,
            aws_smithy_http::result::SdkError<crate::error::PutConfigRuleError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The rule that you want to add to your account.</p>
        pub fn config_rule(mut self, input: crate::model::ConfigRule) -> Self {
            self.inner = self.inner.config_rule(input);
            self
        }
        /// <p>The rule that you want to add to your account.</p>
        pub fn set_config_rule(
            mut self,
            input: std::option::Option<crate::model::ConfigRule>,
        ) -> Self {
            self.inner = self.inner.set_config_rule(input);
            self
        }
        /// Appends an item to `Tags`.
        ///
        /// To override the contents of this collection use [`set_tags`](Self::set_tags).
        ///
        /// <p>An array of tag object.</p>
        pub fn tags(mut self, input: crate::model::Tag) -> Self {
            self.inner = self.inner.tags(input);
            self
        }
        /// <p>An array of tag object.</p>
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
    }
    /// Fluent builder constructing a request to `PutConfigurationAggregator`.
    ///
    /// <p>Creates and updates the configuration aggregator with the selected source accounts and regions. The source account can be individual account(s) or an organization.</p>
    /// <p> <code>accountIds</code> that are passed will be replaced with existing accounts. If you want to add additional accounts into the aggregator, call <code>DescribeConfigurationAggregators</code> to get the previous accounts and then append new ones.</p> <note>
    /// <p>Config should be enabled in source accounts and regions you want to aggregate.</p>
    /// <p>If your source type is an organization, you must be signed in to the management account or a registered delegated administrator and all the features must be enabled in your organization. If the caller is a management account, Config calls <code>EnableAwsServiceAccess</code> API to enable integration between Config and Organizations. If the caller is a registered delegated administrator, Config calls <code>ListDelegatedAdministrators</code> API to verify whether the caller is a valid delegated administrator.</p>
    /// <p>To register a delegated administrator, see <a href="https://docs.aws.amazon.com/config/latest/developerguide/set-up-aggregator-cli.html#register-a-delegated-administrator-cli">Register a Delegated Administrator</a> in the Config developer guide. </p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct PutConfigurationAggregator {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::put_configuration_aggregator_input::Builder,
    }
    impl PutConfigurationAggregator {
        /// Creates a new `PutConfigurationAggregator`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutConfigurationAggregatorOutput,
            aws_smithy_http::result::SdkError<crate::error::PutConfigurationAggregatorError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn configuration_aggregator_name(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(input.into());
            self
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
        /// Appends an item to `AccountAggregationSources`.
        ///
        /// To override the contents of this collection use [`set_account_aggregation_sources`](Self::set_account_aggregation_sources).
        ///
        /// <p>A list of AccountAggregationSource object. </p>
        pub fn account_aggregation_sources(
            mut self,
            input: crate::model::AccountAggregationSource,
        ) -> Self {
            self.inner = self.inner.account_aggregation_sources(input);
            self
        }
        /// <p>A list of AccountAggregationSource object. </p>
        pub fn set_account_aggregation_sources(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::AccountAggregationSource>>,
        ) -> Self {
            self.inner = self.inner.set_account_aggregation_sources(input);
            self
        }
        /// <p>An OrganizationAggregationSource object.</p>
        pub fn organization_aggregation_source(
            mut self,
            input: crate::model::OrganizationAggregationSource,
        ) -> Self {
            self.inner = self.inner.organization_aggregation_source(input);
            self
        }
        /// <p>An OrganizationAggregationSource object.</p>
        pub fn set_organization_aggregation_source(
            mut self,
            input: std::option::Option<crate::model::OrganizationAggregationSource>,
        ) -> Self {
            self.inner = self.inner.set_organization_aggregation_source(input);
            self
        }
        /// Appends an item to `Tags`.
        ///
        /// To override the contents of this collection use [`set_tags`](Self::set_tags).
        ///
        /// <p>An array of tag object.</p>
        pub fn tags(mut self, input: crate::model::Tag) -> Self {
            self.inner = self.inner.tags(input);
            self
        }
        /// <p>An array of tag object.</p>
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
    }
    /// Fluent builder constructing a request to `PutConfigurationRecorder`.
    ///
    /// <p>Creates a new configuration recorder to record the selected resource configurations.</p>
    /// <p>You can use this action to change the role <code>roleARN</code> or the <code>recordingGroup</code> of an existing recorder. To change the role, call the action on the existing configuration recorder and specify a role.</p> <note>
    /// <p>Currently, you can specify only one configuration recorder per region in your account.</p>
    /// <p>If <code>ConfigurationRecorder</code> does not have the <b>recordingGroup</b> parameter specified, the default is to record all supported resource types.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct PutConfigurationRecorder {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::put_configuration_recorder_input::Builder,
    }
    impl PutConfigurationRecorder {
        /// Creates a new `PutConfigurationRecorder`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutConfigurationRecorderOutput,
            aws_smithy_http::result::SdkError<crate::error::PutConfigurationRecorderError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The configuration recorder object that records each configuration change made to the resources.</p>
        pub fn configuration_recorder(
            mut self,
            input: crate::model::ConfigurationRecorder,
        ) -> Self {
            self.inner = self.inner.configuration_recorder(input);
            self
        }
        /// <p>The configuration recorder object that records each configuration change made to the resources.</p>
        pub fn set_configuration_recorder(
            mut self,
            input: std::option::Option<crate::model::ConfigurationRecorder>,
        ) -> Self {
            self.inner = self.inner.set_configuration_recorder(input);
            self
        }
    }
    /// Fluent builder constructing a request to `PutConformancePack`.
    ///
    /// <p>Creates or updates a conformance pack. A conformance pack is a collection of Config rules that can be easily deployed in an account and a region and across Amazon Web Services Organization.</p>
    /// <p>This API creates a service linked role <code>AWSServiceRoleForConfigConforms</code> in your account. The service linked role is created only when the role does not exist in your account. </p> <note>
    /// <p>You must specify either the <code>TemplateS3Uri</code> or the <code>TemplateBody</code> parameter, but not both. If you provide both Config uses the <code>TemplateS3Uri</code> parameter and ignores the <code>TemplateBody</code> parameter.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct PutConformancePack {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::put_conformance_pack_input::Builder,
    }
    impl PutConformancePack {
        /// Creates a new `PutConformancePack`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutConformancePackOutput,
            aws_smithy_http::result::SdkError<crate::error::PutConformancePackError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>Name of the conformance pack you want to create.</p>
        pub fn conformance_pack_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.conformance_pack_name(input.into());
            self
        }
        /// <p>Name of the conformance pack you want to create.</p>
        pub fn set_conformance_pack_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_conformance_pack_name(input);
            self
        }
        /// <p>Location of file containing the template body (<code>s3://bucketname/prefix</code>). The uri must point to the conformance pack template (max size: 300 KB) that is located in an Amazon S3 bucket in the same region as the conformance pack. </p> <note>
        /// <p>You must have access to read Amazon S3 bucket.</p>
        /// </note>
        pub fn template_s3_uri(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.template_s3_uri(input.into());
            self
        }
        /// <p>Location of file containing the template body (<code>s3://bucketname/prefix</code>). The uri must point to the conformance pack template (max size: 300 KB) that is located in an Amazon S3 bucket in the same region as the conformance pack. </p> <note>
        /// <p>You must have access to read Amazon S3 bucket.</p>
        /// </note>
        pub fn set_template_s3_uri(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_template_s3_uri(input);
            self
        }
        /// <p>A string containing full conformance pack template body. Structure containing the template body with a minimum length of 1 byte and a maximum length of 51,200 bytes.</p> <note>
        /// <p>You can only use a YAML template with two resource types: config rule (<code>AWS::Config::ConfigRule</code>) and a remediation action (<code>AWS::Config::RemediationConfiguration</code>).</p>
        /// </note>
        pub fn template_body(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.template_body(input.into());
            self
        }
        /// <p>A string containing full conformance pack template body. Structure containing the template body with a minimum length of 1 byte and a maximum length of 51,200 bytes.</p> <note>
        /// <p>You can only use a YAML template with two resource types: config rule (<code>AWS::Config::ConfigRule</code>) and a remediation action (<code>AWS::Config::RemediationConfiguration</code>).</p>
        /// </note>
        pub fn set_template_body(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_template_body(input);
            self
        }
        /// <p>The name of the Amazon S3 bucket where Config stores conformance pack templates.</p> <note>
        /// <p>This field is optional.</p>
        /// </note>
        pub fn delivery_s3_bucket(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.delivery_s3_bucket(input.into());
            self
        }
        /// <p>The name of the Amazon S3 bucket where Config stores conformance pack templates.</p> <note>
        /// <p>This field is optional.</p>
        /// </note>
        pub fn set_delivery_s3_bucket(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_delivery_s3_bucket(input);
            self
        }
        /// <p>The prefix for the Amazon S3 bucket. </p> <note>
        /// <p>This field is optional.</p>
        /// </note>
        pub fn delivery_s3_key_prefix(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.delivery_s3_key_prefix(input.into());
            self
        }
        /// <p>The prefix for the Amazon S3 bucket. </p> <note>
        /// <p>This field is optional.</p>
        /// </note>
        pub fn set_delivery_s3_key_prefix(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_delivery_s3_key_prefix(input);
            self
        }
        /// Appends an item to `ConformancePackInputParameters`.
        ///
        /// To override the contents of this collection use [`set_conformance_pack_input_parameters`](Self::set_conformance_pack_input_parameters).
        ///
        /// <p>A list of <code>ConformancePackInputParameter</code> objects.</p>
        pub fn conformance_pack_input_parameters(
            mut self,
            input: crate::model::ConformancePackInputParameter,
        ) -> Self {
            self.inner = self.inner.conformance_pack_input_parameters(input);
            self
        }
        /// <p>A list of <code>ConformancePackInputParameter</code> objects.</p>
        pub fn set_conformance_pack_input_parameters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ConformancePackInputParameter>>,
        ) -> Self {
            self.inner = self.inner.set_conformance_pack_input_parameters(input);
            self
        }
    }
    /// Fluent builder constructing a request to `PutDeliveryChannel`.
    ///
    /// <p>Creates a delivery channel object to deliver configuration information to an Amazon S3 bucket and Amazon SNS topic.</p>
    /// <p>Before you can create a delivery channel, you must create a configuration recorder.</p>
    /// <p>You can use this action to change the Amazon S3 bucket or an Amazon SNS topic of the existing delivery channel. To change the Amazon S3 bucket or an Amazon SNS topic, call this action and specify the changed values for the S3 bucket and the SNS topic. If you specify a different value for either the S3 bucket or the SNS topic, this action will keep the existing value for the parameter that is not changed.</p> <note>
    /// <p>You can have only one delivery channel per region in your account.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct PutDeliveryChannel {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::put_delivery_channel_input::Builder,
    }
    impl PutDeliveryChannel {
        /// Creates a new `PutDeliveryChannel`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutDeliveryChannelOutput,
            aws_smithy_http::result::SdkError<crate::error::PutDeliveryChannelError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The configuration delivery channel object that delivers the configuration information to an Amazon S3 bucket and to an Amazon SNS topic.</p>
        pub fn delivery_channel(mut self, input: crate::model::DeliveryChannel) -> Self {
            self.inner = self.inner.delivery_channel(input);
            self
        }
        /// <p>The configuration delivery channel object that delivers the configuration information to an Amazon S3 bucket and to an Amazon SNS topic.</p>
        pub fn set_delivery_channel(
            mut self,
            input: std::option::Option<crate::model::DeliveryChannel>,
        ) -> Self {
            self.inner = self.inner.set_delivery_channel(input);
            self
        }
    }
    /// Fluent builder constructing a request to `PutEvaluations`.
    ///
    /// <p>Used by an Lambda function to deliver evaluation results to Config. This action is required in every Lambda function that is invoked by an Config rule.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct PutEvaluations {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::put_evaluations_input::Builder,
    }
    impl PutEvaluations {
        /// Creates a new `PutEvaluations`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutEvaluationsOutput,
            aws_smithy_http::result::SdkError<crate::error::PutEvaluationsError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `Evaluations`.
        ///
        /// To override the contents of this collection use [`set_evaluations`](Self::set_evaluations).
        ///
        /// <p>The assessments that the Lambda function performs. Each evaluation identifies an Amazon Web Services resource and indicates whether it complies with the Config rule that invokes the Lambda function.</p>
        pub fn evaluations(mut self, input: crate::model::Evaluation) -> Self {
            self.inner = self.inner.evaluations(input);
            self
        }
        /// <p>The assessments that the Lambda function performs. Each evaluation identifies an Amazon Web Services resource and indicates whether it complies with the Config rule that invokes the Lambda function.</p>
        pub fn set_evaluations(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Evaluation>>,
        ) -> Self {
            self.inner = self.inner.set_evaluations(input);
            self
        }
        /// <p>An encrypted token that associates an evaluation with an Config rule. Identifies the rule and the event that triggered the evaluation.</p>
        pub fn result_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.result_token(input.into());
            self
        }
        /// <p>An encrypted token that associates an evaluation with an Config rule. Identifies the rule and the event that triggered the evaluation.</p>
        pub fn set_result_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_result_token(input);
            self
        }
        /// <p>Use this parameter to specify a test run for <code>PutEvaluations</code>. You can verify whether your Lambda function will deliver evaluation results to Config. No updates occur to your existing evaluations, and evaluation results are not sent to Config.</p> <note>
        /// <p>When <code>TestMode</code> is <code>true</code>, <code>PutEvaluations</code> doesn't require a valid value for the <code>ResultToken</code> parameter, but the value cannot be null.</p>
        /// </note>
        pub fn test_mode(mut self, input: bool) -> Self {
            self.inner = self.inner.test_mode(input);
            self
        }
        /// <p>Use this parameter to specify a test run for <code>PutEvaluations</code>. You can verify whether your Lambda function will deliver evaluation results to Config. No updates occur to your existing evaluations, and evaluation results are not sent to Config.</p> <note>
        /// <p>When <code>TestMode</code> is <code>true</code>, <code>PutEvaluations</code> doesn't require a valid value for the <code>ResultToken</code> parameter, but the value cannot be null.</p>
        /// </note>
        pub fn set_test_mode(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_test_mode(input);
            self
        }
    }
    /// Fluent builder constructing a request to `PutExternalEvaluation`.
    ///
    /// <p>Add or updates the evaluations for process checks. This API checks if the rule is a process check when the name of the Config rule is provided.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct PutExternalEvaluation {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::put_external_evaluation_input::Builder,
    }
    impl PutExternalEvaluation {
        /// Creates a new `PutExternalEvaluation`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutExternalEvaluationOutput,
            aws_smithy_http::result::SdkError<crate::error::PutExternalEvaluationError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the Config rule.</p>
        pub fn config_rule_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_name(input.into());
            self
        }
        /// <p>The name of the Config rule.</p>
        pub fn set_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_name(input);
            self
        }
        /// <p>An <code>ExternalEvaluation</code> object that provides details about compliance.</p>
        pub fn external_evaluation(mut self, input: crate::model::ExternalEvaluation) -> Self {
            self.inner = self.inner.external_evaluation(input);
            self
        }
        /// <p>An <code>ExternalEvaluation</code> object that provides details about compliance.</p>
        pub fn set_external_evaluation(
            mut self,
            input: std::option::Option<crate::model::ExternalEvaluation>,
        ) -> Self {
            self.inner = self.inner.set_external_evaluation(input);
            self
        }
    }
    /// Fluent builder constructing a request to `PutOrganizationConfigRule`.
    ///
    /// <p>Adds or updates organization config rule for your entire organization evaluating whether your Amazon Web Services resources comply with your desired configurations.</p>
    /// <p> Only a master account and a delegated administrator can create or update an organization config rule. When calling this API with a delegated administrator, you must ensure Organizations <code>ListDelegatedAdministrator</code> permissions are added. </p>
    /// <p>This API enables organization service access through the <code>EnableAWSServiceAccess</code> action and creates a service linked role <code>AWSServiceRoleForConfigMultiAccountSetup</code> in the master or delegated administrator account of your organization. The service linked role is created only when the role does not exist in the caller account. Config verifies the existence of role with <code>GetRole</code> action.</p>
    /// <p>To use this API with delegated administrator, register a delegated administrator by calling Amazon Web Services Organization <code>register-delegated-administrator</code> for <code>config-multiaccountsetup.amazonaws.com</code>. </p>
    /// <p>You can use this action to create both custom Config rules and Config managed rules. If you are adding a new custom Config rule, you must first create Lambda function in the master account or a delegated administrator that the rule invokes to evaluate your resources. You also need to create an IAM role in the managed-account that can be assumed by the Lambda function. When you use the <code>PutOrganizationConfigRule</code> action to add the rule to Config, you must specify the Amazon Resource Name (ARN) that Lambda assigns to the function. If you are adding an Config managed rule, specify the rule's identifier for the <code>RuleIdentifier</code> key.</p>
    /// <p>The maximum number of organization config rules that Config supports is 150 and 3 delegated administrator per organization. </p> <note>
    /// <p>Prerequisite: Ensure you call <code>EnableAllFeatures</code> API to enable all features in an organization.</p>
    /// <p>Specify either <code>OrganizationCustomRuleMetadata</code> or <code>OrganizationManagedRuleMetadata</code>.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct PutOrganizationConfigRule {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::put_organization_config_rule_input::Builder,
    }
    impl PutOrganizationConfigRule {
        /// Creates a new `PutOrganizationConfigRule`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutOrganizationConfigRuleOutput,
            aws_smithy_http::result::SdkError<crate::error::PutOrganizationConfigRuleError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The name that you assign to an organization config rule.</p>
        pub fn organization_config_rule_name(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.organization_config_rule_name(input.into());
            self
        }
        /// <p>The name that you assign to an organization config rule.</p>
        pub fn set_organization_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_organization_config_rule_name(input);
            self
        }
        /// <p>An <code>OrganizationManagedRuleMetadata</code> object. </p>
        pub fn organization_managed_rule_metadata(
            mut self,
            input: crate::model::OrganizationManagedRuleMetadata,
        ) -> Self {
            self.inner = self.inner.organization_managed_rule_metadata(input);
            self
        }
        /// <p>An <code>OrganizationManagedRuleMetadata</code> object. </p>
        pub fn set_organization_managed_rule_metadata(
            mut self,
            input: std::option::Option<crate::model::OrganizationManagedRuleMetadata>,
        ) -> Self {
            self.inner = self.inner.set_organization_managed_rule_metadata(input);
            self
        }
        /// <p>An <code>OrganizationCustomRuleMetadata</code> object.</p>
        pub fn organization_custom_rule_metadata(
            mut self,
            input: crate::model::OrganizationCustomRuleMetadata,
        ) -> Self {
            self.inner = self.inner.organization_custom_rule_metadata(input);
            self
        }
        /// <p>An <code>OrganizationCustomRuleMetadata</code> object.</p>
        pub fn set_organization_custom_rule_metadata(
            mut self,
            input: std::option::Option<crate::model::OrganizationCustomRuleMetadata>,
        ) -> Self {
            self.inner = self.inner.set_organization_custom_rule_metadata(input);
            self
        }
        /// Appends an item to `ExcludedAccounts`.
        ///
        /// To override the contents of this collection use [`set_excluded_accounts`](Self::set_excluded_accounts).
        ///
        /// <p>A comma-separated list of accounts that you want to exclude from an organization config rule.</p>
        pub fn excluded_accounts(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.excluded_accounts(input.into());
            self
        }
        /// <p>A comma-separated list of accounts that you want to exclude from an organization config rule.</p>
        pub fn set_excluded_accounts(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_excluded_accounts(input);
            self
        }
    }
    /// Fluent builder constructing a request to `PutOrganizationConformancePack`.
    ///
    /// <p>Deploys conformance packs across member accounts in an Amazon Web Services Organization.</p>
    /// <p>Only a master account and a delegated administrator can call this API. When calling this API with a delegated administrator, you must ensure Organizations <code>ListDelegatedAdministrator</code> permissions are added.</p>
    /// <p>This API enables organization service access for <code>config-multiaccountsetup.amazonaws.com</code> through the <code>EnableAWSServiceAccess</code> action and creates a service linked role <code>AWSServiceRoleForConfigMultiAccountSetup</code> in the master or delegated administrator account of your organization. The service linked role is created only when the role does not exist in the caller account. To use this API with delegated administrator, register a delegated administrator by calling Amazon Web Services Organization <code>register-delegate-admin</code> for <code>config-multiaccountsetup.amazonaws.com</code>.</p> <note>
    /// <p>Prerequisite: Ensure you call <code>EnableAllFeatures</code> API to enable all features in an organization.</p>
    /// <p>You must specify either the <code>TemplateS3Uri</code> or the <code>TemplateBody</code> parameter, but not both. If you provide both Config uses the <code>TemplateS3Uri</code> parameter and ignores the <code>TemplateBody</code> parameter.</p>
    /// <p>Config sets the state of a conformance pack to CREATE_IN_PROGRESS and UPDATE_IN_PROGRESS until the conformance pack is created or updated. You cannot update a conformance pack while it is in this state.</p>
    /// <p>You can create 50 conformance packs with 25 Config rules in each pack and 3 delegated administrator per organization. </p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct PutOrganizationConformancePack {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::put_organization_conformance_pack_input::Builder,
    }
    impl PutOrganizationConformancePack {
        /// Creates a new `PutOrganizationConformancePack`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutOrganizationConformancePackOutput,
            aws_smithy_http::result::SdkError<crate::error::PutOrganizationConformancePackError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>Name of the organization conformance pack you want to create.</p>
        pub fn organization_conformance_pack_name(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.organization_conformance_pack_name(input.into());
            self
        }
        /// <p>Name of the organization conformance pack you want to create.</p>
        pub fn set_organization_conformance_pack_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_organization_conformance_pack_name(input);
            self
        }
        /// <p>Location of file containing the template body. The uri must point to the conformance pack template (max size: 300 KB).</p> <note>
        /// <p>You must have access to read Amazon S3 bucket.</p>
        /// </note>
        pub fn template_s3_uri(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.template_s3_uri(input.into());
            self
        }
        /// <p>Location of file containing the template body. The uri must point to the conformance pack template (max size: 300 KB).</p> <note>
        /// <p>You must have access to read Amazon S3 bucket.</p>
        /// </note>
        pub fn set_template_s3_uri(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_template_s3_uri(input);
            self
        }
        /// <p>A string containing full conformance pack template body. Structure containing the template body with a minimum length of 1 byte and a maximum length of 51,200 bytes.</p>
        pub fn template_body(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.template_body(input.into());
            self
        }
        /// <p>A string containing full conformance pack template body. Structure containing the template body with a minimum length of 1 byte and a maximum length of 51,200 bytes.</p>
        pub fn set_template_body(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_template_body(input);
            self
        }
        /// <p>The name of the Amazon S3 bucket where Config stores conformance pack templates.</p> <note>
        /// <p>This field is optional. If used, it must be prefixed with <code>awsconfigconforms</code>.</p>
        /// </note>
        pub fn delivery_s3_bucket(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.delivery_s3_bucket(input.into());
            self
        }
        /// <p>The name of the Amazon S3 bucket where Config stores conformance pack templates.</p> <note>
        /// <p>This field is optional. If used, it must be prefixed with <code>awsconfigconforms</code>.</p>
        /// </note>
        pub fn set_delivery_s3_bucket(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_delivery_s3_bucket(input);
            self
        }
        /// <p>The prefix for the Amazon S3 bucket.</p> <note>
        /// <p>This field is optional.</p>
        /// </note>
        pub fn delivery_s3_key_prefix(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.delivery_s3_key_prefix(input.into());
            self
        }
        /// <p>The prefix for the Amazon S3 bucket.</p> <note>
        /// <p>This field is optional.</p>
        /// </note>
        pub fn set_delivery_s3_key_prefix(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_delivery_s3_key_prefix(input);
            self
        }
        /// Appends an item to `ConformancePackInputParameters`.
        ///
        /// To override the contents of this collection use [`set_conformance_pack_input_parameters`](Self::set_conformance_pack_input_parameters).
        ///
        /// <p>A list of <code>ConformancePackInputParameter</code> objects.</p>
        pub fn conformance_pack_input_parameters(
            mut self,
            input: crate::model::ConformancePackInputParameter,
        ) -> Self {
            self.inner = self.inner.conformance_pack_input_parameters(input);
            self
        }
        /// <p>A list of <code>ConformancePackInputParameter</code> objects.</p>
        pub fn set_conformance_pack_input_parameters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ConformancePackInputParameter>>,
        ) -> Self {
            self.inner = self.inner.set_conformance_pack_input_parameters(input);
            self
        }
        /// Appends an item to `ExcludedAccounts`.
        ///
        /// To override the contents of this collection use [`set_excluded_accounts`](Self::set_excluded_accounts).
        ///
        /// <p>A list of Amazon Web Services accounts to be excluded from an organization conformance pack while deploying a conformance pack.</p>
        pub fn excluded_accounts(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.excluded_accounts(input.into());
            self
        }
        /// <p>A list of Amazon Web Services accounts to be excluded from an organization conformance pack while deploying a conformance pack.</p>
        pub fn set_excluded_accounts(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_excluded_accounts(input);
            self
        }
    }
    /// Fluent builder constructing a request to `PutRemediationConfigurations`.
    ///
    /// <p>Adds or updates the remediation configuration with a specific Config rule with the selected target or action. The API creates the <code>RemediationConfiguration</code> object for the Config rule. The Config rule must already exist for you to add a remediation configuration. The target (SSM document) must exist and have permissions to use the target. </p> <note>
    /// <p>If you make backward incompatible changes to the SSM document, you must call this again to ensure the remediations can run.</p>
    /// <p>This API does not support adding remediation configurations for service-linked Config Rules such as Organization Config rules, the rules deployed by conformance packs, and rules deployed by Amazon Web Services Security Hub.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct PutRemediationConfigurations {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::put_remediation_configurations_input::Builder,
    }
    impl PutRemediationConfigurations {
        /// Creates a new `PutRemediationConfigurations`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutRemediationConfigurationsOutput,
            aws_smithy_http::result::SdkError<crate::error::PutRemediationConfigurationsError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `RemediationConfigurations`.
        ///
        /// To override the contents of this collection use [`set_remediation_configurations`](Self::set_remediation_configurations).
        ///
        /// <p>A list of remediation configuration objects.</p>
        pub fn remediation_configurations(
            mut self,
            input: crate::model::RemediationConfiguration,
        ) -> Self {
            self.inner = self.inner.remediation_configurations(input);
            self
        }
        /// <p>A list of remediation configuration objects.</p>
        pub fn set_remediation_configurations(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::RemediationConfiguration>>,
        ) -> Self {
            self.inner = self.inner.set_remediation_configurations(input);
            self
        }
    }
    /// Fluent builder constructing a request to `PutRemediationExceptions`.
    ///
    /// <p>A remediation exception is when a specific resource is no longer considered for auto-remediation. This API adds a new exception or updates an existing exception for a specific resource with a specific Config rule. </p> <note>
    /// <p>Config generates a remediation exception when a problem occurs executing a remediation action to a specific resource. Remediation exceptions blocks auto-remediation until the exception is cleared.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct PutRemediationExceptions {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::put_remediation_exceptions_input::Builder,
    }
    impl PutRemediationExceptions {
        /// Creates a new `PutRemediationExceptions`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutRemediationExceptionsOutput,
            aws_smithy_http::result::SdkError<crate::error::PutRemediationExceptionsError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the Config rule for which you want to create remediation exception.</p>
        pub fn config_rule_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_name(input.into());
            self
        }
        /// <p>The name of the Config rule for which you want to create remediation exception.</p>
        pub fn set_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_name(input);
            self
        }
        /// Appends an item to `ResourceKeys`.
        ///
        /// To override the contents of this collection use [`set_resource_keys`](Self::set_resource_keys).
        ///
        /// <p>An exception list of resource exception keys to be processed with the current request. Config adds exception for each resource key. For example, Config adds 3 exceptions for 3 resource keys. </p>
        pub fn resource_keys(
            mut self,
            input: crate::model::RemediationExceptionResourceKey,
        ) -> Self {
            self.inner = self.inner.resource_keys(input);
            self
        }
        /// <p>An exception list of resource exception keys to be processed with the current request. Config adds exception for each resource key. For example, Config adds 3 exceptions for 3 resource keys. </p>
        pub fn set_resource_keys(
            mut self,
            input: std::option::Option<
                std::vec::Vec<crate::model::RemediationExceptionResourceKey>,
            >,
        ) -> Self {
            self.inner = self.inner.set_resource_keys(input);
            self
        }
        /// <p>The message contains an explanation of the exception.</p>
        pub fn message(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.message(input.into());
            self
        }
        /// <p>The message contains an explanation of the exception.</p>
        pub fn set_message(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_message(input);
            self
        }
        /// <p>The exception is automatically deleted after the expiration date.</p>
        pub fn expiration_time(mut self, input: aws_smithy_types::DateTime) -> Self {
            self.inner = self.inner.expiration_time(input);
            self
        }
        /// <p>The exception is automatically deleted after the expiration date.</p>
        pub fn set_expiration_time(
            mut self,
            input: std::option::Option<aws_smithy_types::DateTime>,
        ) -> Self {
            self.inner = self.inner.set_expiration_time(input);
            self
        }
    }
    /// Fluent builder constructing a request to `PutResourceConfig`.
    ///
    /// <p>Records the configuration state for the resource provided in the request. The configuration state of a resource is represented in Config as Configuration Items. Once this API records the configuration item, you can retrieve the list of configuration items for the custom resource type using existing Config APIs. </p> <note>
    /// <p>The custom resource type must be registered with CloudFormation. This API accepts the configuration item registered with CloudFormation.</p>
    /// <p>When you call this API, Config only stores configuration state of the resource provided in the request. This API does not change or remediate the configuration of the resource. </p>
    /// <p>Write-only schema properites are not recorded as part of the published configuration item.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct PutResourceConfig {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::put_resource_config_input::Builder,
    }
    impl PutResourceConfig {
        /// Creates a new `PutResourceConfig`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutResourceConfigOutput,
            aws_smithy_http::result::SdkError<crate::error::PutResourceConfigError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The type of the resource. The custom resource type must be registered with CloudFormation. </p> <note>
        /// <p>You cannot use the organization names “amzn”, “amazon”, “alexa”, “custom” with custom resource types. It is the first part of the ResourceType up to the first ::.</p>
        /// </note>
        pub fn resource_type(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_type(input.into());
            self
        }
        /// <p>The type of the resource. The custom resource type must be registered with CloudFormation. </p> <note>
        /// <p>You cannot use the organization names “amzn”, “amazon”, “alexa”, “custom” with custom resource types. It is the first part of the ResourceType up to the first ::.</p>
        /// </note>
        pub fn set_resource_type(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_resource_type(input);
            self
        }
        /// <p>Version of the schema registered for the ResourceType in CloudFormation.</p>
        pub fn schema_version_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.schema_version_id(input.into());
            self
        }
        /// <p>Version of the schema registered for the ResourceType in CloudFormation.</p>
        pub fn set_schema_version_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_schema_version_id(input);
            self
        }
        /// <p>Unique identifier of the resource.</p>
        pub fn resource_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_id(input.into());
            self
        }
        /// <p>Unique identifier of the resource.</p>
        pub fn set_resource_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_resource_id(input);
            self
        }
        /// <p>Name of the resource.</p>
        pub fn resource_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_name(input.into());
            self
        }
        /// <p>Name of the resource.</p>
        pub fn set_resource_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_resource_name(input);
            self
        }
        /// <p>The configuration object of the resource in valid JSON format. It must match the schema registered with CloudFormation.</p> <note>
        /// <p>The configuration JSON must not exceed 64 KB.</p>
        /// </note>
        pub fn configuration(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.configuration(input.into());
            self
        }
        /// <p>The configuration object of the resource in valid JSON format. It must match the schema registered with CloudFormation.</p> <note>
        /// <p>The configuration JSON must not exceed 64 KB.</p>
        /// </note>
        pub fn set_configuration(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration(input);
            self
        }
        /// Adds a key-value pair to `Tags`.
        ///
        /// To override the contents of this collection use [`set_tags`](Self::set_tags).
        ///
        /// <p>Tags associated with the resource.</p>
        pub fn tags(
            mut self,
            k: impl Into<std::string::String>,
            v: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.tags(k.into(), v.into());
            self
        }
        /// <p>Tags associated with the resource.</p>
        pub fn set_tags(
            mut self,
            input: std::option::Option<
                std::collections::HashMap<std::string::String, std::string::String>,
            >,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
    }
    /// Fluent builder constructing a request to `PutRetentionConfiguration`.
    ///
    /// <p>Creates and updates the retention configuration with details about retention period (number of days) that Config stores your historical information. The API creates the <code>RetentionConfiguration</code> object and names the object as <b>default</b>. When you have a <code>RetentionConfiguration</code> object named <b>default</b>, calling the API modifies the default object. </p> <note>
    /// <p>Currently, Config supports only one retention configuration per region in your account.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct PutRetentionConfiguration {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::put_retention_configuration_input::Builder,
    }
    impl PutRetentionConfiguration {
        /// Creates a new `PutRetentionConfiguration`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutRetentionConfigurationOutput,
            aws_smithy_http::result::SdkError<crate::error::PutRetentionConfigurationError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>Number of days Config stores your historical information.</p> <note>
        /// <p>Currently, only applicable to the configuration item history.</p>
        /// </note>
        pub fn retention_period_in_days(mut self, input: i32) -> Self {
            self.inner = self.inner.retention_period_in_days(input);
            self
        }
        /// <p>Number of days Config stores your historical information.</p> <note>
        /// <p>Currently, only applicable to the configuration item history.</p>
        /// </note>
        pub fn set_retention_period_in_days(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_retention_period_in_days(input);
            self
        }
    }
    /// Fluent builder constructing a request to `PutStoredQuery`.
    ///
    /// <p>Saves a new query or updates an existing saved query. The <code>QueryName</code> must be unique for a single Amazon Web Services account and a single Amazon Web Services Region. You can create upto 300 queries in a single Amazon Web Services account and a single Amazon Web Services Region.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct PutStoredQuery {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::put_stored_query_input::Builder,
    }
    impl PutStoredQuery {
        /// Creates a new `PutStoredQuery`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutStoredQueryOutput,
            aws_smithy_http::result::SdkError<crate::error::PutStoredQueryError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>A list of <code>StoredQuery</code> objects. The mandatory fields are <code>QueryName</code> and <code>Expression</code>.</p> <note>
        /// <p>When you are creating a query, you must provide a query name and an expression. When you are updating a query, you must provide a query name but updating the description is optional.</p>
        /// </note>
        pub fn stored_query(mut self, input: crate::model::StoredQuery) -> Self {
            self.inner = self.inner.stored_query(input);
            self
        }
        /// <p>A list of <code>StoredQuery</code> objects. The mandatory fields are <code>QueryName</code> and <code>Expression</code>.</p> <note>
        /// <p>When you are creating a query, you must provide a query name and an expression. When you are updating a query, you must provide a query name but updating the description is optional.</p>
        /// </note>
        pub fn set_stored_query(
            mut self,
            input: std::option::Option<crate::model::StoredQuery>,
        ) -> Self {
            self.inner = self.inner.set_stored_query(input);
            self
        }
        /// Appends an item to `Tags`.
        ///
        /// To override the contents of this collection use [`set_tags`](Self::set_tags).
        ///
        /// <p>A list of <code>Tags</code> object.</p>
        pub fn tags(mut self, input: crate::model::Tag) -> Self {
            self.inner = self.inner.tags(input);
            self
        }
        /// <p>A list of <code>Tags</code> object.</p>
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
    }
    /// Fluent builder constructing a request to `SelectAggregateResourceConfig`.
    ///
    /// <p>Accepts a structured query language (SQL) SELECT command and an aggregator to query configuration state of Amazon Web Services resources across multiple accounts and regions, performs the corresponding search, and returns resource configurations matching the properties.</p>
    /// <p>For more information about query components, see the <a href="https://docs.aws.amazon.com/config/latest/developerguide/query-components.html"> <b>Query Components</b> </a> section in the Config Developer Guide.</p> <note>
    /// <p>If you run an aggregation query (i.e., using <code>GROUP BY</code> or using aggregate functions such as <code>COUNT</code>; e.g., <code>SELECT resourceId, COUNT(*) WHERE resourceType = 'AWS::IAM::Role' GROUP BY resourceId</code>) and do not specify the <code>MaxResults</code> or the <code>Limit</code> query parameters, the default page size is set to 500.</p>
    /// <p>If you run a non-aggregation query (i.e., not using <code>GROUP BY</code> or aggregate function; e.g., <code>SELECT * WHERE resourceType = 'AWS::IAM::Role'</code>) and do not specify the <code>MaxResults</code> or the <code>Limit</code> query parameters, the default page size is set to 25.</p>
    /// </note>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct SelectAggregateResourceConfig {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::select_aggregate_resource_config_input::Builder,
    }
    impl SelectAggregateResourceConfig {
        /// Creates a new `SelectAggregateResourceConfig`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::SelectAggregateResourceConfigOutput,
            aws_smithy_http::result::SdkError<crate::error::SelectAggregateResourceConfigError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::SelectAggregateResourceConfigPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(self) -> crate::paginator::SelectAggregateResourceConfigPaginator {
            crate::paginator::SelectAggregateResourceConfigPaginator::new(self.handle, self.inner)
        }
        /// <p>The SQL query SELECT command. </p>
        pub fn expression(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.expression(input.into());
            self
        }
        /// <p>The SQL query SELECT command. </p>
        pub fn set_expression(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_expression(input);
            self
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn configuration_aggregator_name(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(input.into());
            self
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
        /// <p>The maximum number of query results returned on each page. </p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of query results returned on each page. </p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The maximum number of query results returned on each page. Config also allows the Limit request parameter.</p>
        pub fn max_results(mut self, input: i32) -> Self {
            self.inner = self.inner.max_results(input);
            self
        }
        /// <p>The maximum number of query results returned on each page. Config also allows the Limit request parameter.</p>
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_results(input);
            self
        }
        /// <p>The nextToken string returned in a previous request that you use to request the next page of results in a paginated response. </p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The nextToken string returned in a previous request that you use to request the next page of results in a paginated response. </p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `SelectResourceConfig`.
    ///
    /// <p>Accepts a structured query language (SQL) <code>SELECT</code> command, performs the corresponding search, and returns resource configurations matching the properties.</p>
    /// <p>For more information about query components, see the <a href="https://docs.aws.amazon.com/config/latest/developerguide/query-components.html"> <b>Query Components</b> </a> section in the Config Developer Guide.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct SelectResourceConfig {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::select_resource_config_input::Builder,
    }
    impl SelectResourceConfig {
        /// Creates a new `SelectResourceConfig`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::SelectResourceConfigOutput,
            aws_smithy_http::result::SdkError<crate::error::SelectResourceConfigError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Create a paginator for this request
        ///
        /// Paginators are used by calling [`send().await`](crate::paginator::SelectResourceConfigPaginator::send) which returns a [`Stream`](tokio_stream::Stream).
        pub fn into_paginator(self) -> crate::paginator::SelectResourceConfigPaginator {
            crate::paginator::SelectResourceConfigPaginator::new(self.handle, self.inner)
        }
        /// <p>The SQL query <code>SELECT</code> command.</p>
        pub fn expression(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.expression(input.into());
            self
        }
        /// <p>The SQL query <code>SELECT</code> command.</p>
        pub fn set_expression(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_expression(input);
            self
        }
        /// <p>The maximum number of query results returned on each page. </p>
        pub fn limit(mut self, input: i32) -> Self {
            self.inner = self.inner.limit(input);
            self
        }
        /// <p>The maximum number of query results returned on each page. </p>
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response. </p>
        pub fn next_token(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(input.into());
            self
        }
        /// <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response. </p>
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    /// Fluent builder constructing a request to `StartConfigRulesEvaluation`.
    ///
    /// <p>Runs an on-demand evaluation for the specified Config rules against the last known configuration state of the resources. Use <code>StartConfigRulesEvaluation</code> when you want to test that a rule you updated is working as expected. <code>StartConfigRulesEvaluation</code> does not re-record the latest configuration state for your resources. It re-runs an evaluation against the last known state of your resources. </p>
    /// <p>You can specify up to 25 Config rules per request. </p>
    /// <p>An existing <code>StartConfigRulesEvaluation</code> call for the specified rules must complete before you can call the API again. If you chose to have Config stream to an Amazon SNS topic, you will receive a <code>ConfigRuleEvaluationStarted</code> notification when the evaluation starts.</p> <note>
    /// <p>You don't need to call the <code>StartConfigRulesEvaluation</code> API to run an evaluation for a new rule. When you create a rule, Config evaluates your resources against the rule automatically. </p>
    /// </note>
    /// <p>The <code>StartConfigRulesEvaluation</code> API is useful if you want to run on-demand evaluations, such as the following example:</p>
    /// <ol>
    /// <li> <p>You have a custom rule that evaluates your IAM resources every 24 hours.</p> </li>
    /// <li> <p>You update your Lambda function to add additional conditions to your rule.</p> </li>
    /// <li> <p>Instead of waiting for the next periodic evaluation, you call the <code>StartConfigRulesEvaluation</code> API.</p> </li>
    /// <li> <p>Config invokes your Lambda function and evaluates your IAM resources.</p> </li>
    /// <li> <p>Your custom rule will still run periodic evaluations every 24 hours.</p> </li>
    /// </ol>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct StartConfigRulesEvaluation {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::start_config_rules_evaluation_input::Builder,
    }
    impl StartConfigRulesEvaluation {
        /// Creates a new `StartConfigRulesEvaluation`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::StartConfigRulesEvaluationOutput,
            aws_smithy_http::result::SdkError<crate::error::StartConfigRulesEvaluationError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `ConfigRuleNames`.
        ///
        /// To override the contents of this collection use [`set_config_rule_names`](Self::set_config_rule_names).
        ///
        /// <p>The list of names of Config rules that you want to run evaluations for.</p>
        pub fn config_rule_names(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_names(input.into());
            self
        }
        /// <p>The list of names of Config rules that you want to run evaluations for.</p>
        pub fn set_config_rule_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_names(input);
            self
        }
    }
    /// Fluent builder constructing a request to `StartConfigurationRecorder`.
    ///
    /// <p>Starts recording configurations of the Amazon Web Services resources you have selected to record in your Amazon Web Services account.</p>
    /// <p>You must have created at least one delivery channel to successfully start the configuration recorder.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct StartConfigurationRecorder {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::start_configuration_recorder_input::Builder,
    }
    impl StartConfigurationRecorder {
        /// Creates a new `StartConfigurationRecorder`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::StartConfigurationRecorderOutput,
            aws_smithy_http::result::SdkError<crate::error::StartConfigurationRecorderError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the recorder object that records each configuration change made to the resources.</p>
        pub fn configuration_recorder_name(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_recorder_name(input.into());
            self
        }
        /// <p>The name of the recorder object that records each configuration change made to the resources.</p>
        pub fn set_configuration_recorder_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_recorder_name(input);
            self
        }
    }
    /// Fluent builder constructing a request to `StartRemediationExecution`.
    ///
    /// <p>Runs an on-demand remediation for the specified Config rules against the last known remediation configuration. It runs an execution against the current state of your resources. Remediation execution is asynchronous.</p>
    /// <p>You can specify up to 100 resource keys per request. An existing StartRemediationExecution call for the specified resource keys must complete before you can call the API again.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct StartRemediationExecution {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::start_remediation_execution_input::Builder,
    }
    impl StartRemediationExecution {
        /// Creates a new `StartRemediationExecution`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::StartRemediationExecutionOutput,
            aws_smithy_http::result::SdkError<crate::error::StartRemediationExecutionError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The list of names of Config rules that you want to run remediation execution for.</p>
        pub fn config_rule_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_name(input.into());
            self
        }
        /// <p>The list of names of Config rules that you want to run remediation execution for.</p>
        pub fn set_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_name(input);
            self
        }
        /// Appends an item to `ResourceKeys`.
        ///
        /// To override the contents of this collection use [`set_resource_keys`](Self::set_resource_keys).
        ///
        /// <p>A list of resource keys to be processed with the current request. Each element in the list consists of the resource type and resource ID. </p>
        pub fn resource_keys(mut self, input: crate::model::ResourceKey) -> Self {
            self.inner = self.inner.resource_keys(input);
            self
        }
        /// <p>A list of resource keys to be processed with the current request. Each element in the list consists of the resource type and resource ID. </p>
        pub fn set_resource_keys(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ResourceKey>>,
        ) -> Self {
            self.inner = self.inner.set_resource_keys(input);
            self
        }
    }
    /// Fluent builder constructing a request to `StopConfigurationRecorder`.
    ///
    /// <p>Stops recording configurations of the Amazon Web Services resources you have selected to record in your Amazon Web Services account.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct StopConfigurationRecorder {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::stop_configuration_recorder_input::Builder,
    }
    impl StopConfigurationRecorder {
        /// Creates a new `StopConfigurationRecorder`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::StopConfigurationRecorderOutput,
            aws_smithy_http::result::SdkError<crate::error::StopConfigurationRecorderError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the recorder object that records each configuration change made to the resources.</p>
        pub fn configuration_recorder_name(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_recorder_name(input.into());
            self
        }
        /// <p>The name of the recorder object that records each configuration change made to the resources.</p>
        pub fn set_configuration_recorder_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_recorder_name(input);
            self
        }
    }
    /// Fluent builder constructing a request to `TagResource`.
    ///
    /// <p>Associates the specified tags to a resource with the specified resourceArn. If existing tags on a resource are not specified in the request parameters, they are not changed. When a resource is deleted, the tags associated with that resource are deleted as well.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct TagResource {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::tag_resource_input::Builder,
    }
    impl TagResource {
        /// Creates a new `TagResource`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::TagResourceOutput,
            aws_smithy_http::result::SdkError<crate::error::TagResourceError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The Amazon Resource Name (ARN) that identifies the resource for which to list the tags. Currently, the supported resources are <code>ConfigRule</code>, <code>ConfigurationAggregator</code> and <code>AggregatorAuthorization</code>.</p>
        pub fn resource_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_arn(input.into());
            self
        }
        /// <p>The Amazon Resource Name (ARN) that identifies the resource for which to list the tags. Currently, the supported resources are <code>ConfigRule</code>, <code>ConfigurationAggregator</code> and <code>AggregatorAuthorization</code>.</p>
        pub fn set_resource_arn(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_resource_arn(input);
            self
        }
        /// Appends an item to `Tags`.
        ///
        /// To override the contents of this collection use [`set_tags`](Self::set_tags).
        ///
        /// <p>An array of tag object.</p>
        pub fn tags(mut self, input: crate::model::Tag) -> Self {
            self.inner = self.inner.tags(input);
            self
        }
        /// <p>An array of tag object.</p>
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
    }
    /// Fluent builder constructing a request to `UntagResource`.
    ///
    /// <p>Deletes specified tags from a resource.</p>
    #[derive(std::clone::Clone, std::fmt::Debug)]
    pub struct UntagResource {
        handle: std::sync::Arc<super::Handle>,
        inner: crate::input::untag_resource_input::Builder,
    }
    impl UntagResource {
        /// Creates a new `UntagResource`.
        pub(crate) fn new(handle: std::sync::Arc<super::Handle>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }

        /// Sends the request and returns the response.
        ///
        /// If an error occurs, an `SdkError` will be returned with additional details that
        /// can be matched against.
        ///
        /// By default, any retryable failures will be retried twice. Retry behavior
        /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
        /// set when configuring the client.
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::UntagResourceOutput,
            aws_smithy_http::result::SdkError<crate::error::UntagResourceError>,
        > {
            let op = self
                .inner
                .build()
                .map_err(|err| aws_smithy_http::result::SdkError::ConstructionFailure(err.into()))?
                .make_operation(&self.handle.conf)
                .await
                .map_err(|err| {
                    aws_smithy_http::result::SdkError::ConstructionFailure(err.into())
                })?;
            self.handle.client.call(op).await
        }
        /// <p>The Amazon Resource Name (ARN) that identifies the resource for which to list the tags. Currently, the supported resources are <code>ConfigRule</code>, <code>ConfigurationAggregator</code> and <code>AggregatorAuthorization</code>.</p>
        pub fn resource_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_arn(input.into());
            self
        }
        /// <p>The Amazon Resource Name (ARN) that identifies the resource for which to list the tags. Currently, the supported resources are <code>ConfigRule</code>, <code>ConfigurationAggregator</code> and <code>AggregatorAuthorization</code>.</p>
        pub fn set_resource_arn(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_resource_arn(input);
            self
        }
        /// Appends an item to `TagKeys`.
        ///
        /// To override the contents of this collection use [`set_tag_keys`](Self::set_tag_keys).
        ///
        /// <p>The keys of the tags to be removed.</p>
        pub fn tag_keys(mut self, input: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.tag_keys(input.into());
            self
        }
        /// <p>The keys of the tags to be removed.</p>
        pub fn set_tag_keys(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_tag_keys(input);
            self
        }
    }
}

impl Client {
    /// Creates a client with the given service config and connector override.
    pub fn from_conf_conn<C, E>(conf: crate::Config, conn: C) -> Self
    where
        C: aws_smithy_client::bounds::SmithyConnector<Error = E> + Send + 'static,
        E: Into<aws_smithy_http::result::ConnectorError>,
    {
        let retry_config = conf.retry_config.as_ref().cloned().unwrap_or_default();
        let timeout_config = conf.timeout_config.as_ref().cloned().unwrap_or_default();
        let sleep_impl = conf.sleep_impl.clone();
        let mut builder = aws_smithy_client::Builder::new()
            .connector(aws_smithy_client::erase::DynConnector::new(conn))
            .middleware(aws_smithy_client::erase::DynMiddleware::new(
                crate::middleware::DefaultMiddleware::new(),
            ));
        builder.set_retry_config(retry_config.into());
        builder.set_timeout_config(timeout_config);
        if let Some(sleep_impl) = sleep_impl {
            builder.set_sleep_impl(Some(sleep_impl));
        }
        let client = builder.build();
        Self {
            handle: std::sync::Arc::new(Handle { client, conf }),
        }
    }

    /// Creates a new client from a shared config.
    #[cfg(any(feature = "rustls", feature = "native-tls"))]
    pub fn new(sdk_config: &aws_types::sdk_config::SdkConfig) -> Self {
        Self::from_conf(sdk_config.into())
    }

    /// Creates a new client from the service [`Config`](crate::Config).
    #[cfg(any(feature = "rustls", feature = "native-tls"))]
    pub fn from_conf(conf: crate::Config) -> Self {
        let retry_config = conf.retry_config.as_ref().cloned().unwrap_or_default();
        let timeout_config = conf.timeout_config.as_ref().cloned().unwrap_or_default();
        let sleep_impl = conf.sleep_impl.clone();
        let mut builder = aws_smithy_client::Builder::dyn_https().middleware(
            aws_smithy_client::erase::DynMiddleware::new(
                crate::middleware::DefaultMiddleware::new(),
            ),
        );
        builder.set_retry_config(retry_config.into());
        builder.set_timeout_config(timeout_config);
        // the builder maintains a try-state. To avoid suppressing the warning when sleep is unset,
        // only set it if we actually have a sleep impl.
        if let Some(sleep_impl) = sleep_impl {
            builder.set_sleep_impl(Some(sleep_impl));
        }
        let client = builder.build();

        Self {
            handle: std::sync::Arc::new(Handle { client, conf }),
        }
    }
}
